(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define gerbil/tools/gxensemble::timestamp 1701960165)
  (begin
    (define gerbil/tools/gxensemble#main
      (lambda _args6491_
        (let ()
          (declare (not safe))
          (std/cli/getopt#call-with-getopt__%
           '#f
           '"gxensemble"
           '"the Gerbil Actor Ensemble Manager"
           absent-value
           gerbil/tools/gxensemble#gxensemble-main
           _args6491_
           gerbil/tools/gxensemble#run-cmd
           gerbil/tools/gxensemble#registry-cmd
           gerbil/tools/gxensemble#load-cmd
           gerbil/tools/gxensemble#eval-cmd
           gerbil/tools/gxensemble#repl-cmd
           gerbil/tools/gxensemble#ping-cmd
           gerbil/tools/gxensemble#lookup-cmd
           gerbil/tools/gxensemble#shutdown-cmd
           gerbil/tools/gxensemble#admin-cmd
           gerbil/tools/gxensemble#list-cmd
           gerbil/tools/gxensemble#ca-cmd
           gerbil/tools/gxensemble#package-cmd))))
    (define gerbil/tools/gxensemble#logging-option
      (let ()
        (declare (not safe))
        (std/cli/getopt#option__%__0
         '#f
         '"specifies the log level to run with"
         string->symbol
         'INFO
         'logging
         '"--log")))
    (define gerbil/tools/gxensemble#logging-file-option
      (let ()
        (declare (not safe))
        (std/cli/getopt#option__%__0
         '#f
         '"specifies a log file instead of logging to stderr; if it is - then the log will be written into the ensemble server directory log"
         absent-value
         '#f
         'logging-file
         '"--log-file")))
    (define gerbil/tools/gxensemble#listen-option
      (let ()
        (declare (not safe))
        (std/cli/getopt#option__%__%
         '#f
         '"additional addresses to listen to; by default the server listens at unix /tmp/ensemble/<server-id>"
         gerbil/tools/gxensemble#string->object
         '()
         'listen
         '"-l"
         '"--listen")))
    (define gerbil/tools/gxensemble#announce-option
      (let ()
        (declare (not safe))
        (std/cli/getopt#option__%__%
         '#f
         '"public addresses to announce to the registry; by default these are the listen addresses"
         gerbil/tools/gxensemble#string->object
         '#f
         'announce
         '"-a"
         '"--announce")))
    (define gerbil/tools/gxensemble#console-option
      (let ()
        (declare (not safe))
        (std/cli/getopt#option__%__%
         '#f
         '"console server id"
         string->symbol
         'console
         'console
         '"-c"
         '"--console")))
    (define gerbil/tools/gxensemble#registry-option
      (let ()
        (declare (not safe))
        (std/cli/getopt#option__%__%
         '#f
         '"additional registry addresses; by default the registry is reachable at unix /tmp/ensemble/registry"
         gerbil/tools/gxensemble#string->object
         '#f
         'registry
         '"-r"
         '"--registry")))
    (define gerbil/tools/gxensemble#roles-option
      (let ()
        (declare (not safe))
        (std/cli/getopt#option__%__0
         '#f
         '"server role(s); a list of symbols"
         gerbil/tools/gxensemble#string->object
         '()
         'roles
         '"--roles")))
    (define gerbil/tools/gxensemble#library-prefix-option
      (let ()
        (declare (not safe))
        (std/cli/getopt#option__%__0
         '#f
         '"list of package prefixes to consider as library modules installed in the server"
         gerbil/tools/gxensemble#string->object
         '(gerbil scheme std)
         'library-prefix
         '"--library-prefix")))
    (define gerbil/tools/gxensemble#server-id-argument
      (let ()
        (declare (not safe))
        (std/cli/getopt#argument__%
         '#f
         '"the server id"
         string->symbol
         'server-id)))
    (define gerbil/tools/gxensemble#server-id-optional-argument
      (let ()
        (declare (not safe))
        (std/cli/getopt#optional-argument__%
         '#f
         '"the server id"
         string->symbol
         absent-value
         'server-id)))
    (define gerbil/tools/gxensemble#actor-id-optional-argument
      (let ()
        (declare (not safe))
        (std/cli/getopt#optional-argument__%
         '#f
         '"the actor's registered name"
         string->symbol
         absent-value
         'actor-id)))
    (define gerbil/tools/gxensemble#module-id-argument
      (let ()
        (declare (not safe))
        (std/cli/getopt#argument__%
         '#f
         '"the module id"
         string->symbol
         'module-id)))
    (define gerbil/tools/gxensemble#server-id-or-role-argument
      (let ()
        (declare (not safe))
        (std/cli/getopt#argument__%
         '#f
         '"the server or role to lookup"
         string->symbol
         'server-or-role)))
    (define gerbil/tools/gxensemble#authorized-server-id-argument
      (let ()
        (declare (not safe))
        (std/cli/getopt#argument__%
         '#f
         '"the server to authorize capabilities for"
         string->symbol
         'authorized-server-id)))
    (define gerbil/tools/gxensemble#capabilities-optional-argument
      (let ()
        (declare (not safe))
        (std/cli/getopt#optional-argument__%
         '#f
         '"the server capabilities to authorize"
         gerbil/tools/gxensemble#string->object
         '()
         'capabilities)))
    (define gerbil/tools/gxensemble#expr-argument
      (let ()
        (declare (not safe))
        (std/cli/getopt#argument__%
         '#f
         '"the expression to eval"
         gerbil/tools/gxensemble#string->object
         'expr)))
    (define gerbil/tools/gxensemble#main-arguments
      (let ()
        (declare (not safe))
        (std/cli/getopt#rest-arguments__%
         '#f
         '"arguments for the module's main procedure"
         absent-value
         'main-args)))
    (define gerbil/tools/gxensemble#library-flag
      (let ()
        (declare (not safe))
        (std/cli/getopt#flag__%__0
         '#f
         '"loads the code as library module; the library must be in the servers load path"
         'library
         '"--library")))
    (define gerbil/tools/gxensemble#role-flag
      (let ()
        (declare (not safe))
        (std/cli/getopt#flag__%__0 '#f '"lookup by role" 'role '"--role")))
    (define gerbil/tools/gxensemble#force-flag
      (let ()
        (declare (not safe))
        (std/cli/getopt#flag__%__%
         '#f
         '"force the action"
         'force
         '"-f"
         '"--force")))
    (define gerbil/tools/gxensemble#view-flag
      (let ()
        (declare (not safe))
        (std/cli/getopt#flag__%__0
         '#f
         '"inspect existing, don't generate"
         'view
         '"--view")))
    (define gerbil/tools/gxensemble#subcommand
      (lambda (_help6489_)
        (let ()
          (declare (not safe))
          (std/cli/getopt#argument__%
           '#f
           _help6489_
           string->symbol
           'subcommand))))
    (define gerbil/tools/gxensemble#subcommand-list
      (let ()
        (declare (not safe))
        (gerbil/tools/gxensemble#subcommand
         '"what to do: servers|actors|connections")))
    (define gerbil/tools/gxensemble#subcommand-admin
      (let ()
        (declare (not safe))
        (gerbil/tools/gxensemble#subcommand
         '"what to do: cookie|creds|authorize|retract")))
    (define gerbil/tools/gxensemble#subcommand-ca
      (let ()
        (declare (not safe))
        (gerbil/tools/gxensemble#subcommand '"what to do: setup|cert")))
    (define gerbil/tools/gxensemble#subcommand-arguments
      (let ()
        (declare (not safe))
        (std/cli/getopt#rest-arguments__%
         '#f
         '"arguments for the subcommand"
         absent-value
         'subcommand-args)))
    (define gerbil/tools/gxensemble#run-cmd
      (let ()
        (declare (not safe))
        (std/cli/getopt#command__%
         '#f
         '"run a server in the ensemble"
         'run
         gerbil/tools/gxensemble#logging-option
         gerbil/tools/gxensemble#logging-file-option
         gerbil/tools/gxensemble#listen-option
         gerbil/tools/gxensemble#announce-option
         gerbil/tools/gxensemble#registry-option
         gerbil/tools/gxensemble#roles-option
         gerbil/tools/gxensemble#server-id-argument
         gerbil/tools/gxensemble#module-id-argument
         gerbil/tools/gxensemble#main-arguments)))
    (define gerbil/tools/gxensemble#registry-cmd
      (let ()
        (declare (not safe))
        (std/cli/getopt#command__%
         '#f
         '"runs the ensemble registry"
         'registry
         gerbil/tools/gxensemble#logging-option
         gerbil/tools/gxensemble#logging-file-option
         gerbil/tools/gxensemble#listen-option
         gerbil/tools/gxensemble#announce-option)))
    (define gerbil/tools/gxensemble#load-cmd
      (let ()
        (declare (not safe))
        (std/cli/getopt#command__%
         '#f
         '"loads code in a running server"
         'load
         gerbil/tools/gxensemble#console-option
         gerbil/tools/gxensemble#force-flag
         gerbil/tools/gxensemble#library-flag
         gerbil/tools/gxensemble#registry-option
         gerbil/tools/gxensemble#library-prefix-option
         gerbil/tools/gxensemble#server-id-argument
         gerbil/tools/gxensemble#module-id-argument)))
    (define gerbil/tools/gxensemble#eval-cmd
      (let ()
        (declare (not safe))
        (std/cli/getopt#command__%
         '#f
         '"evals code in a running server"
         'eval
         gerbil/tools/gxensemble#console-option
         gerbil/tools/gxensemble#registry-option
         gerbil/tools/gxensemble#server-id-argument
         gerbil/tools/gxensemble#expr-argument)))
    (define gerbil/tools/gxensemble#repl-cmd
      (let ()
        (declare (not safe))
        (std/cli/getopt#command__%
         '#f
         '"provides a repl for a running server"
         'repl
         gerbil/tools/gxensemble#console-option
         gerbil/tools/gxensemble#registry-option
         gerbil/tools/gxensemble#library-prefix-option
         gerbil/tools/gxensemble#server-id-argument)))
    (define gerbil/tools/gxensemble#ping-cmd
      (let ()
        (declare (not safe))
        (std/cli/getopt#command__%
         '#f
         '"pings a server or actor in the server"
         'ping
         gerbil/tools/gxensemble#console-option
         gerbil/tools/gxensemble#registry-option
         gerbil/tools/gxensemble#server-id-argument
         gerbil/tools/gxensemble#actor-id-optional-argument)))
    (define gerbil/tools/gxensemble#shutdown-cmd
      (let ()
        (declare (not safe))
        (std/cli/getopt#command__%
         '#f
         '"shuts down an actor, server, or the entire ensemble including the registry"
         'shutdown
         gerbil/tools/gxensemble#console-option
         gerbil/tools/gxensemble#force-flag
         gerbil/tools/gxensemble#registry-option
         gerbil/tools/gxensemble#server-id-optional-argument
         gerbil/tools/gxensemble#actor-id-optional-argument)))
    (define gerbil/tools/gxensemble#lookup-cmd
      (let ()
        (declare (not safe))
        (std/cli/getopt#command__%
         '#f
         '"looks up a server by id or role"
         'lookup
         gerbil/tools/gxensemble#console-option
         gerbil/tools/gxensemble#registry-option
         gerbil/tools/gxensemble#role-flag
         gerbil/tools/gxensemble#server-id-or-role-argument)))
    (define gerbil/tools/gxensemble#list-cmd
      (let ()
        (declare (not safe))
        (std/cli/getopt#command__%
         '#f
         '"list server state"
         'list
         gerbil/tools/gxensemble#subcommand-list
         gerbil/tools/gxensemble#subcommand-arguments)))
    (define gerbil/tools/gxensemble#admin-cmd
      (let ()
        (declare (not safe))
        (std/cli/getopt#command__%
         '#f
         '"ensemble administrative operations"
         'admin
         gerbil/tools/gxensemble#subcommand-admin
         gerbil/tools/gxensemble#subcommand-arguments)))
    (define gerbil/tools/gxensemble#ca-cmd
      (let ()
        (declare (not safe))
        (std/cli/getopt#command__%
         '#f
         '"ensemble CA operations"
         'ca
         gerbil/tools/gxensemble#subcommand-ca
         gerbil/tools/gxensemble#subcommand-arguments)))
    (define gerbil/tools/gxensemble#list-servers-cmd
      (let ()
        (declare (not safe))
        (std/cli/getopt#command__%
         '#f
         '"lists known servers"
         'servers
         gerbil/tools/gxensemble#console-option
         gerbil/tools/gxensemble#registry-option)))
    (define gerbil/tools/gxensemble#list-actors-cmd
      (let ()
        (declare (not safe))
        (std/cli/getopt#command__%
         '#f
         '"list actors registered in a server"
         'actors
         gerbil/tools/gxensemble#console-option
         gerbil/tools/gxensemble#registry-option
         gerbil/tools/gxensemble#server-id-argument)))
    (define gerbil/tools/gxensemble#list-connections-cmd
      (let ()
        (declare (not safe))
        (std/cli/getopt#command__%
         '#f
         '"list a server's connections"
         'connections
         gerbil/tools/gxensemble#console-option
         gerbil/tools/gxensemble#registry-option
         gerbil/tools/gxensemble#server-id-argument)))
    (define gerbil/tools/gxensemble#admin-authorize-cmd
      (let ()
        (declare (not safe))
        (std/cli/getopt#command__%
         '#f
         '"authorize capabilities for a server as an administrator"
         'authorize
         gerbil/tools/gxensemble#console-option
         gerbil/tools/gxensemble#registry-option
         gerbil/tools/gxensemble#server-id-argument
         gerbil/tools/gxensemble#authorized-server-id-argument
         gerbil/tools/gxensemble#capabilities-optional-argument)))
    (define gerbil/tools/gxensemble#admin-retract-cmd
      (let ()
        (declare (not safe))
        (std/cli/getopt#command__%
         '#f
         '"retract all capabilities granted to a server by an administrator"
         'retract
         gerbil/tools/gxensemble#console-option
         gerbil/tools/gxensemble#registry-option
         gerbil/tools/gxensemble#server-id-argument
         gerbil/tools/gxensemble#authorized-server-id-argument)))
    (define gerbil/tools/gxensemble#admin-cookie-cmd
      (let ()
        (declare (not safe))
        (std/cli/getopt#command__%
         '#f
         '"generate or inspect the ensemble cookie"
         'cookie
         gerbil/tools/gxensemble#force-flag
         gerbil/tools/gxensemble#view-flag)))
    (define gerbil/tools/gxensemble#admin-creds-cmd
      (let ()
        (declare (not safe))
        (std/cli/getopt#command__%
         '#f
         '"generate or inspect ensemble administrator credentials"
         'creds
         gerbil/tools/gxensemble#force-flag
         gerbil/tools/gxensemble#view-flag)))
    (define gerbil/tools/gxensemble#ca-domain-option
      (let ()
        (declare (not safe))
        (std/cli/getopt#option__%__0
         '#f
         '"ensemble TLS domain"
         absent-value
         '"ensemble.local"
         'domain
         '"--domain")))
    (define gerbil/tools/gxensemble#ca-subject/C-option
      (let ()
        (declare (not safe))
        (std/cli/getopt#option__%__0
         '#f
         '"ensemble TLS CA Country"
         absent-value
         '"UN"
         'subject/C
         '"--subject/C")))
    (define gerbil/tools/gxensemble#ca-subject/O-option
      (let ()
        (declare (not safe))
        (std/cli/getopt#option__%__0
         '#f
         '"ensemble TLS CA Organization"
         absent-value
         '"Mighty Gerbils"
         'subject/O
         '"--subject/O")))
    (define gerbil/tools/gxensemble#ca-subject/L-option
      (let ()
        (declare (not safe))
        (std/cli/getopt#option__%__0
         '#f
         '"ensemble TLS certificate location"
         absent-value
         '"Internet"
         'subject/L
         '"--subject/L")))
    (define gerbil/tools/gxensemble#ca-setup-cmd
      (let ()
        (declare (not safe))
        (std/cli/getopt#command__%
         '#f
         '"setup or inspect the ensemble CAs"
         'setup
         gerbil/tools/gxensemble#view-flag
         gerbil/tools/gxensemble#ca-domain-option
         gerbil/tools/gxensemble#ca-subject/C-option
         gerbil/tools/gxensemble#ca-subject/O-option
         gerbil/tools/gxensemble#ca-subject/L-option)))
    (define gerbil/tools/gxensemble#ca-cert-cmd
      (let ()
        (declare (not safe))
        (std/cli/getopt#command__%
         '#f
         '"generate or inspect an actor server certificate"
         'cert
         gerbil/tools/gxensemble#force-flag
         gerbil/tools/gxensemble#view-flag
         gerbil/tools/gxensemble#ca-subject/C-option
         gerbil/tools/gxensemble#ca-subject/O-option
         gerbil/tools/gxensemble#ca-subject/L-option
         gerbil/tools/gxensemble#server-id-argument
         gerbil/tools/gxensemble#capabilities-optional-argument)))
    (define gerbil/tools/gxensemble#package-output-option
      (let ()
        (declare (not safe))
        (std/cli/getopt#option__%__%
         '#f
         '"output file for the server package"
         absent-value
         '"ensemble.tar.gz"
         'output
         '"-o"
         '"--output")))
    (define gerbil/tools/gxensemble#package-cmd
      (let ()
        (declare (not safe))
        (std/cli/getopt#command__%
         '#f
         '"package ensemble state to ship an actor server environment"
         'package
         gerbil/tools/gxensemble#package-output-option
         gerbil/tools/gxensemble#server-id-argument)))
    (define gerbil/tools/gxensemble#main-commands
      (make-promise
       (lambda ()
         (let ((_ht6486_
                (let () (declare (not safe)) (make-table 'size: '12))))
           (let ()
             (declare (not safe))
             (table-set! _ht6486_ 'run gerbil/tools/gxensemble#do-run))
           (let ()
             (declare (not safe))
             (table-set!
              _ht6486_
              'registry
              gerbil/tools/gxensemble#do-registry))
           (let ()
             (declare (not safe))
             (table-set! _ht6486_ 'load gerbil/tools/gxensemble#do-load))
           (let ()
             (declare (not safe))
             (table-set! _ht6486_ 'eval gerbil/tools/gxensemble#do-eval))
           (let ()
             (declare (not safe))
             (table-set! _ht6486_ 'repl gerbil/tools/gxensemble#do-repl))
           (let ()
             (declare (not safe))
             (table-set! _ht6486_ 'ping gerbil/tools/gxensemble#do-ping))
           (let ()
             (declare (not safe))
             (table-set! _ht6486_ 'lookup gerbil/tools/gxensemble#do-lookup))
           (let ()
             (declare (not safe))
             (table-set! _ht6486_ 'list gerbil/tools/gxensemble#do-list))
           (let ()
             (declare (not safe))
             (table-set!
              _ht6486_
              'shutdown
              gerbil/tools/gxensemble#do-shutdown))
           (let ()
             (declare (not safe))
             (table-set! _ht6486_ 'admin gerbil/tools/gxensemble#do-admin))
           (let ()
             (declare (not safe))
             (table-set! _ht6486_ 'ca gerbil/tools/gxensemble#do-ca))
           (let ()
             (declare (not safe))
             (table-set! _ht6486_ 'package gerbil/tools/gxensemble#do-package))
           _ht6486_))))
    (define gerbil/tools/gxensemble#list-commands
      (make-promise
       (lambda ()
         (let ((_ht6482_ (let () (declare (not safe)) (make-table 'size: '3))))
           (let ()
             (declare (not safe))
             (table-set!
              _ht6482_
              'servers
              gerbil/tools/gxensemble#do-list-servers))
           (let ()
             (declare (not safe))
             (table-set!
              _ht6482_
              'actors
              gerbil/tools/gxensemble#do-list-actors))
           (let ()
             (declare (not safe))
             (table-set!
              _ht6482_
              'connections
              gerbil/tools/gxensemble#do-list-connections))
           _ht6482_))))
    (define gerbil/tools/gxensemble#admin-commands
      (make-promise
       (lambda ()
         (let ((_ht6478_ (let () (declare (not safe)) (make-table 'size: '4))))
           (let ()
             (declare (not safe))
             (table-set!
              _ht6478_
              'authorize
              gerbil/tools/gxensemble#do-admin-authorize))
           (let ()
             (declare (not safe))
             (table-set!
              _ht6478_
              'retract
              gerbil/tools/gxensemble#do-admin-retract))
           (let ()
             (declare (not safe))
             (table-set!
              _ht6478_
              'cookie
              gerbil/tools/gxensemble#do-admin-cookie))
           (let ()
             (declare (not safe))
             (table-set!
              _ht6478_
              'creds
              gerbil/tools/gxensemble#do-admin-creds))
           _ht6478_))))
    (define gerbil/tools/gxensemble#ca-commands
      (make-promise
       (lambda ()
         (let ((_ht6474_ (let () (declare (not safe)) (make-table 'size: '2))))
           (let ()
             (declare (not safe))
             (table-set! _ht6474_ 'setup gerbil/tools/gxensemble#do-ca-setup))
           (let ()
             (declare (not safe))
             (table-set! _ht6474_ 'cert gerbil/tools/gxensemble#do-ca-cert))
           _ht6474_))))
    (define gerbil/tools/gxensemble#gxensemble-main
      (lambda (_cmd6460_ _opt6461_)
        (let* ((_table6463_ (force gerbil/tools/gxensemble#main-commands))
               (_$e6466_
                (let ()
                  (declare (not safe))
                  (table-ref _table6463_ _cmd6460_ '#f))))
          (if _$e6466_
              ((lambda (_g64686470_) (_g64686470_ _opt6461_)) _$e6466_)
              (let ((__tmp16677
                     (let () (declare (not safe)) (hash-keys _table6463_))))
                (declare (not safe))
                (error '"Unexpected command" _cmd6460_ __tmp16677))))))
    (define gerbil/tools/gxensemble#do-admin
      (lambda (_opt6434_)
        (let* ((_cmd6437_
                (let ()
                  (declare (not safe))
                  (table-ref _opt6434_ 'subcommand)))
               (_cmd-args6440_
                (let ((__tmp16679 (symbol->string _cmd6437_))
                      (__tmp16678
                       (let ()
                         (declare (not safe))
                         (table-ref _opt6434_ 'subcommand-args))))
                  (declare (not safe))
                  (cons __tmp16679 __tmp16678)))
               (_cmd-main6456_
                (lambda (_cmd6443_ _opt6444_)
                  (let* ((_table6446_
                          (force gerbil/tools/gxensemble#admin-commands))
                         (_$e6449_
                          (let ()
                            (declare (not safe))
                            (table-ref _table6446_ _cmd6443_ '#f))))
                    (if _$e6449_
                        ((lambda (_g64516453_) (_g64516453_ _opt6444_))
                         _$e6449_)
                        (let ((__tmp16680
                               (let ()
                                 (declare (not safe))
                                 (hash-keys _table6446_))))
                          (declare (not safe))
                          (error '"Unexpected command"
                                 _cmd6443_
                                 __tmp16680)))))))
          (let ()
            (declare (not safe))
            (std/cli/getopt#call-with-getopt__%
             '#f
             '"gxensemble admin"
             absent-value
             absent-value
             _cmd-main6456_
             _cmd-args6440_
             gerbil/tools/gxensemble#admin-cookie-cmd
             gerbil/tools/gxensemble#admin-creds-cmd
             gerbil/tools/gxensemble#admin-authorize-cmd
             gerbil/tools/gxensemble#admin-retract-cmd)))))
    (define gerbil/tools/gxensemble#do-admin-cookie
      (lambda (_opt6430_)
        (if (let () (declare (not safe)) (table-ref _opt6430_ 'view '#f))
            (let* ((_cookie6432_
                    (let ()
                      (declare (not safe))
                      (std/actor-v18/cookie#get-actor-server-cookie__0)))
                   (__tmp16682
                    (let ()
                      (declare (not safe))
                      (std/text/hex#hex-encode__0 _cookie6432_))))
              (declare (not safe))
              (displayln __tmp16682))
            (let ((__tmp16681
                   (let ()
                     (declare (not safe))
                     (table-ref _opt6430_ 'force '#f))))
              (declare (not safe))
              (std/actor-v18/cookie#generate-actor-server-cookie!__%__0
               '#f
               __tmp16681)))))
    (define gerbil/tools/gxensemble#do-admin-creds
      (lambda (_opt6418_)
        (if (let () (declare (not safe)) (table-ref _opt6418_ 'view '#f))
            (let* ((_pubk-path6420_
                    (let ()
                      (declare (not safe))
                      (std/actor-v18/admin#default-admin-pubkey-path)))
                   (_pubk-raw6422_
                    (let ()
                      (declare (not safe))
                      (std/misc/ports#read-file-u8vector__%
                       '#f
                       absent-value
                       _pubk-path6420_))))
              (let ((__tmp16684
                     (let ()
                       (declare (not safe))
                       (std/text/hex#hex-encode__0 _pubk-raw6422_))))
                (declare (not safe))
                (displayln __tmp16684)))
            (let* ((_passphrase6425_
                    (let ()
                      (declare (not safe))
                      (std/misc/ports#read-password__%__0
                       '#f
                       '"Enter passphrase: ")))
                   (_again6427_
                    (let ()
                      (declare (not safe))
                      (std/misc/ports#read-password__%__0
                       '#f
                       '"Re-enter passphrase: "))))
              (if (let ()
                    (declare (not safe))
                    (equal? _passphrase6425_ _again6427_))
                  '#!void
                  (let ()
                    (declare (not safe))
                    (error '"administrative passphrases don't match")))
              (let ((__tmp16683
                     (let ()
                       (declare (not safe))
                       (table-ref _opt6418_ 'force '#f))))
                (declare (not safe))
                (std/actor-v18/admin#generate-admin-keypair!__%__0
                 '#f
                 __tmp16683
                 _passphrase6425_))))))
    (define gerbil/tools/gxensemble#do-admin-authorize
      (lambda (_opt6412_)
        (let ()
          (declare (not safe))
          (gerbil/tools/gxensemble#start-actor-server-with-options! _opt6412_))
        (let ((_server-id6414_
               (let () (declare (not safe)) (table-ref _opt6412_ 'server-id)))
              (_authorized-server-id6415_
               (let ()
                 (declare (not safe))
                 (table-ref _opt6412_ 'authorized-server-id)))
              (_capabilities6416_
               (let ()
                 (declare (not safe))
                 (table-ref _opt6412_ 'capabilities))))
          (let ((__tmp16685
                 (let ()
                   (declare (not safe))
                   (gerbil/tools/gxensemble#get-privkey))))
            (declare (not safe))
            (std/actor-v18/ensemble#admin-authorize__%__0
             '#f
             _capabilities6416_
             __tmp16685
             _server-id6414_
             _authorized-server-id6415_)))))
    (define gerbil/tools/gxensemble#do-admin-retract
      (lambda (_opt6407_)
        (let ()
          (declare (not safe))
          (gerbil/tools/gxensemble#start-actor-server-with-options! _opt6407_))
        (let ((_server-id6409_
               (let () (declare (not safe)) (table-ref _opt6407_ 'server-id)))
              (_authorized-server-id6410_
               (let ()
                 (declare (not safe))
                 (table-ref _opt6407_ 'authorized-server-id))))
          (let ()
            (declare (not safe))
            (gerbil/tools/gxensemble#maybe-authorize! _server-id6409_))
          (let ()
            (declare (not safe))
            (std/actor-v18/ensemble#admin-retract__0
             _server-id6409_
             _authorized-server-id6410_)))))
    (define gerbil/tools/gxensemble#do-lookup
      (lambda (_opt6403_)
        (let ()
          (declare (not safe))
          (gerbil/tools/gxensemble#start-actor-server-with-options! _opt6403_))
        (let* ((_what6405_
                (let ()
                  (declare (not safe))
                  (table-ref _opt6403_ 'server-or-role)))
               (__tmp16686
                (if (let ()
                      (declare (not safe))
                      (table-ref _opt6403_ 'role '#f))
                    (let ()
                      (declare (not safe))
                      (std/actor-v18/ensemble#ensemble-lookup-servers/role__0
                       _what6405_))
                    (let ()
                      (declare (not safe))
                      (std/actor-v18/ensemble#ensemble-lookup-server__0
                       _what6405_)))))
          (declare (not safe))
          (gerbil/tools/gxensemble#display-result-list __tmp16686))
        (let ()
          (declare (not safe))
          (std/actor-v18/server#stop-actor-server!__0))))
    (define gerbil/tools/gxensemble#do-list
      (lambda (_opt6377_)
        (let* ((_cmd6380_
                (let ()
                  (declare (not safe))
                  (table-ref _opt6377_ 'subcommand)))
               (_cmd-args6383_
                (let ((__tmp16688 (symbol->string _cmd6380_))
                      (__tmp16687
                       (let ()
                         (declare (not safe))
                         (table-ref _opt6377_ 'subcommand-args))))
                  (declare (not safe))
                  (cons __tmp16688 __tmp16687)))
               (_cmd-main6399_
                (lambda (_cmd6386_ _opt6387_)
                  (let* ((_table6389_
                          (force gerbil/tools/gxensemble#list-commands))
                         (_$e6392_
                          (let ()
                            (declare (not safe))
                            (table-ref _table6389_ _cmd6386_ '#f))))
                    (if _$e6392_
                        ((lambda (_g63946396_) (_g63946396_ _opt6387_))
                         _$e6392_)
                        (let ((__tmp16689
                               (let ()
                                 (declare (not safe))
                                 (hash-keys _table6389_))))
                          (declare (not safe))
                          (error '"Unexpected command"
                                 _cmd6386_
                                 __tmp16689)))))))
          (let ()
            (declare (not safe))
            (std/cli/getopt#call-with-getopt__%
             '#f
             '"gxensemble list"
             absent-value
             absent-value
             _cmd-main6399_
             _cmd-args6383_
             gerbil/tools/gxensemble#list-servers-cmd
             gerbil/tools/gxensemble#list-actors-cmd
             gerbil/tools/gxensemble#list-connections-cmd)))))
    (define gerbil/tools/gxensemble#do-list-connections
      (lambda (_opt6375_)
        (let ()
          (declare (not safe))
          (gerbil/tools/gxensemble#start-actor-server-with-options! _opt6375_))
        (let ((__tmp16690
               (let ((__tmp16691
                      (let ()
                        (declare (not safe))
                        (table-ref _opt6375_ 'server-id))))
                 (declare (not safe))
                 (std/actor-v18/ensemble#remote-list-connections__0
                  __tmp16691))))
          (declare (not safe))
          (gerbil/tools/gxensemble#display-result-list __tmp16690))
        (let ()
          (declare (not safe))
          (std/actor-v18/server#stop-actor-server!__0))))
    (define gerbil/tools/gxensemble#do-list-actors
      (lambda (_opt6373_)
        (let ()
          (declare (not safe))
          (gerbil/tools/gxensemble#start-actor-server-with-options! _opt6373_))
        (let ((__tmp16692
               (map std/actor-v18/server#reference-id
                    (let ((__tmp16693
                           (let ()
                             (declare (not safe))
                             (table-ref _opt6373_ 'server-id))))
                      (declare (not safe))
                      (std/actor-v18/ensemble#remote-list-actors__0
                       __tmp16693)))))
          (declare (not safe))
          (gerbil/tools/gxensemble#display-result-list __tmp16692))
        (let ()
          (declare (not safe))
          (std/actor-v18/server#stop-actor-server!__0))))
    (define gerbil/tools/gxensemble#do-list-servers
      (lambda (_opt6371_)
        (let ()
          (declare (not safe))
          (gerbil/tools/gxensemble#start-actor-server-with-options! _opt6371_))
        (let ((__tmp16694
               (let ()
                 (declare (not safe))
                 (std/actor-v18/ensemble#ensemble-list-servers__0))))
          (declare (not safe))
          (gerbil/tools/gxensemble#display-result-list __tmp16694))
        (let ()
          (declare (not safe))
          (std/actor-v18/server#stop-actor-server!__0))))
    (define gerbil/tools/gxensemble#do-ca
      (lambda (_opt6345_)
        (let* ((_cmd6348_
                (let ()
                  (declare (not safe))
                  (table-ref _opt6345_ 'subcommand)))
               (_cmd-args6351_
                (let ((__tmp16696 (symbol->string _cmd6348_))
                      (__tmp16695
                       (let ()
                         (declare (not safe))
                         (table-ref _opt6345_ 'subcommand-args))))
                  (declare (not safe))
                  (cons __tmp16696 __tmp16695)))
               (_cmd-main6367_
                (lambda (_cmd6354_ _opt6355_)
                  (let* ((_table6357_
                          (force gerbil/tools/gxensemble#ca-commands))
                         (_$e6360_
                          (let ()
                            (declare (not safe))
                            (table-ref _table6357_ _cmd6354_ '#f))))
                    (if _$e6360_
                        ((lambda (_g63626364_) (_g63626364_ _opt6355_))
                         _$e6360_)
                        (let ((__tmp16697
                               (let ()
                                 (declare (not safe))
                                 (hash-keys _table6357_))))
                          (declare (not safe))
                          (error '"Unexpected command"
                                 _cmd6354_
                                 __tmp16697)))))))
          (let ()
            (declare (not safe))
            (std/cli/getopt#call-with-getopt__%
             '#f
             '"gxensemble ca"
             absent-value
             absent-value
             _cmd-main6367_
             _cmd-args6351_
             gerbil/tools/gxensemble#ca-setup-cmd
             gerbil/tools/gxensemble#ca-cert-cmd)))))
    (define gerbil/tools/gxensemble#do-ca-setup
      (lambda (_opt6279_)
        (if (let () (declare (not safe)) (table-ref _opt6279_ 'view '#f))
            (let* ((_base-path6281_
                    (let ()
                      (declare (not safe))
                      (std/actor-v18/tls#ensemble-tls-base-path)))
                   (_ca-certificates6283_
                    (path-expand '"ca-certificates" _base-path6281_)))
              (let ((_iterable6309_ '("root-ca" "sub-ca"))
                    (_iter-do6311_
                     (lambda (_val6286_)
                       (let* ((_val62886293_ _val6286_)
                              (_E62906297_
                               (lambda ()
                                 (let ()
                                   (declare (not safe))
                                   (error '"No clause matching"
                                          _val62886293_))))
                              (_K62916304_
                               (lambda (_subject6300_)
                                 (let* ((_cert6302_
                                         (path-expand
                                          (string-append _subject6300_ '".crt")
                                          _ca-certificates6283_))
                                        (__tmp16706
                                         (let ((__tmp16707
                                                (let ((__tmp16708
                                                       (let ()
                                                         (declare (not safe))
                                                         (cons _cert6302_
                                                               '()))))
                                                  (declare (not safe))
                                                  (cons '"-in" __tmp16708))))
                                           (declare (not safe))
                                           (cons '"-text" __tmp16707))))
                                   (declare (not safe))
                                   (std/misc/process#invoke__%
                                    '#f
                                    absent-value
                                    absent-value
                                    absent-value
                                    absent-value
                                    absent-value
                                    absent-value
                                    absent-value
                                    absent-value
                                    '"openssl"
                                    __tmp16706))))
                              (_subject6307_ _val62886293_))
                         (declare (not safe))
                         (_K62916304_ _subject6307_)))))
                (if (let () (declare (not safe)) (pair? _iterable6309_))
                    (for-each _iter-do6311_ _iterable6309_)
                    (if (let () (declare (not safe)) (null? _iterable6309_))
                        '#!void
                        (let* ((_it6314_
                                (let ()
                                  (declare (not safe))
                                  (std/iter#iter _iterable6309_)))
                               (_next!6317_
                                (let ()
                                  (declare (not safe))
                                  (##unchecked-structure-ref
                                   _it6314_
                                   '2
                                   std/iter#iterator::t
                                   '#f))))
                          (declare (not safe))
                          (begin
                            (let _lp6322_ ()
                              (let ((_val6326_ (_next!6317_ _it6314_)))
                                (if (eq? std/iter#iter-end _val6326_)
                                    '#!void
                                    (begin
                                      (_iter-do6311_ _val6326_)
                                      (_lp6322_)))))
                            (let ((_$e6328_
                                   (##unchecked-structure-ref
                                    _it6314_
                                    '3
                                    std/iter#iterator::t
                                    '#f)))
                              (if _$e6328_
                                  ((lambda (_g63306332_)
                                     (_g63306332_ _it6314_))
                                   _$e6328_)
                                  '#!void))
                            '#!void))))))
            (if (file-exists?
                 (path-expand
                  '"caroot.pem"
                  (let ()
                    (declare (not safe))
                    (std/actor-v18/tls#ensemble-tls-base-path))))
                (let ()
                  (declare (not safe))
                  (displayln '"caroot.pem already exists"))
                (let* ((_root-passphrase6335_
                        (let ()
                          (declare (not safe))
                          (std/misc/ports#read-password__%__0
                           '#f
                           '"Enter root CA passphrase: ")))
                       (_again6337_
                        (let ()
                          (declare (not safe))
                          (std/misc/ports#read-password__%__0
                           '#f
                           '"Re-enter passphrase: "))))
                  (if (let ()
                        (declare (not safe))
                        (equal? _root-passphrase6335_ _again6337_))
                      '#!void
                      (let ()
                        (declare (not safe))
                        (error '"root CA passphrases don't match")))
                  (let ((__tmp16700
                         (let ()
                           (declare (not safe))
                           (table-ref _opt6279_ 'domain)))
                        (__tmp16699
                         (let ()
                           (declare (not safe))
                           (table-ref _opt6279_ 'subject/C)))
                        (__tmp16698
                         (let ()
                           (declare (not safe))
                           (table-ref _opt6279_ 'subject/O))))
                    (declare (not safe))
                    (std/actor-v18/tls#generate-actor-tls-root-ca!__%
                     '#f
                     __tmp16700
                     __tmp16699
                     __tmp16698
                     absent-value
                     _root-passphrase6335_))
                  (let* ((_sub-passphrase6340_
                          (let ()
                            (declare (not safe))
                            (std/misc/ports#read-password__%__0
                             '#f
                             '"Enter subordinate CA passphrase: ")))
                         (_again6342_
                          (let ()
                            (declare (not safe))
                            (std/misc/ports#read-password__%__0
                             '#f
                             '"Re-enter passphrase: "))))
                    (if (let ()
                          (declare (not safe))
                          (equal? _sub-passphrase6340_ _again6342_))
                        '#!void
                        (let ()
                          (declare (not safe))
                          (error '"subordinate CA passphrases don't match")))
                    (let ((__tmp16702
                           (let ()
                             (declare (not safe))
                             (table-ref _opt6279_ 'subject/C)))
                          (__tmp16701
                           (let ()
                             (declare (not safe))
                             (table-ref _opt6279_ 'subject/O))))
                      (declare (not safe))
                      (std/actor-v18/tls#generate-actor-tls-sub-ca!__%
                       '#f
                       __tmp16702
                       __tmp16701
                       absent-value
                       _root-passphrase6335_
                       _sub-passphrase6340_))
                    (let ()
                      (declare (not safe))
                      (std/actor-v18/tls#generate-actor-tls-cafiles!__%
                       '#f
                       absent-value))
                    (let ((__tmp16705
                           (let ()
                             (declare (not safe))
                             (table-ref _opt6279_ 'subject/C)))
                          (__tmp16704
                           (let ()
                             (declare (not safe))
                             (table-ref _opt6279_ 'subject/O)))
                          (__tmp16703
                           (let ()
                             (declare (not safe))
                             (table-ref _opt6279_ 'subject/L))))
                      (declare (not safe))
                      (std/actor-v18/tls#generate-actor-tls-cert!__%
                       '#f
                       'console
                       '(admin)
                       __tmp16705
                       __tmp16704
                       __tmp16703
                       _sub-passphrase6340_))))))))
    (define gerbil/tools/gxensemble#do-ca-cert
      (lambda (_opt6268_)
        (let* ((_server-id6270_
                (let () (declare (not safe)) (table-ref _opt6268_ 'server-id)))
               (_base-path6272_
                (let ()
                  (declare (not safe))
                  (std/actor-v18/tls#ensemble-tls-server-path
                   _server-id6270_))))
          (if (let () (declare (not safe)) (table-ref _opt6268_ 'view '#f))
              (let* ((_cert6275_ (path-expand '"server.crt" _base-path6272_))
                     (__tmp16714
                      (let ((__tmp16715
                             (let ((__tmp16716
                                    (let ()
                                      (declare (not safe))
                                      (cons _cert6275_ '()))))
                               (declare (not safe))
                               (cons '"-in" __tmp16716))))
                        (declare (not safe))
                        (cons '"-text" __tmp16715))))
                (declare (not safe))
                (std/misc/process#invoke__%
                 '#f
                 absent-value
                 absent-value
                 absent-value
                 absent-value
                 absent-value
                 absent-value
                 absent-value
                 absent-value
                 '"openssl"
                 __tmp16714))
              (if (and (let ((__tmp16713
                              (let ()
                                (declare (not safe))
                                (table-ref _opt6268_ 'force '#f))))
                         (declare (not safe))
                         (not __tmp16713))
                       (file-exists?
                        (path-expand '"server.crt" _base-path6272_)))
                  (let ()
                    (declare (not safe))
                    (displayln
                     '"server.crt already exists; use --force to force certificate generation"))
                  (let ((_sub-passphrase6277_
                         (let ()
                           (declare (not safe))
                           (std/misc/ports#read-password__%__0
                            '#f
                            '"Enter subordinate CA passphprase: "))))
                    (let ((__tmp16712
                           (let ()
                             (declare (not safe))
                             (table-ref _opt6268_ 'capabilities)))
                          (__tmp16711
                           (let ()
                             (declare (not safe))
                             (table-ref _opt6268_ 'subject/C)))
                          (__tmp16710
                           (let ()
                             (declare (not safe))
                             (table-ref _opt6268_ 'subject/O)))
                          (__tmp16709
                           (let ()
                             (declare (not safe))
                             (table-ref _opt6268_ 'subject/L))))
                      (declare (not safe))
                      (std/actor-v18/tls#generate-actor-tls-cert!__%
                       '#f
                       _server-id6270_
                       __tmp16712
                       __tmp16711
                       __tmp16710
                       __tmp16709
                       _sub-passphrase6277_))))))))
    (define gerbil/tools/gxensemble#do-package
      (lambda (_opt6239_)
        (let* ((_server-id6241_
                (let () (declare (not safe)) (table-ref _opt6239_ 'server-id)))
               (_output6243_
                (let () (declare (not safe)) (table-ref _opt6239_ 'output)))
               (_output6245_ (path-expand _output6243_ (current-directory)))
               (_ensemble-base6247_ '"ensemble/")
               (_ensemble-rebase6255_
                (lambda _files6249_
                  (map (lambda (_g62506252_)
                         (string-append _ensemble-base6247_ _g62506252_))
                       _files6249_)))
               (_server-base6257_
                (string-append
                 _ensemble-base6247_
                 '"server/"
                 (symbol->string _server-id6241_)
                 '"/"))
               (_server-rebase6265_
                (lambda _files6259_
                  (map (lambda (_g62606262_)
                         (string-append _server-base6257_ _g62606262_))
                       _files6259_))))
          (current-directory (gerbil-path))
          (let ((__tmp16717
                 (let ((__tmp16718
                        (let ((__tmp16719
                               (let ((__tmp16721
                                      (let ()
                                        (declare (not safe))
                                        (_server-rebase6265_
                                         '"tls/chain.pem"
                                         '"tls/server.key")))
                                     (__tmp16720
                                      (let ()
                                        (declare (not safe))
                                        (_ensemble-rebase6255_
                                         '"cookie"
                                         '"admin.pub"
                                         '"tls/ca-certificates"
                                         '"tls/ca.pem"
                                         '"tls/caroot.pem"
                                         '"tls/domain"))))
                                 (declare (not safe))
                                 (foldr1 cons __tmp16721 __tmp16720))))
                          (declare (not safe))
                          (cons _output6245_ __tmp16719))))
                   (declare (not safe))
                   (cons '"cavf" __tmp16718))))
            (declare (not safe))
            (std/misc/process#invoke__%
             '#f
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             '"tar"
             __tmp16717)))))
    (define gerbil/tools/gxensemble#do-shutdown
      (lambda (_opt6175_)
        (let ()
          (declare (not safe))
          (gerbil/tools/gxensemble#start-actor-server-with-options! _opt6175_))
        (let ((_$e6177_
               (let ()
                 (declare (not safe))
                 (table-ref _opt6175_ 'server-id '#f))))
          (if _$e6177_
              ((lambda (_server-id6180_)
                 (let ((_$e6182_
                        (let ()
                          (declare (not safe))
                          (table-ref _opt6175_ 'actor-id '#f))))
                   (if _$e6182_
                       ((lambda (_actor-id6185_)
                          (let ()
                            (declare (not safe))
                            (gerbil/tools/gxensemble#maybe-authorize!
                             _server-id6180_))
                          (let ()
                            (declare (not safe))
                            (displayln
                             '"... shutting down "
                             _actor-id6185_
                             '"@"
                             _server-id6180_))
                          (let ((__tmp16723
                                 (let ()
                                   (declare (not safe))
                                   (##structure
                                    std/actor-v18/server#reference::t
                                    _server-id6180_
                                    _actor-id6185_))))
                            (declare (not safe))
                            (std/actor-v18/ensemble#stop-actor!__0
                             __tmp16723)))
                        _$e6182_)
                       (begin
                         (let ()
                           (declare (not safe))
                           (gerbil/tools/gxensemble#maybe-authorize!
                            _server-id6180_))
                         (let ()
                           (declare (not safe))
                           (displayln '"... shutting down " _server-id6180_))
                         (let ()
                           (declare (not safe))
                           (std/actor-v18/ensemble#remote-stop-server!__0
                            _server-id6180_))))))
               _$e6177_)
              (call-with-current-continuation
               (lambda (_nope6187_)
                 (if (let ()
                       (declare (not safe))
                       (table-ref _opt6175_ 'force '#f))
                     '#!void
                     (begin
                       (let ()
                         (declare (not safe))
                         (displayln
                          '"This will shutdown every server in the ensemble, including the registry. Proceed? [y/n]"))
                       (if (memq (read) '(y yes Y YES))
                           '#!void
                           (_nope6187_ '#!void))))
                 (let ((_servers6189_
                        (let ()
                          (declare (not safe))
                          (std/actor-v18/ensemble#ensemble-list-servers__0))))
                   (let ((_iterable6213_ (map car _servers6189_))
                         (_iter-do6215_
                          (lambda (_val6191_)
                            (let* ((_val61936198_ _val6191_)
                                   (_E61956202_
                                    (lambda ()
                                      (let ()
                                        (declare (not safe))
                                        (error '"No clause matching"
                                               _val61936198_))))
                                   (_K61966208_
                                    (lambda (_server-id6205_)
                                      (let ()
                                        (declare (not safe))
                                        (gerbil/tools/gxensemble#maybe-authorize!
                                         _server-id6205_))
                                      (let ()
                                        (declare (not safe))
                                        (displayln
                                         '"... shutting down "
                                         _server-id6205_))
                                      (let ((__tmp16722
                                             (lambda ()
                                               (let ()
                                                 (declare (not safe))
                                                 (std/actor-v18/ensemble#remote-stop-server!__0
                                                  _server-id6205_)))))
                                        (declare (not safe))
                                        (with-catch void __tmp16722))))
                                   (_server-id6211_ _val61936198_))
                              (declare (not safe))
                              (_K61966208_ _server-id6211_)))))
                     (if (let () (declare (not safe)) (pair? _iterable6213_))
                         (for-each _iter-do6215_ _iterable6213_)
                         (if (let ()
                               (declare (not safe))
                               (null? _iterable6213_))
                             '#!void
                             (let* ((_it6218_
                                     (let ()
                                       (declare (not safe))
                                       (std/iter#iter _iterable6213_)))
                                    (_next!6221_
                                     (let ()
                                       (declare (not safe))
                                       (##unchecked-structure-ref
                                        _it6218_
                                        '2
                                        std/iter#iterator::t
                                        '#f))))
                               (declare (not safe))
                               (begin
                                 (let _lp6226_ ()
                                   (let ((_val6230_ (_next!6221_ _it6218_)))
                                     (if (eq? std/iter#iter-end _val6230_)
                                         '#!void
                                         (begin
                                           (_iter-do6215_ _val6230_)
                                           (_lp6226_)))))
                                 (let ((_$e6232_
                                        (##unchecked-structure-ref
                                         _it6218_
                                         '3
                                         std/iter#iterator::t
                                         '#f)))
                                   (if _$e6232_
                                       ((lambda (_g62346236_)
                                          (_g62346236_ _it6218_))
                                        _$e6232_)
                                       '#!void))
                                 '#!void)))))
                   (if (let () (declare (not safe)) (null? _servers6189_))
                       '#!void
                       (thread-sleep! '3)))
                 (let ()
                   (declare (not safe))
                   (displayln '"... shutting down registry"))
                 (let ()
                   (declare (not safe))
                   (gerbil/tools/gxensemble#maybe-authorize! 'registry))
                 (let ()
                   (declare (not safe))
                   (std/actor-v18/ensemble#remote-stop-server!__0
                    'registry))))))
        (let ()
          (declare (not safe))
          (std/actor-v18/server#stop-actor-server!__0))))
    (define gerbil/tools/gxensemble#do-ping
      (lambda (_opt6166_)
        (let ()
          (declare (not safe))
          (gerbil/tools/gxensemble#start-actor-server-with-options! _opt6166_))
        (let* ((_server-id6168_
                (let () (declare (not safe)) (table-ref _opt6166_ 'server-id)))
               (_$e6170_
                (let ()
                  (declare (not safe))
                  (table-ref _opt6166_ 'actor-id '#f))))
          (if _$e6170_
              ((lambda (_actor-id6173_)
                 (let ((__tmp16725
                        (let ((__tmp16726
                               (let ()
                                 (declare (not safe))
                                 (##structure
                                  std/actor-v18/server#reference::t
                                  _server-id6168_
                                  _actor-id6173_))))
                          (declare (not safe))
                          (std/actor-v18/ensemble#ping-actor__0 __tmp16726))))
                   (declare (not safe))
                   (displayln __tmp16725)))
               _$e6170_)
              (let ((__tmp16724
                     (let ()
                       (declare (not safe))
                       (std/actor-v18/ensemble#ping-server__0
                        _server-id6168_))))
                (declare (not safe))
                (displayln __tmp16724))))))
    (define gerbil/tools/gxensemble#do-eval
      (lambda (_opt6161_)
        (let ()
          (declare (not safe))
          (gerbil/tools/gxensemble#start-actor-server-with-options! _opt6161_))
        (let ((_server-id6163_
               (let () (declare (not safe)) (table-ref _opt6161_ 'server-id)))
              (_expr6164_
               (let () (declare (not safe)) (table-ref _opt6161_ 'expr))))
          (let ()
            (declare (not safe))
            (gerbil/tools/gxensemble#maybe-authorize! _server-id6163_))
          (let ((__tmp16727
                 (let ()
                   (declare (not safe))
                   (std/actor-v18/ensemble#remote-eval__0
                    _server-id6163_
                    _expr6164_))))
            (declare (not safe))
            (displayln __tmp16727)))
        (let ()
          (declare (not safe))
          (std/actor-v18/server#stop-actor-server!__0))))
    (define gerbil/tools/gxensemble#do-repl
      (lambda (_opt6156_)
        (let ()
          (declare (not safe))
          (gerbil/tools/gxensemble#start-actor-server-with-options! _opt6156_))
        (let ((_server-id6158_
               (let () (declare (not safe)) (table-ref _opt6156_ 'server-id)))
              (_library-prefix6159_
               (let ()
                 (declare (not safe))
                 (table-ref _opt6156_ 'library-prefix))))
          (let ()
            (declare (not safe))
            (gerbil/tools/gxensemble#maybe-authorize! _server-id6158_))
          (let ()
            (declare (not safe))
            (gerbil/tools/gxensemble#do-repl-for-server
             _server-id6158_
             _library-prefix6159_))
          (let ()
            (declare (not safe))
            (std/actor-v18/server#stop-actor-server!__0)))))
    (define gerbil/tools/gxensemble#do-repl-for-server
      (lambda (_server-id5613_ _library-prefix5614_)
        (letrec* ((_display-help5616_
                   (lambda ()
                     (let ()
                       (declare (not safe))
                       (displayln '"Control commands: "))
                     (let ()
                       (declare (not safe))
                       (displayln
                        '"  ,(import module-id)    -- import a module locally for expansion"))
                     (let ()
                       (declare (not safe))
                       (displayln
                        '"  ,(load module-id)      -- load the code and dependencies for a module"))
                     (let ()
                       (declare (not safe))
                       (displayln
                        '"  ,(load -f module-id)   -- forcibly load a module ignoring dependencies"))
                     (let ()
                       (declare (not safe))
                       (displayln
                        '"  ,(load -l module-id)   -- load a library module"))
                     (let ()
                       (declare (not safe))
                       (displayln
                        '"  ,(defined? id)         -- checks if an identifier is defined at the server"))
                     (let ()
                       (declare (not safe))
                       (displayln
                        '"  ,(thread-state)        -- display the thread state for the primordial thread group"))
                     (let ()
                       (declare (not safe))
                       (displayln
                        '"  ,(thread-state -g)     -- display the thread state for all thread groups recursively"))
                     (let ()
                       (declare (not safe))
                       (displayln
                        '"  ,(thread-state sn)     -- display the thread state for a thread or group identified by its serial number"))
                     (let ()
                       (declare (not safe))
                       (displayln
                        '"  ,(thread-backtrace sn) -- display a backtrace for a thread identified by its serial number"))
                     (let ()
                       (declare (not safe))
                       (displayln
                        '"  ,(shutdown)            -- shut down the server and exit the repl"))
                     (let ()
                       (declare (not safe))
                       (displayln
                        '"  ,q ,quit               -- quit the repl"))
                     (let ()
                       (declare (not safe))
                       (displayln
                        '"  ,h ,help               -- display this help message"))))
                  (_module-registry5617_ '#f)
                  (_loaded-object-files5618_
                   (let () (declare (not safe)) (make-table)))
                  (_library-module-loader5619_
                   (lambda (_module-id6153_)
                     (string-append
                      (let ()
                        (declare (not safe))
                        (gerbil/tools/gxensemble#module-id->string
                         _module-id6153_))
                      '"__rt")))
                  (_library-module-rt5620_
                   (lambda (_module-id6151_)
                     (string-append
                      (let ()
                        (declare (not safe))
                        (gerbil/tools/gxensemble#module-id->string
                         _module-id6151_))
                      '"__0")))
                  (_library-module-loaded?5621_
                   (lambda (_module-id6146_)
                     (let ((_$e6148_
                            (let ((__tmp16728
                                   (let ()
                                     (declare (not safe))
                                     (_library-module-loader5619_
                                      _module-id6146_))))
                              (declare (not safe))
                              (table-ref
                               _module-registry5617_
                               __tmp16728
                               '#f))))
                       (if _$e6148_
                           _$e6148_
                           (let ((__tmp16729
                                  (let ()
                                    (declare (not safe))
                                    (_library-module-rt5620_
                                     _module-id6146_))))
                             (declare (not safe))
                             (table-ref
                              _module-registry5617_
                              __tmp16729
                              '#f))))))
                  (_object-file-loaded?5622_
                   (lambda (_object-file6144_)
                     (let ()
                       (declare (not safe))
                       (table-ref
                        _loaded-object-files5618_
                        _object-file6144_
                        '#f))))
                  (_bind-module-exports!5623_
                   (lambda (_ctx6105_)
                     (let _lp6107_ ((_rest6109_
                                     (##structure-ref
                                      _ctx6105_
                                      '9
                                      gx#module-context::t
                                      '#f)))
                       (let* ((_rest61106118_ _rest6109_)
                              (_else61126126_ (lambda () '#!void))
                              (_K61146132_
                               (lambda (_rest6129_ _hd6130_)
                                 (if (let ()
                                       (declare (not safe))
                                       (##structure-direct-instance-of?
                                        _hd6130_
                                        'gx#module-export::t))
                                     (begin
                                       (if (= (##direct-structure-ref
                                               _hd6130_
                                               '3
                                               gx#module-export::t
                                               '#f)
                                              '0)
                                           (let ((__tmp16732
                                                  (let ()
                                                    (declare (not safe))
                                                    (gx#core-module-export->import__0
                                                     _hd6130_))))
                                             (declare (not safe))
                                             (gx#core-bind-import!__0
                                              __tmp16732))
                                           '#!void)
                                       (let ()
                                         (declare (not safe))
                                         (_lp6107_ _rest6129_)))
                                     (if (let ()
                                           (declare (not safe))
                                           (##structure-direct-instance-of?
                                            _hd6130_
                                            'gx#export-set::t))
                                         (let ((__tmp16730
                                                (let ((__tmp16731
                                                       (##direct-structure-ref
                                                        _hd6130_
                                                        '3
                                                        gx#export-set::t
                                                        '#f)))
                                                  (declare (not safe))
                                                  (foldl1 cons
                                                          _rest6129_
                                                          __tmp16731))))
                                           (declare (not safe))
                                           (_lp6107_ __tmp16730))
                                         (let ()
                                           (declare (not safe))
                                           (_lp6107_ _rest6129_)))))))
                         (if (let ()
                               (declare (not safe))
                               (##pair? _rest61106118_))
                             (let ((_hd61156135_
                                    (let ()
                                      (declare (not safe))
                                      (##car _rest61106118_)))
                                   (_tl61166137_
                                    (let ()
                                      (declare (not safe))
                                      (##cdr _rest61106118_))))
                               (let* ((_hd6140_ _hd61156135_)
                                      (_rest6142_ _tl61166137_))
                                 (declare (not safe))
                                 (_K61146132_ _rest6142_ _hd6140_)))
                             '#!void)))))
                  (_load-object-file5624_
                   (lambda (_object-file6103_)
                     (if (let ()
                           (declare (not safe))
                           (_object-file-loaded?5622_ _object-file6103_))
                         '#!void
                         (begin
                           (let ()
                             (declare (not safe))
                             (displayln
                              '"loading code object file "
                              _object-file6103_))
                           (let ()
                             (declare (not safe))
                             (table-set!
                              _loaded-object-files5618_
                              _object-file6103_
                              '#t))
                           (let ()
                             (declare (not safe))
                             (std/actor-v18/ensemble#remote-load-code__0
                              _server-id5613_
                              _object-file6103_))))))
                  (_load-library-module5625_
                   (lambda (_lib6101_)
                     (if (let ()
                           (declare (not safe))
                           (_library-module-loaded?5621_ _lib6101_))
                         '#!void
                         (begin
                           (let ()
                             (declare (not safe))
                             (displayln '"loading library module " _lib6101_))
                           (let ()
                             (declare (not safe))
                             (std/actor-v18/ensemble#remote-load-library-module__0
                              _server-id5613_
                              _lib6101_))
                           (set! _module-registry5617_
                                 (let ()
                                   (declare (not safe))
                                   (std/actor-v18/ensemble#remote-eval__0
                                    _server-id5613_
                                    '(current-module-registry))))))))
                  (_eval-expr5626_
                   (lambda (_expr6090_)
                     (let* ((_expanded-expr6092_
                             (let ()
                               (declare (not safe))
                               (gx#core-expand__0 _expr6090_)))
                            (_compiled-expr6094_
                             (let ()
                               (declare (not safe))
                               (gx#core-compile-top-syntax
                                _expanded-expr6092_)))
                            (_raw-compiled-expr6096_
                             (__compile _compiled-expr6094_))
                            (_result6098_
                             (let ()
                               (declare (not safe))
                               (std/actor-v18/ensemble#remote-eval__0
                                _server-id5613_
                                _raw-compiled-expr6096_))))
                       (if (let ()
                             (declare (not safe))
                             (eq? _result6098_ '#!void))
                           '#!void
                           (if (let ()
                                 (declare (not safe))
                                 (##values? _result6098_))
                               (let ((__tmp16733
                                      (if (let ()
                                            (declare (not safe))
                                            (##values? _result6098_))
                                          (let ()
                                            (declare (not safe))
                                            (##vector->list _result6098_))
                                          (list _result6098_))))
                                 (declare (not safe))
                                 (gerbil/tools/gxensemble#display-result-list
                                  __tmp16733))
                               (let ()
                                 (declare (not safe))
                                 (gerbil/tools/gxensemble#display-result
                                  _result6098_))))))))
          (gerbil-load-expander!)
          (let ()
            (declare (not safe))
            (std/actor-v18/server#connect-to-server!__0 _server-id5613_))
          (let ()
            (declare (not safe))
            (std/actor-v18/ensemble#remote-eval__0
             _server-id5613_
             '(##expand-source-set! identity)))
          (set! _module-registry5617_
                (let ()
                  (declare (not safe))
                  (std/actor-v18/ensemble#remote-eval__0
                   _server-id5613_
                   '(current-module-registry))))
          (call-with-current-continuation
           (lambda (_exit5628_)
             (let ((__tmp16735
                    (lambda ()
                      (eval '(import :gerbil/core))
                      (eval '(import :gerbil/gambit))
                      (let _lp5631_ ()
                        (if '#t
                            (begin
                              (display _server-id5613_)
                              (display '"> ")
                              (let ((__tmp16804
                                     (lambda (_g56345636_)
                                       (if '#t
                                           (let ((_exn5639_ _g56345636_))
                                             (display '"*** ERROR ")
                                             (let ()
                                               (declare (not safe))
                                               (display-exception _exn5639_)))
                                           (let ()
                                             (declare (not safe))
                                             (raise _g56345636_)))))
                                    (__tmp16736
                                     (lambda ()
                                       (let* ((_g56415654_ (read))
                                              (_E56455658_
                                               (lambda ()
                                                 (let ()
                                                   (declare (not safe))
                                                   (error '"No clause matching"
                                                          _g56415654_)))))
                                         (let ((_K56526087_
                                                (lambda ()
                                                  (_exit5628_ '#!void)))
                                               (_K56476068_
                                                (lambda (_command5673_)
                                                  (let* ((_command56745742_
                                                          _command5673_)
                                                         (_else56875750_
                                                          (lambda ()
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (displayln
                                                               '"unknown control command "
                                                               _command5673_))
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (_display-help5616_)))))
                                                    (let ((_K57366053_
                                                           (lambda (_module-id6051_)
                                                             (let ((__tmp16737
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            (let ()
                              (declare (not safe))
                              (gx#import-module__0 _module-id6051_))))
                       (declare (not safe))
                       (_bind-module-exports!5623_ __tmp16737))))
                  (_K57316033_
                   (lambda (_module-id5934_)
                     (let ((_g16738_
                            (let ()
                              (declare (not safe))
                              (gerbil/tools/gxensemble#get-module-objects
                               _module-id5934_
                               _library-prefix5614_))))
                       (begin
                         (let ((_g16739_
                                (let ()
                                  (declare (not safe))
                                  (if (##values? _g16738_)
                                      (##vector-length _g16738_)
                                      1))))
                           (if (not (let ()
                                      (declare (not safe))
                                      (##fx= _g16739_ 2)))
                               (error "Context expects 2 values" _g16739_)))
                         (let ((_object-files5936_
                                (let ()
                                  (declare (not safe))
                                  (##vector-ref _g16738_ 0)))
                               (_library-modules5937_
                                (let ()
                                  (declare (not safe))
                                  (##vector-ref _g16738_ 1))))
                           (begin
                             (if _module-registry5617_
                                 (let ((_iterable5960_ _library-modules5937_)
                                       (_iter-do5962_
                                        (lambda (_val5939_)
                                          (let* ((_val59415946_ _val5939_)
                                                 (_E59435950_
                                                  (lambda ()
                                                    (let ()
                                                      (declare (not safe))
                                                      (error '"No clause matching"
                                                             _val59415946_))))
                                                 (_K59445955_
                                                  (lambda (_lib5953_)
                                                    (let ()
                                                      (declare (not safe))
                                                      (_load-library-module5625_
                                                       _lib5953_))))
                                                 (_lib5958_ _val59415946_))
                                            (declare (not safe))
                                            (_load-library-module5625_
                                             _lib5958_)))))
                                   (if (let ()
                                         (declare (not safe))
                                         (pair? _iterable5960_))
                                       (for-each _iter-do5962_ _iterable5960_)
                                       (if (let ()
                                             (declare (not safe))
                                             (null? _iterable5960_))
                                           '#!void
                                           (let* ((_it5965_
                                                   (let ()
                                                     (declare (not safe))
                                                     (std/iter#iter
                                                      _iterable5960_)))
                                                  (_next!5968_
                                                   (let ()
                                                     (declare (not safe))
                                                     (##unchecked-structure-ref
                                                      _it5965_
                                                      '2
                                                      std/iter#iterator::t
                                                      '#f))))
                                             (declare (not safe))
                                             (begin
                                               (let _lp5973_ ()
                                                 (let ((_val5977_
                                                        (_next!5968_
                                                         _it5965_)))
                                                   (if (eq? std/iter#iter-end
                                                            _val5977_)
                                                       '#!void
                                                       (begin
                                                         (_iter-do5962_
                                                          _val5977_)
                                                         (_lp5973_)))))
                                               (let ((_$e5979_
                                                      (##unchecked-structure-ref
                                                       _it5965_
                                                       '3
                                                       std/iter#iterator::t
                                                       '#f)))
                                                 (if _$e5979_
                                                     ((lambda (_g59815983_)
                                                        (_g59815983_ _it5965_))
                                                      _$e5979_)
                                                     '#!void))
                                               '#!void)))))
                                 '#!void)
                             (let ((_iterable6007_ _object-files5936_)
                                   (_iter-do6009_
                                    (lambda (_val5986_)
                                      (let* ((_val59885993_ _val5986_)
                                             (_E59905997_
                                              (lambda ()
                                                (let ()
                                                  (declare (not safe))
                                                  (error '"No clause matching"
                                                         _val59885993_))))
                                             (_K59916002_
                                              (lambda (_object-file6000_)
                                                (let ()
                                                  (declare (not safe))
                                                  (_load-object-file5624_
                                                   _object-file6000_))))
                                             (_object-file6005_ _val59885993_))
                                        (declare (not safe))
                                        (_load-object-file5624_
                                         _object-file6005_)))))
                               (if (let ()
                                     (declare (not safe))
                                     (pair? _iterable6007_))
                                   (for-each _iter-do6009_ _iterable6007_)
                                   (if (let ()
                                         (declare (not safe))
                                         (null? _iterable6007_))
                                       '#!void
                                       (let* ((_it6012_
                                               (let ()
                                                 (declare (not safe))
                                                 (std/iter#iter
                                                  _iterable6007_)))
                                              (_next!6015_
                                               (let ()
                                                 (declare (not safe))
                                                 (##unchecked-structure-ref
                                                  _it6012_
                                                  '2
                                                  std/iter#iterator::t
                                                  '#f))))
                                         (declare (not safe))
                                         (begin
                                           (let _lp6020_ ()
                                             (let ((_val6024_
                                                    (_next!6015_ _it6012_)))
                                               (if (eq? std/iter#iter-end
                                                        _val6024_)
                                                   '#!void
                                                   (begin
                                                     (_iter-do6009_ _val6024_)
                                                     (_lp6020_)))))
                                           (let ((_$e6026_
                                                  (##unchecked-structure-ref
                                                   _it6012_
                                                   '3
                                                   std/iter#iterator::t
                                                   '#f)))
                                             (if _$e6026_
                                                 ((lambda (_g60286030_)
                                                    (_g60286030_ _it6012_))
                                                  _$e6026_)
                                                 '#!void))
                                           '#!void)))))))))))
                  (_K57245910_
                   (lambda (_module-id5906_)
                     (let ((_object-file5908_
                            (let ((__tmp16740
                                   (let ()
                                     (declare (not safe))
                                     (gx#import-module__0 _module-id5906_))))
                              (declare (not safe))
                              (gerbil/tools/gxensemble#find-object-file
                               __tmp16740))))
                       (if _object-file5908_
                           (let ()
                             (declare (not safe))
                             (_load-object-file5624_ _object-file5908_))
                           (let ()
                             (declare (not safe))
                             (displayln '"cannot find object file"))))))
                  (_K57175880_
                   (lambda (_module-id5877_ _-l5878_)
                     (if _module-registry5617_
                         (let ()
                           (declare (not safe))
                           (_load-library-module5625_ _module-id5877_))
                         (let ()
                           (declare (not safe))
                           (displayln
                            '"server does not support library loading")))))
                  (_K57125858_
                   (lambda (_symbol5856_)
                     (let ((__tmp16741
                            (let ((__tmp16742
                                   (let ((__tmp16748
                                          (let ((__tmp16749
                                                 (let ((__tmp16751
                                                        (let ()
                                                          (declare (not safe))
                                                          (cons '_ '())))
                                                       (__tmp16750
                                                        (let ()
                                                          (declare (not safe))
                                                          (cons '#f '()))))
                                                   (declare (not safe))
                                                   (cons __tmp16751
                                                         __tmp16750))))
                                            (declare (not safe))
                                            (cons 'lambda __tmp16749)))
                                         (__tmp16743
                                          (let ((__tmp16744
                                                 (let ((__tmp16745
                                                        (let ((__tmp16746
                                                               (let ((__tmp16747
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              (let () (declare (not safe)) (cons '#t '()))))
                         (declare (not safe))
                         (cons _symbol5856_ __tmp16747))))
                  (declare (not safe))
                  (cons '() __tmp16746))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (declare (not safe))
                                                   (cons 'lambda __tmp16745))))
                                            (declare (not safe))
                                            (cons __tmp16744 '()))))
                                     (declare (not safe))
                                     (cons __tmp16748 __tmp16743))))
                              (declare (not safe))
                              (cons 'with-exception-catcher __tmp16742))))
                       (declare (not safe))
                       (_eval-expr5626_ __tmp16741))))
                  (_K57095844_
                   (lambda ()
                     (let ()
                       (declare (not safe))
                       (_eval-expr5626_
                        '(call-with-output-string
                          ""
                          (lambda (p)
                            (##cmd-st
                             (thread-thread-group ##primordial-thread)
                             p)))))))
                  (_K57045826_
                   (lambda ()
                     (let ()
                       (declare (not safe))
                       (_eval-expr5626_
                        '(call-with-output-string
                          ""
                          (lambda (p)
                            (let thread-state ((tg (thread-thread-group
                                                    ##primordial-thread)))
                              (display "thread group: " p)
                              (display tg p)
                              (newline p)
                              (##cmd-st tg p)
                              (for-each
                               thread-state
                               (thread-group->thread-group-list tg)))))))))
                  (_K56995806_
                   (lambda (_sn5804_)
                     (let ((__tmp16752
                            (let ((__tmp16753
                                   (let ((__tmp16754
                                          (let ((__tmp16755
                                                 (let ((__tmp16756
                                                        (let ((__tmp16778
                                                               (let ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (declare (not safe))
                         (cons 'p '())))
                      (__tmp16757
                       (let ((__tmp16758
                              (let ((__tmp16759
                                     (let ((__tmp16774
                                            (let ((__tmp16775
                                                   (let ((__tmp16776
                                                          (let ((__tmp16777
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (let () (declare (not safe)) (cons _sn5804_ '()))))
                    (declare (not safe))
                    (cons 'serial-number->object __tmp16777))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (declare (not safe))
                                                     (cons __tmp16776 '()))))
                                              (declare (not safe))
                                              (cons 'thread-or-group
                                                    __tmp16775)))
                                           (__tmp16760
                                            (let ((__tmp16761
                                                   (let ((__tmp16762
                                                          (let ((__tmp16767
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (let ((__tmp16768
                                (let ((__tmp16772
                                       (let ((__tmp16773
                                              (let ()
                                                (declare (not safe))
                                                (cons 'thread-or-group '()))))
                                         (declare (not safe))
                                         (cons 'thread? __tmp16773)))
                                      (__tmp16769
                                       (let ((__tmp16770
                                              (let ((__tmp16771
                                                     (let ()
                                                       (declare (not safe))
                                                       (cons 'thread-or-group
                                                             '()))))
                                                (declare (not safe))
                                                (cons 'thread-group?
                                                      __tmp16771))))
                                         (declare (not safe))
                                         (cons __tmp16770 '()))))
                                  (declare (not safe))
                                  (cons __tmp16772 __tmp16769))))
                           (declare (not safe))
                           (cons 'or __tmp16768)))
                        (__tmp16763
                         (let ((__tmp16764
                                (let ((__tmp16765
                                       (let ((__tmp16766
                                              (let ()
                                                (declare (not safe))
                                                (cons 'p '()))))
                                         (declare (not safe))
                                         (cons 'thread-or-group __tmp16766))))
                                  (declare (not safe))
                                  (cons '##cmd-st __tmp16765))))
                           (declare (not safe))
                           (cons __tmp16764 '()))))
                    (declare (not safe))
                    (cons __tmp16767 __tmp16763))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (declare (not safe))
                                                     (cons 'if __tmp16762))))
                                              (declare (not safe))
                                              (cons __tmp16761 '()))))
                                       (declare (not safe))
                                       (cons __tmp16774 __tmp16760))))
                                (declare (not safe))
                                (cons 'let __tmp16759))))
                         (declare (not safe))
                         (cons __tmp16758 '()))))
                  (declare (not safe))
                  (cons __tmp16778 __tmp16757))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (declare (not safe))
                                                   (cons 'lambda __tmp16756))))
                                            (declare (not safe))
                                            (cons __tmp16755 '()))))
                                     (declare (not safe))
                                     (cons '"" __tmp16754))))
                              (declare (not safe))
                              (cons 'call-with-output-string __tmp16753))))
                       (declare (not safe))
                       (_eval-expr5626_ __tmp16752))))
                  (_K56945785_
                   (lambda (_sn5783_)
                     (let ((__tmp16779
                            (let ((__tmp16780
                                   (let ((__tmp16781
                                          (let ((__tmp16782
                                                 (let ((__tmp16783
                                                        (let ((__tmp16803
                                                               (let ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (declare (not safe))
                         (cons 'p '())))
                      (__tmp16784
                       (let ((__tmp16785
                              (let ((__tmp16786
                                     (let ((__tmp16799
                                            (let ((__tmp16800
                                                   (let ((__tmp16801
                                                          (let ((__tmp16802
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (let () (declare (not safe)) (cons _sn5783_ '()))))
                    (declare (not safe))
                    (cons 'serial-number->object __tmp16802))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (declare (not safe))
                                                     (cons __tmp16801 '()))))
                                              (declare (not safe))
                                              (cons 'thread __tmp16800)))
                                           (__tmp16787
                                            (let ((__tmp16788
                                                   (let ((__tmp16789
                                                          (let ((__tmp16797
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (let ((__tmp16798
                                (let ()
                                  (declare (not safe))
                                  (cons 'thread '()))))
                           (declare (not safe))
                           (cons 'thread? __tmp16798)))
                        (__tmp16790
                         (let ((__tmp16791
                                (let ((__tmp16792
                                       (let ((__tmp16795
                                              (let ((__tmp16796
                                                     (let ()
                                                       (declare (not safe))
                                                       (cons 'thread '()))))
                                                (declare (not safe))
                                                (cons '##thread-continuation-capture
                                                      __tmp16796)))
                                             (__tmp16793
                                              (let ((__tmp16794
                                                     (let ()
                                                       (declare (not safe))
                                                       (cons '#t '()))))
                                                (declare (not safe))
                                                (cons 'p __tmp16794))))
                                         (declare (not safe))
                                         (cons __tmp16795 __tmp16793))))
                                  (declare (not safe))
                                  (cons 'display-continuation-backtrace
                                        __tmp16792))))
                           (declare (not safe))
                           (cons __tmp16791 '()))))
                    (declare (not safe))
                    (cons __tmp16797 __tmp16790))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (declare (not safe))
                                                     (cons 'if __tmp16789))))
                                              (declare (not safe))
                                              (cons __tmp16788 '()))))
                                       (declare (not safe))
                                       (cons __tmp16799 __tmp16787))))
                                (declare (not safe))
                                (cons 'let __tmp16786))))
                         (declare (not safe))
                         (cons __tmp16785 '()))))
                  (declare (not safe))
                  (cons __tmp16803 __tmp16784))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (declare (not safe))
                                                   (cons 'lambda __tmp16783))))
                                            (declare (not safe))
                                            (cons __tmp16782 '()))))
                                     (declare (not safe))
                                     (cons '"" __tmp16781))))
                              (declare (not safe))
                              (cons 'call-with-output-string __tmp16780))))
                       (declare (not safe))
                       (_eval-expr5626_ __tmp16779))))
                  (_K56915771_
                   (lambda ()
                     (let ()
                       (declare (not safe))
                       (std/actor-v18/ensemble#remote-stop-server!__0
                        _server-id5613_))
                     (_exit5628_ '#!void)))
                  (_K56905763_
                   (lambda ()
                     (let () (declare (not safe)) (_display-help5616_))))
                  (_K56895755_ (lambda () (_exit5628_ '#!void))))
              (let* ((___match1665816659_
                      (lambda ()
                        (if (let ()
                              (declare (not safe))
                              (##eq? _command56745742_ 'quit))
                            (let () (declare (not safe)) (_K56895755_))
                            (let () (declare (not safe)) (_else56875750_)))))
                     (_try-match56865758_
                      (lambda ()
                        (if (let ()
                              (declare (not safe))
                              (##eq? _command56745742_ 'q))
                            (let () (declare (not safe)) (_K56895755_))
                            (___match1665816659_))))
                     (___match1665216653_
                      (lambda ()
                        (if (let ()
                              (declare (not safe))
                              (##eq? _command56745742_ 'help))
                            (let () (declare (not safe)) (_display-help5616_))
                            (let ()
                              (declare (not safe))
                              (_try-match56865758_)))))
                     (_try-match56855766_
                      (lambda ()
                        (if (let ()
                              (declare (not safe))
                              (##eq? _command56745742_ 'h))
                            (let () (declare (not safe)) (_display-help5616_))
                            (___match1665216653_)))))
                (if (let () (declare (not safe)) (##pair? _command56745742_))
                    (let ((_tl57386058_
                           (let ()
                             (declare (not safe))
                             (##cdr _command56745742_)))
                          (_hd57376056_
                           (let ()
                             (declare (not safe))
                             (##car _command56745742_))))
                      (if (let ()
                            (declare (not safe))
                            (##eq? _hd57376056_ 'import))
                          (if (let ()
                                (declare (not safe))
                                (##pair? _tl57386058_))
                              (let ((_tl57406063_
                                     (let ()
                                       (declare (not safe))
                                       (##cdr _tl57386058_)))
                                    (_hd57396061_
                                     (let ()
                                       (declare (not safe))
                                       (##car _tl57386058_))))
                                (if (let ()
                                      (declare (not safe))
                                      (##null? _tl57406063_))
                                    (let ((_module-id6066_ _hd57396061_))
                                      (declare (not safe))
                                      (_K57366053_ _module-id6066_))
                                    (if (let ()
                                          (declare (not safe))
                                          (##eq? _command56745742_ 'h))
                                        (let ()
                                          (declare (not safe))
                                          (_display-help5616_))
                                        (___match1665216653_))))
                              (if (let ()
                                    (declare (not safe))
                                    (##eq? _command56745742_ 'h))
                                  (let ()
                                    (declare (not safe))
                                    (_display-help5616_))
                                  (___match1665216653_)))
                          (if (let ()
                                (declare (not safe))
                                (##eq? _hd57376056_ 'load))
                              (if (let ()
                                    (declare (not safe))
                                    (##pair? _tl57386058_))
                                  (let ((_tl57356043_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _tl57386058_)))
                                        (_hd57346041_
                                         (let ()
                                           (declare (not safe))
                                           (##car _tl57386058_))))
                                    (if (let ()
                                          (declare (not safe))
                                          (##null? _tl57356043_))
                                        (let ((_module-id6046_ _hd57346041_))
                                          (declare (not safe))
                                          (_K57316033_ _module-id6046_))
                                        (if (let ()
                                              (declare (not safe))
                                              (##eq? _hd57346041_ '-f))
                                            (if (let ()
                                                  (declare (not safe))
                                                  (##pair? _tl57356043_))
                                                (let ((_tl57305925_
                                                       (let ()
                                                         (declare (not safe))
                                                         (##cdr _tl57356043_)))
                                                      (_hd57295923_
                                                       (let ()
                                                         (declare (not safe))
                                                         (##car _tl57356043_))))
                                                  (if (let ()
                                                        (declare (not safe))
                                                        (##null? _tl57305925_))
                                                      (let ((_module-id5928_
                                                             _hd57295923_))
                                                        (declare (not safe))
                                                        (_K57245910_
                                                         _module-id5928_))
                                                      (if (let ()
                                                            (declare
                                                              (not safe))
                                                            (##eq? _command56745742_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           'h))
                  (let () (declare (not safe)) (_display-help5616_))
                  (___match1665216653_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                (if (let ()
                                                      (declare (not safe))
                                                      (##eq? _command56745742_
                                                             'h))
                                                    (let ()
                                                      (declare (not safe))
                                                      (_display-help5616_))
                                                    (___match1665216653_)))
                                            (if (let ()
                                                  (declare (not safe))
                                                  (##pair? _tl57356043_))
                                                (let ((_tl57235897_
                                                       (let ()
                                                         (declare (not safe))
                                                         (##cdr _tl57356043_)))
                                                      (_hd57225895_
                                                       (let ()
                                                         (declare (not safe))
                                                         (##car _tl57356043_))))
                                                  (if (let ()
                                                        (declare (not safe))
                                                        (##null? _tl57235897_))
                                                      (let ((_-l5893_
                                                             _hd57346041_)
                                                            (_module-id5900_
                                                             _hd57225895_))
                                                        (let ()
                                                          (declare (not safe))
                                                          (_K57175880_
                                                           _module-id5900_
                                                           _-l5893_)))
                                                      (if (let ()
                                                            (declare
                                                              (not safe))
                                                            (##eq? _command56745742_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           'h))
                  (let () (declare (not safe)) (_display-help5616_))
                  (___match1665216653_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                (if (let ()
                                                      (declare (not safe))
                                                      (##eq? _command56745742_
                                                             'h))
                                                    (let ()
                                                      (declare (not safe))
                                                      (_display-help5616_))
                                                    (___match1665216653_))))))
                                  (if (let ()
                                        (declare (not safe))
                                        (##eq? _command56745742_ 'h))
                                      (let ()
                                        (declare (not safe))
                                        (_display-help5616_))
                                      (___match1665216653_)))
                              (if (let ()
                                    (declare (not safe))
                                    (##eq? _hd57376056_ 'defined?))
                                  (if (let ()
                                        (declare (not safe))
                                        (##pair? _tl57386058_))
                                      (let ((_tl57165868_
                                             (let ()
                                               (declare (not safe))
                                               (##cdr _tl57386058_)))
                                            (_hd57155866_
                                             (let ()
                                               (declare (not safe))
                                               (##car _tl57386058_))))
                                        (if (let ()
                                              (declare (not safe))
                                              (##null? _tl57165868_))
                                            (let ((_symbol5871_ _hd57155866_))
                                              (declare (not safe))
                                              (_K57125858_ _symbol5871_))
                                            (if (let ()
                                                  (declare (not safe))
                                                  (##eq? _command56745742_ 'h))
                                                (let ()
                                                  (declare (not safe))
                                                  (_display-help5616_))
                                                (___match1665216653_))))
                                      (if (let ()
                                            (declare (not safe))
                                            (##eq? _command56745742_ 'h))
                                          (let ()
                                            (declare (not safe))
                                            (_display-help5616_))
                                          (___match1665216653_)))
                                  (if (let ()
                                        (declare (not safe))
                                        (##eq? _hd57376056_ 'thread-state))
                                      (if (let ()
                                            (declare (not safe))
                                            (##null? _tl57386058_))
                                          (let ()
                                            (declare (not safe))
                                            (_K57095844_))
                                          (if (let ()
                                                (declare (not safe))
                                                (##pair? _tl57386058_))
                                              (let ((_tl57085836_
                                                     (let ()
                                                       (declare (not safe))
                                                       (##cdr _tl57386058_)))
                                                    (_hd57075834_
                                                     (let ()
                                                       (declare (not safe))
                                                       (##car _tl57386058_))))
                                                (if (let ()
                                                      (declare (not safe))
                                                      (##eq? _hd57075834_ '-g))
                                                    (if (let ()
                                                          (declare (not safe))
                                                          (##null? _tl57085836_))
                                                        (let ()
                                                          (declare (not safe))
                                                          (_K57045826_))
                                                        (if (let ()
                                                              (declare
                                                                (not safe))
                                                              (##eq? _command56745742_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                             'h))
                    (let () (declare (not safe)) (_display-help5616_))
                    (___match1665216653_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                    (if (let ()
                                                          (declare (not safe))
                                                          (integer?
                                                           _hd57075834_))
                                                        (if (let ()
                                                              (declare
                                                                (not safe))
                                                              (##null? _tl57085836_))
                                                            (let ((_sn5819_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           _hd57075834_))
                      (declare (not safe))
                      (_K56995806_ _sn5819_))
                    (if (let ()
                          (declare (not safe))
                          (##eq? _command56745742_ 'h))
                        (let () (declare (not safe)) (_display-help5616_))
                        (___match1665216653_)))
                (if (let () (declare (not safe)) (##eq? _command56745742_ 'h))
                    (let () (declare (not safe)) (_display-help5616_))
                    (___match1665216653_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              (if (let ()
                                                    (declare (not safe))
                                                    (##eq? _command56745742_
                                                           'h))
                                                  (let ()
                                                    (declare (not safe))
                                                    (_display-help5616_))
                                                  (___match1665216653_))))
                                      (if (let ()
                                            (declare (not safe))
                                            (##eq? _hd57376056_
                                                   'thread-backtrace))
                                          (if (let ()
                                                (declare (not safe))
                                                (##pair? _tl57386058_))
                                              (let ((_tl56985795_
                                                     (let ()
                                                       (declare (not safe))
                                                       (##cdr _tl57386058_)))
                                                    (_hd56975793_
                                                     (let ()
                                                       (declare (not safe))
                                                       (##car _tl57386058_))))
                                                (if (let ()
                                                      (declare (not safe))
                                                      (integer? _hd56975793_))
                                                    (if (let ()
                                                          (declare (not safe))
                                                          (##null? _tl56985795_))
                                                        (let ((_sn5798_
                                                               _hd56975793_))
                                                          (declare (not safe))
                                                          (_K56945785_
                                                           _sn5798_))
                                                        (if (let ()
                                                              (declare
                                                                (not safe))
                                                              (##eq? _command56745742_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                             'h))
                    (let () (declare (not safe)) (_display-help5616_))
                    (___match1665216653_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                    (if (let ()
                                                          (declare (not safe))
                                                          (##eq? _command56745742_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         'h))
                (let () (declare (not safe)) (_display-help5616_))
                (___match1665216653_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              (if (let ()
                                                    (declare (not safe))
                                                    (##eq? _command56745742_
                                                           'h))
                                                  (let ()
                                                    (declare (not safe))
                                                    (_display-help5616_))
                                                  (___match1665216653_)))
                                          (if (let ()
                                                (declare (not safe))
                                                (##eq? _hd57376056_ 'shutdown))
                                              (if (let ()
                                                    (declare (not safe))
                                                    (##null? _tl57386058_))
                                                  (let ()
                                                    (declare (not safe))
                                                    (_K56915771_))
                                                  (let ()
                                                    (declare (not safe))
                                                    (_try-match56855766_)))
                                              (let ()
                                                (declare (not safe))
                                                (_try-match56855766_)))))))))
                    (let () (declare (not safe)) (_try-match56855766_))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                               (_K56465664_
                                                (lambda (_expr5662_)
                                                  (let ()
                                                    (declare (not safe))
                                                    (_eval-expr5626_
                                                     _expr5662_)))))
                                           (let ((_try-match56436083_
                                                  (lambda ()
                                                    (if (let ()
                                                          (declare (not safe))
                                                          (##pair? _g56415654_))
                                                        (let ((_tl56496073_
                                                               (let ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (declare (not safe))
                         (##cdr _g56415654_)))
                      (_hd56486071_
                       (let () (declare (not safe)) (##car _g56415654_))))
                  (if (let ()
                        (declare (not safe))
                        (##eq? _hd56486071_ 'unquote))
                      (if (let () (declare (not safe)) (##pair? _tl56496073_))
                          (let ((_tl56516078_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _tl56496073_)))
                                (_hd56506076_
                                 (let ()
                                   (declare (not safe))
                                   (##car _tl56496073_))))
                            (if (let ()
                                  (declare (not safe))
                                  (##null? _tl56516078_))
                                (let ((_command6081_ _hd56506076_))
                                  (declare (not safe))
                                  (_K56476068_ _command6081_))
                                (let ((_expr5667_ _g56415654_))
                                  (declare (not safe))
                                  (_eval-expr5626_ _expr5667_))))
                          (let ((_expr5667_ _g56415654_))
                            (declare (not safe))
                            (_eval-expr5626_ _expr5667_)))
                      (let ((_expr5667_ _g56415654_))
                        (declare (not safe))
                        (_eval-expr5626_ _expr5667_))))
                (let ((_expr5667_ _g56415654_))
                  (declare (not safe))
                  (_eval-expr5626_ _expr5667_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                             (if (let ()
                                                   (declare (not safe))
                                                   (eof-object? _g56415654_))
                                                 (let ()
                                                   (declare (not safe))
                                                   (_K56526087_))
                                                 (let ()
                                                   (declare (not safe))
                                                   (_try-match56436083_)))))))))
                                (declare (not safe))
                                (with-catch __tmp16804 __tmp16736))
                              (let () (declare (not safe)) (_lp5631_)))
                            '#!void))))
                   (__tmp16734
                    (let ()
                      (declare (not safe))
                      (make-struct-instance gx#top-context::t))))
               (declare (not safe))
               (call-with-parameters
                __tmp16735
                gx#current-expander-context
                __tmp16734)))))))
    (define gerbil/tools/gxensemble#do-load
      (lambda (_opt5611_)
        (gerbil-load-expander!)
        (if (let () (declare (not safe)) (table-ref _opt5611_ 'library '#f))
            (let ()
              (declare (not safe))
              (gerbil/tools/gxensemble#do-load-library _opt5611_))
            (let ()
              (declare (not safe))
              (gerbil/tools/gxensemble#do-load-code _opt5611_)))))
    (define gerbil/tools/gxensemble#do-load-library
      (lambda (_opt5606_)
        (let ((_module-id5608_
               (let () (declare (not safe)) (table-ref _opt5606_ 'module-id)))
              (_server-id5609_
               (let () (declare (not safe)) (table-ref _opt5606_ 'server-id))))
          (let ()
            (declare (not safe))
            (gerbil/tools/gxensemble#start-actor-server-with-options!
             _opt5606_))
          (let ()
            (declare (not safe))
            (gerbil/tools/gxensemble#maybe-authorize! _server-id5609_))
          (let ()
            (declare (not safe))
            (displayln '"... loading library module " _module-id5608_))
          (let ((__tmp16805
                 (let ()
                   (declare (not safe))
                   (std/actor-v18/ensemble#remote-load-library-module__0
                    _server-id5609_
                    _module-id5608_))))
            (declare (not safe))
            (displayln __tmp16805))
          (let ()
            (declare (not safe))
            (std/actor-v18/server#stop-actor-server!__0)))))
    (define gerbil/tools/gxensemble#do-load-code
      (lambda (_opt5503_)
        (let ((_module-id5505_
               (let () (declare (not safe)) (table-ref _opt5503_ 'module-id)))
              (_library-prefix5506_
               (let ()
                 (declare (not safe))
                 (table-ref _opt5503_ 'library-prefix)))
              (_server-id5507_
               (let () (declare (not safe)) (table-ref _opt5503_ 'server-id))))
          (let ((_g16806_
                 (let ()
                   (declare (not safe))
                   (gerbil/tools/gxensemble#get-module-objects
                    _module-id5505_
                    _library-prefix5506_))))
            (begin
              (let ((_g16807_
                     (let ()
                       (declare (not safe))
                       (if (##values? _g16806_)
                           (##vector-length _g16806_)
                           1))))
                (if (not (let () (declare (not safe)) (##fx= _g16807_ 2)))
                    (error "Context expects 2 values" _g16807_)))
              (let ((_object-files5509_
                     (let () (declare (not safe)) (##vector-ref _g16806_ 0)))
                    (_library-modules5510_
                     (let () (declare (not safe)) (##vector-ref _g16806_ 1))))
                (begin
                  (let ()
                    (declare (not safe))
                    (gerbil/tools/gxensemble#start-actor-server-with-options!
                     _opt5503_))
                  (let ()
                    (declare (not safe))
                    (gerbil/tools/gxensemble#maybe-authorize! _server-id5507_))
                  (if (let ()
                        (declare (not safe))
                        (table-ref _opt5503_ 'force '#f))
                      '#!void
                      (let ((_iterable5533_ _library-modules5510_)
                            (_iter-do5535_
                             (lambda (_val5512_)
                               (let* ((_val55145519_ _val5512_)
                                      (_E55165523_
                                       (lambda ()
                                         (let ()
                                           (declare (not safe))
                                           (error '"No clause matching"
                                                  _val55145519_))))
                                      (_K55175528_
                                       (lambda (_lib5526_)
                                         (let ()
                                           (declare (not safe))
                                           (displayln
                                            '"... loading library module "
                                            _lib5526_))
                                         (let ((__tmp16808
                                                (let ()
                                                  (declare (not safe))
                                                  (std/actor-v18/ensemble#remote-load-library-module__0
                                                   _server-id5507_
                                                   _lib5526_))))
                                           (declare (not safe))
                                           (displayln __tmp16808))))
                                      (_lib5531_ _val55145519_))
                                 (declare (not safe))
                                 (_K55175528_ _lib5531_)))))
                        (if (let ()
                              (declare (not safe))
                              (pair? _iterable5533_))
                            (for-each _iter-do5535_ _iterable5533_)
                            (if (let ()
                                  (declare (not safe))
                                  (null? _iterable5533_))
                                '#!void
                                (let* ((_it5538_
                                        (let ()
                                          (declare (not safe))
                                          (std/iter#iter _iterable5533_)))
                                       (_next!5541_
                                        (let ()
                                          (declare (not safe))
                                          (##unchecked-structure-ref
                                           _it5538_
                                           '2
                                           std/iter#iterator::t
                                           '#f))))
                                  (declare (not safe))
                                  (begin
                                    (let _lp5546_ ()
                                      (let ((_val5550_ (_next!5541_ _it5538_)))
                                        (if (eq? std/iter#iter-end _val5550_)
                                            '#!void
                                            (begin
                                              (_iter-do5535_ _val5550_)
                                              (_lp5546_)))))
                                    (let ((_$e5552_
                                           (##unchecked-structure-ref
                                            _it5538_
                                            '3
                                            std/iter#iterator::t
                                            '#f)))
                                      (if _$e5552_
                                          ((lambda (_g55545556_)
                                             (_g55545556_ _it5538_))
                                           _$e5552_)
                                          '#!void))
                                    '#!void))))))
                  (let ((_iterable5580_ _object-files5509_)
                        (_iter-do5582_
                         (lambda (_val5559_)
                           (let* ((_val55615566_ _val5559_)
                                  (_E55635570_
                                   (lambda ()
                                     (let ()
                                       (declare (not safe))
                                       (error '"No clause matching"
                                              _val55615566_))))
                                  (_K55645575_
                                   (lambda (_object-file5573_)
                                     (let ()
                                       (declare (not safe))
                                       (displayln
                                        '"... loading code object file "
                                        _object-file5573_))
                                     (let ((__tmp16809
                                            (let ()
                                              (declare (not safe))
                                              (std/actor-v18/ensemble#remote-load-code__0
                                               _server-id5507_
                                               _object-file5573_))))
                                       (declare (not safe))
                                       (displayln __tmp16809))))
                                  (_object-file5578_ _val55615566_))
                             (declare (not safe))
                             (_K55645575_ _object-file5578_)))))
                    (if (let () (declare (not safe)) (pair? _iterable5580_))
                        (for-each _iter-do5582_ _iterable5580_)
                        (if (let ()
                              (declare (not safe))
                              (null? _iterable5580_))
                            '#!void
                            (let* ((_it5585_
                                    (let ()
                                      (declare (not safe))
                                      (std/iter#iter _iterable5580_)))
                                   (_next!5588_
                                    (let ()
                                      (declare (not safe))
                                      (##unchecked-structure-ref
                                       _it5585_
                                       '2
                                       std/iter#iterator::t
                                       '#f))))
                              (declare (not safe))
                              (begin
                                (let _lp5593_ ()
                                  (let ((_val5597_ (_next!5588_ _it5585_)))
                                    (if (eq? std/iter#iter-end _val5597_)
                                        '#!void
                                        (begin
                                          (_iter-do5582_ _val5597_)
                                          (_lp5593_)))))
                                (let ((_$e5599_
                                       (##unchecked-structure-ref
                                        _it5585_
                                        '3
                                        std/iter#iterator::t
                                        '#f)))
                                  (if _$e5599_
                                      ((lambda (_g56015603_)
                                         (_g56015603_ _it5585_))
                                       _$e5599_)
                                      '#!void))
                                '#!void)))))
                  (let ()
                    (declare (not safe))
                    (std/actor-v18/server#stop-actor-server!__0)))))))))
    (define gerbil/tools/gxensemble#find-object-file
      (lambda (_ctx-or-id5501_)
        (if (let ()
              (declare (not safe))
              (##structure-instance-of? _ctx-or-id5501_ 'gx#module-context::t))
            (let ((__tmp16810
                   (##structure-ref
                    _ctx-or-id5501_
                    '1
                    gx#expander-context::t
                    '#f)))
              (declare (not safe))
              (gerbil/tools/gxensemble#find-object-file __tmp16810))
            (find-library-module
             (string-append
              (let ()
                (declare (not safe))
                (gerbil/tools/gxensemble#module-id->string _ctx-or-id5501_))
              '"__0")))))
    (define gerbil/tools/gxensemble#module-id->string
      (lambda (_module-id5497_)
        (let ((_mod-str5499_ (symbol->string _module-id5497_)))
          (if (let () (declare (not safe)) (string-prefix? '":" _mod-str5499_))
              (substring _mod-str5499_ '1 (string-length _mod-str5499_))
              _mod-str5499_))))
    (define gerbil/tools/gxensemble#get-module-objects
      (lambda (_module-id5342_ _library-prefix5343_)
        (letrec ((_fold-modules5345_
                  (lambda (_r5440_ _q5441_)
                    (let ((_iterable5465_ _q5441_)
                          (_iter-do5467_
                           (lambda (_val5443_ _r5445_)
                             (let* ((_val54465451_ _val5443_)
                                    (_E54485455_
                                     (lambda ()
                                       (let ()
                                         (declare (not safe))
                                         (error '"No clause matching"
                                                _val54465451_))))
                                    (_K54495460_
                                     (lambda (_in5458_)
                                       (if (let ()
                                             (declare (not safe))
                                             (##structure-instance-of?
                                              _in5458_
                                              'gx#module-context::t))
                                           (let ((__tmp16818
                                                  (let ()
                                                    (declare (not safe))
                                                    (cons _in5458_ _r5445_)))
                                                 (__tmp16815
                                                  (let ((__tmp16817
                                                         (let ()
                                                           (declare (not safe))
                                                           (gx#core-context-prelude__%
                                                            _in5458_)))
                                                        (__tmp16816
                                                         (##structure-ref
                                                          _in5458_
                                                          '8
                                                          gx#module-context::t
                                                          '#f)))
                                                    (declare (not safe))
                                                    (cons __tmp16817
                                                          __tmp16816))))
                                             (declare (not safe))
                                             (_fold-modules5345_
                                              __tmp16818
                                              __tmp16815))
                                           (if (let ()
                                                 (declare (not safe))
                                                 (##structure-instance-of?
                                                  _in5458_
                                                  'gx#prelude-context::t))
                                               (let ()
                                                 (declare (not safe))
                                                 (cons _in5458_ _r5445_))
                                               (if (let ()
                                                     (declare (not safe))
                                                     (##structure-direct-instance-of?
                                                      _in5458_
                                                      'gx#module-import::t))
                                                   (if (= (##direct-structure-ref
                                                           _in5458_
                                                           '3
                                                           gx#module-import::t
                                                           '#f)
                                                          '0)
                                                       (let ((__tmp16813
                                                              (let ((__tmp16814
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                             (##direct-structure-ref
                              _in5458_
                              '1
                              gx#module-import::t
                              '#f)))
                        (declare (not safe))
                        (cons __tmp16814 '()))))
                 (declare (not safe))
                 (_fold-modules5345_ _r5445_ __tmp16813))
               _r5445_)
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (if (let ()
                                                         (declare (not safe))
                                                         (##structure-direct-instance-of?
                                                          _in5458_
                                                          'gx#import-set::t))
                                                       (if (= (##direct-structure-ref
                                                               _in5458_
                                                               '2
                                                               gx#import-set::t
                                                               '#f)
                                                              '0)
                                                           (let ((__tmp16811
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (let ((__tmp16812
                                 (##direct-structure-ref
                                  _in5458_
                                  '1
                                  gx#import-set::t
                                  '#f)))
                            (declare (not safe))
                            (cons __tmp16812 '()))))
                     (declare (not safe))
                     (_fold-modules5345_ _r5445_ __tmp16811))
                   _r5445_)
               _r5445_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                    (_in5463_ _val54465451_))
                               (declare (not safe))
                               (_K54495460_ _in5463_))))
                          (_r5469_ _r5440_))
                      (if (let () (declare (not safe)) (pair? _iterable5465_))
                          (let ()
                            (declare (not safe))
                            (foldl1 _iter-do5467_ _r5469_ _iterable5465_))
                          (if (let ()
                                (declare (not safe))
                                (null? _iterable5465_))
                              _r5469_
                              (let* ((_it5471_
                                      (let ()
                                        (declare (not safe))
                                        (std/iter#iter _iterable5465_)))
                                     (_next!5474_
                                      (let ()
                                        (declare (not safe))
                                        (##unchecked-structure-ref
                                         _it5471_
                                         '2
                                         std/iter#iterator::t
                                         '#f))))
                                (declare (not safe))
                                (let _lp5479_ ((_rval5482_ _r5469_))
                                  (let ((_val5485_ (_next!5474_ _it5471_)))
                                    (if (eq? std/iter#iter-end _val5485_)
                                        (begin
                                          (let ((_$e5487_
                                                 (##unchecked-structure-ref
                                                  _it5471_
                                                  '3
                                                  std/iter#iterator::t
                                                  '#f)))
                                            (if _$e5487_
                                                ((lambda (_g54895491_)
                                                   (_g54895491_ _it5471_))
                                                 _$e5487_)
                                                '#!void))
                                          _rval5482_)
                                        (let ((_xval5494_
                                               (_iter-do5467_
                                                _val5485_
                                                _rval5482_)))
                                          (_lp5479_ _xval5494_))))))))))))
          (let* ((_library-prefix-str5347_
                  (map symbol->string _library-prefix5343_))
                 (_ctx5349_
                  (let ()
                    (declare (not safe))
                    (gx#import-module__0 _module-id5342_)))
                 (_modules5351_
                  (let ((__tmp16819
                         (let () (declare (not safe)) (cons _ctx5349_ '()))))
                    (declare (not safe))
                    (_fold-modules5345_ '() __tmp16819))))
            (let _lp5354_ ((_rest5356_ _modules5351_)
                           (_to-load5357_ '())
                           (_libraries5358_ '()))
              (let* ((_rest53595367_ _rest5356_)
                     (_else53615413_
                      (lambda ()
                        (let _lp5375_ ((_rest5377_ _to-load5357_)
                                       (_object-files5378_ '()))
                          (let* ((_rest53795387_ _rest5377_)
                                 (_else53815395_
                                  (lambda ()
                                    (values _object-files5378_
                                            (reverse _libraries5358_))))
                                 (_K53835401_
                                  (lambda (_rest5398_ _ctx-id5399_)
                                    (let ((__tmp16820
                                           (let ((__tmp16821
                                                  (let ()
                                                    (declare (not safe))
                                                    (gerbil/tools/gxensemble#find-object-file
                                                     _ctx-id5399_))))
                                             (declare (not safe))
                                             (cons __tmp16821
                                                   _object-files5378_))))
                                      (declare (not safe))
                                      (_lp5375_ _rest5398_ __tmp16820)))))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _rest53795387_))
                                (let ((_hd53845404_
                                       (let ()
                                         (declare (not safe))
                                         (##car _rest53795387_)))
                                      (_tl53855406_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _rest53795387_))))
                                  (let* ((_ctx-id5409_ _hd53845404_)
                                         (_rest5411_ _tl53855406_))
                                    (declare (not safe))
                                    (_K53835401_ _rest5411_ _ctx-id5409_)))
                                (let ()
                                  (declare (not safe))
                                  (_else53815395_)))))))
                     (_K53635428_
                      (lambda (_rest5416_ _ctx5417_)
                        (let* ((_ctx-id5419_
                                (##structure-ref
                                 _ctx5417_
                                 '1
                                 gx#expander-context::t
                                 '#f))
                               (_ctx-id-str5421_
                                (if _ctx-id5419_
                                    (symbol->string _ctx-id5419_)
                                    '#f)))
                          (if (let () (declare (not safe)) (not _ctx-id5419_))
                              (let ()
                                (declare (not safe))
                                (_lp5354_
                                 _rest5416_
                                 _to-load5357_
                                 _libraries5358_))
                              (if (let ()
                                    (declare (not safe))
                                    (string-prefix?
                                     '"gerbil/"
                                     _ctx-id-str5421_))
                                  (let ()
                                    (declare (not safe))
                                    (_lp5354_
                                     _rest5416_
                                     _to-load5357_
                                     _libraries5358_))
                                  (if (let ((__tmp16823
                                             (lambda (_g54235425_)
                                               (let ()
                                                 (declare (not safe))
                                                 (string-prefix?
                                                  _g54235425_
                                                  _ctx-id-str5421_)))))
                                        (declare (not safe))
                                        (find __tmp16823
                                              _library-prefix-str5347_))
                                      (let ()
                                        (declare (not safe))
                                        (_lp5354_
                                         _rest5416_
                                         _to-load5357_
                                         _libraries5358_))
                                      (if (member _ctx-id5419_ _to-load5357_)
                                          (let ()
                                            (declare (not safe))
                                            (_lp5354_
                                             _rest5416_
                                             _to-load5357_
                                             _libraries5358_))
                                          (let ((__tmp16822
                                                 (let ()
                                                   (declare (not safe))
                                                   (cons _ctx-id5419_
                                                         _to-load5357_))))
                                            (declare (not safe))
                                            (_lp5354_
                                             _rest5416_
                                             __tmp16822
                                             _libraries5358_))))))))))
                (if (let () (declare (not safe)) (##pair? _rest53595367_))
                    (let ((_hd53645431_
                           (let ()
                             (declare (not safe))
                             (##car _rest53595367_)))
                          (_tl53655433_
                           (let ()
                             (declare (not safe))
                             (##cdr _rest53595367_))))
                      (let* ((_ctx5436_ _hd53645431_)
                             (_rest5438_ _tl53655433_))
                        (declare (not safe))
                        (_K53635428_ _rest5438_ _ctx5436_)))
                    (let () (declare (not safe)) (_else53615413_)))))))))
    (define gerbil/tools/gxensemble#do-registry
      (lambda (_opt5339_)
        (let ((__tmp16829
               (let () (declare (not safe)) (table-ref _opt5339_ 'logging)))
              (__tmp16828
               (let ()
                 (declare (not safe))
                 (table-ref _opt5339_ 'logging-file)))
              (__tmp16827
               (let () (declare (not safe)) (table-ref _opt5339_ 'listen)))
              (__tmp16826
               (let () (declare (not safe)) (table-ref _opt5339_ 'announce)))
              (__tmp16825
               (let ()
                 (declare (not safe))
                 (std/actor-v18/cookie#get-actor-server-cookie__0)))
              (__tmp16824
               (lambda ()
                 (let ()
                   (declare (not safe))
                   (std/actor-v18/registry#start-ensemble-registry!__0)))))
          (declare (not safe))
          (std/actor-v18/api#call-with-ensemble-server__%
           '#f
           __tmp16829
           __tmp16828
           __tmp16827
           __tmp16826
           '#f
           '#f
           absent-value
           __tmp16825
           absent-value
           absent-value
           'registry
           __tmp16824))))
    (define gerbil/tools/gxensemble#do-run
      (lambda (_opt5333_)
        (let ((_module-main5335_
               (let ((__tmp16830
                      (let ()
                        (declare (not safe))
                        (table-ref _opt5333_ 'module-id))))
                 (declare (not safe))
                 (gerbil/tools/gxensemble#get-module-main __tmp16830)))
              (_main-args5336_
               (let () (declare (not safe)) (table-ref _opt5333_ 'main-args))))
          (let ((__tmp16839
                 (let () (declare (not safe)) (table-ref _opt5333_ 'logging)))
                (__tmp16838
                 (let ()
                   (declare (not safe))
                   (table-ref _opt5333_ 'logging-file)))
                (__tmp16837
                 (let () (declare (not safe)) (table-ref _opt5333_ 'listen)))
                (__tmp16836
                 (let () (declare (not safe)) (table-ref _opt5333_ 'announce)))
                (__tmp16835
                 (let () (declare (not safe)) (table-ref _opt5333_ 'registry)))
                (__tmp16834
                 (let () (declare (not safe)) (table-ref _opt5333_ 'roles)))
                (__tmp16833
                 (let ()
                   (declare (not safe))
                   (std/actor-v18/cookie#get-actor-server-cookie__0)))
                (__tmp16832
                 (let ()
                   (declare (not safe))
                   (table-ref _opt5333_ 'server-id)))
                (__tmp16831
                 (lambda () (apply _module-main5335_ _main-args5336_))))
            (declare (not safe))
            (std/actor-v18/api#call-with-ensemble-server__%
             '#f
             __tmp16839
             __tmp16838
             __tmp16837
             __tmp16836
             __tmp16835
             __tmp16834
             absent-value
             __tmp16833
             absent-value
             absent-value
             __tmp16832
             __tmp16831)))))
    (define gerbil/tools/gxensemble#get-module-main
      (lambda (_module-id5276_)
        (letrec ((_runtime-export?5278_
                  (lambda (_exported5331_)
                    (= (##direct-structure-ref
                        _exported5331_
                        '3
                        gx#module-export::t
                        '#f)
                       '0))))
          (gerbil-load-expander!)
          (let ((_ctx5280_
                 (let ()
                   (declare (not safe))
                   (gx#import-module__% _module-id5276_ '#f '#t))))
            (call-with-current-continuation
             (lambda (_return5282_)
               (let ((_iterable5305_
                      (##structure-ref _ctx5280_ '9 gx#module-context::t '#f))
                     (_iter-do5307_
                      (lambda (_val5284_)
                        (let* ((_val52865291_ _val5284_)
                               (_E52885295_
                                (lambda ()
                                  (let ()
                                    (declare (not safe))
                                    (error '"No clause matching"
                                           _val52865291_))))
                               (_K52895300_
                                (lambda (_exported5298_)
                                  (if (and (let ()
                                             (declare (not safe))
                                             (_runtime-export?5278_
                                              _exported5298_))
                                           (let ((__tmp16840
                                                  (##direct-structure-ref
                                                   _exported5298_
                                                   '4
                                                   gx#module-export::t
                                                   '#f)))
                                             (declare (not safe))
                                             (eq? __tmp16840 'main)))
                                      (_return5282_
                                       (eval (##structure-ref
                                              (let ()
                                                (declare (not safe))
                                                (gx#core-resolve-module-export
                                                 _exported5298_))
                                              '1
                                              gx#binding::t
                                              '#f)))
                                      '#!void)))
                               (_exported5303_ _val52865291_))
                          (declare (not safe))
                          (_K52895300_ _exported5303_)))))
                 (if (let () (declare (not safe)) (pair? _iterable5305_))
                     (for-each _iter-do5307_ _iterable5305_)
                     (if (let () (declare (not safe)) (null? _iterable5305_))
                         '#!void
                         (let* ((_it5310_
                                 (let ()
                                   (declare (not safe))
                                   (std/iter#iter _iterable5305_)))
                                (_next!5313_
                                 (let ()
                                   (declare (not safe))
                                   (##unchecked-structure-ref
                                    _it5310_
                                    '2
                                    std/iter#iterator::t
                                    '#f))))
                           (declare (not safe))
                           (begin
                             (let _lp5318_ ()
                               (let ((_val5322_ (_next!5313_ _it5310_)))
                                 (if (eq? std/iter#iter-end _val5322_)
                                     '#!void
                                     (begin
                                       (_iter-do5307_ _val5322_)
                                       (_lp5318_)))))
                             (let ((_$e5324_
                                    (##unchecked-structure-ref
                                     _it5310_
                                     '3
                                     std/iter#iterator::t
                                     '#f)))
                               (if _$e5324_
                                   ((lambda (_g53265328_)
                                      (_g53265328_ _it5310_))
                                    _$e5324_)
                                   '#!void))
                             '#!void)))))
               (let ()
                 (declare (not safe))
                 (error '"module does not export main" _module-id5276_))))))))
    (define gerbil/tools/gxensemble#display-result-list
      (lambda (_lst5227_)
        (let ((_iterable5250_ _lst5227_)
              (_iter-do5252_
               (lambda (_val5229_)
                 (let* ((_val52315236_ _val5229_)
                        (_E52335240_
                         (lambda ()
                           (let ()
                             (declare (not safe))
                             (error '"No clause matching" _val52315236_))))
                        (_K52345245_
                         (lambda (_result5243_)
                           (let ()
                             (declare (not safe))
                             (gerbil/tools/gxensemble#display-result
                              _result5243_))))
                        (_result5248_ _val52315236_))
                   (declare (not safe))
                   (gerbil/tools/gxensemble#display-result _result5248_)))))
          (if (let () (declare (not safe)) (pair? _iterable5250_))
              (for-each _iter-do5252_ _iterable5250_)
              (if (let () (declare (not safe)) (null? _iterable5250_))
                  '#!void
                  (let* ((_it5255_
                          (let ()
                            (declare (not safe))
                            (std/iter#iter _iterable5250_)))
                         (_next!5258_
                          (let ()
                            (declare (not safe))
                            (##unchecked-structure-ref
                             _it5255_
                             '2
                             std/iter#iterator::t
                             '#f))))
                    (declare (not safe))
                    (begin
                      (let _lp5263_ ()
                        (let ((_val5267_ (_next!5258_ _it5255_)))
                          (if (eq? std/iter#iter-end _val5267_)
                              '#!void
                              (begin (_iter-do5252_ _val5267_) (_lp5263_)))))
                      (let ((_$e5269_
                             (##unchecked-structure-ref
                              _it5255_
                              '3
                              std/iter#iterator::t
                              '#f)))
                        (if _$e5269_
                            ((lambda (_g52715273_) (_g52715273_ _it5255_))
                             _$e5269_)
                            '#!void))
                      '#!void)))))))
    (define gerbil/tools/gxensemble#display-result
      (lambda (_result5225_) (write _result5225_) (newline)))
    (define gerbil/tools/gxensemble#string->object
      (lambda (_str5223_) (call-with-input-string _str5223_ read)))
    (define gerbil/tools/gxensemble#start-actor-server-with-options!
      (lambda (_opt5198_)
        (let ((_$e5200_
               (let ()
                 (declare (not safe))
                 (table-ref _opt5198_ 'logging '#f))))
          (if _$e5200_ (std/logger#current-logger-options _$e5200_) '#!void))
        (let* ((_known-servers5214_
                (let ((_$e5203_
                       (let ()
                         (declare (not safe))
                         (table-ref _opt5198_ 'registry '#f))))
                  (if _$e5203_
                      ((lambda (_addrs5206_)
                         (let ((_ht5208_
                                (let ()
                                  (declare (not safe))
                                  (make-table 'test: eq? 'size: '1))))
                           (let ((__tmp16842
                                  (append (let ()
                                            (declare (not safe))
                                            (std/actor-v18/server#default-registry-addresses))
                                          _addrs5206_)))
                             (declare (not safe))
                             (table-set! _ht5208_ 'registry __tmp16842))
                           _ht5208_))
                       _$e5203_)
                      (let ((_ht5211_
                             (let ()
                               (declare (not safe))
                               (make-table 'test: eq? 'size: '1))))
                        (let ((__tmp16841
                               (let ()
                                 (declare (not safe))
                                 (std/actor-v18/server#default-registry-addresses))))
                          (declare (not safe))
                          (table-set! _ht5211_ 'registry __tmp16841))
                        _ht5211_))))
               (_server-id5216_
                (let () (declare (not safe)) (table-ref _opt5198_ 'console)))
               (_listen-addrs5218_
                (let ()
                  (declare (not safe))
                  (table-ref _opt5198_ 'listen '())))
               (_cookie5220_
                (let ()
                  (declare (not safe))
                  (std/actor-v18/cookie#get-actor-server-cookie__0))))
          (let ()
            (declare (not safe))
            (std/actor-v18/server#start-actor-server!__%
             '#f
             _server-id5216_
             absent-value
             _cookie5220_
             absent-value
             absent-value
             _listen-addrs5218_
             _known-servers5214_)))))
    (define gerbil/tools/gxensemble#+admin-privkey+ '#f)
    (define gerbil/tools/gxensemble#get-privkey
      (lambda ()
        (let ((_$e5190_ gerbil/tools/gxensemble#+admin-privkey+))
          (if _$e5190_
              _$e5190_
              (if (file-exists?
                   (let ()
                     (declare (not safe))
                     (std/actor-v18/admin#default-admin-privkey-path)))
                  (let* ((_passphrase5193_
                          (let ()
                            (declare (not safe))
                            (std/misc/ports#read-password__%__0
                             '#f
                             '"Enter administrative passphrase: ")))
                         (_privk5195_
                          (let ()
                            (declare (not safe))
                            (std/actor-v18/admin#get-admin-privkey__0
                             _passphrase5193_))))
                    (set! gerbil/tools/gxensemble#+admin-privkey+ _privk5195_)
                    _privk5195_)
                  (let ()
                    (declare (not safe))
                    (error '"no administrative private key")))))))
    (define gerbil/tools/gxensemble#maybe-authorize!
      (lambda (_server-id5183_)
        (let ((_addr5185_
               (let ()
                 (declare (not safe))
                 (std/actor-v18/server#connect-to-server!__0
                  _server-id5183_))))
          (if (let ((__tmp16844 (car _addr5185_)))
                (declare (not safe))
                (eq? 'tls: __tmp16844))
              '#!void
              (if (file-exists?
                   (let ()
                     (declare (not safe))
                     (std/actor-v18/admin#default-admin-privkey-path)))
                  (let* ((_privk5187_
                          (let ()
                            (declare (not safe))
                            (gerbil/tools/gxensemble#get-privkey)))
                         (__tmp16843
                          (let ()
                            (declare (not safe))
                            (std/actor-v18/server#actor-server-identifier__0))))
                    (declare (not safe))
                    (std/actor-v18/ensemble#admin-authorize__%__0
                     '#f
                     absent-value
                     gerbil/tools/gxensemble#+admin-privkey+
                     _server-id5183_
                     __tmp16843))
                  '#!void)))))))
