(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/actor-v18/tls::timestamp 1701959742)
  (begin
    (define std/actor-v18/tls#current-time-seconds
      (lambda () (inexact->exact (floor (time->seconds (current-time))))))
    (define std/actor-v18/tls#ensemble-tls-base-path
      (lambda ()
        (path-expand
         '"tls"
         (let ()
           (declare (not safe))
           (std/actor-v18/path#ensemble-base-path)))))
    (define std/actor-v18/tls#ensemble-tls-server-path
      (lambda (_server-id610948_)
        (path-expand
         '"tls"
         (let ()
           (declare (not safe))
           (std/actor-v18/path#ensemble-server-path _server-id610948_)))))
    (define std/actor-v18/tls#ensemble-tls-cafile
      (lambda ()
        (path-expand
         '"ca.pem"
         (let ()
           (declare (not safe))
           (std/actor-v18/tls#ensemble-tls-base-path)))))
    (define std/actor-v18/tls#ensemble-tls-caroot
      (lambda ()
        (path-expand
         '"caroot.pem"
         (let ()
           (declare (not safe))
           (std/actor-v18/tls#ensemble-tls-base-path)))))
    (define std/actor-v18/tls#ensemble-tls-capath
      (lambda ()
        (path-expand
         '"ca-certificates"
         (let ()
           (declare (not safe))
           (std/actor-v18/tls#ensemble-tls-base-path)))))
    (define std/actor-v18/tls#get-actor-tls-context
      (lambda (_server-id610930_)
        (let* ((_cafile610932_
                (let ()
                  (declare (not safe))
                  (std/actor-v18/tls#ensemble-tls-cafile)))
               (_caroot610934_
                (let ()
                  (declare (not safe))
                  (std/actor-v18/tls#ensemble-tls-caroot)))
               (_capath610936_
                (let ()
                  (declare (not safe))
                  (std/actor-v18/tls#ensemble-tls-capath)))
               (_server-base610938_
                (let ()
                  (declare (not safe))
                  (std/actor-v18/tls#ensemble-tls-server-path
                   _server-id610930_)))
               (_chain.pem610940_
                (path-expand '"chain.pem" _server-base610938_))
               (_server.key610942_
                (path-expand '"server.key" _server-base610938_)))
          (if (let ((__tmp41657
                     (let ((__tmp41658
                            (let ((__tmp41659
                                   (let ((__tmp41660
                                          (let ()
                                            (declare (not safe))
                                            (cons _server.key610942_ '()))))
                                     (declare (not safe))
                                     (cons _chain.pem610940_ __tmp41660))))
                              (declare (not safe))
                              (cons _server-base610938_ __tmp41659))))
                       (declare (not safe))
                       (cons _cafile610932_ __tmp41658))))
                (declare (not safe))
                (andmap1 file-exists? __tmp41657))
              (std/net/ssl/libssl#make-actor-tls-context
               _caroot610934_
               _cafile610932_
               _capath610936_
               _chain.pem610940_
               _server.key610942_)
              '#f))))
    (define std/actor-v18/tls#actor-tls-certificate-id
      (lambda (_x509610926_)
        (let ((_name610928_
               (std/net/ssl/libssl#X509_get_subject_name _x509610926_)))
          (if _name610928_
              (string->symbol
               (car (let ()
                      (declare (not safe))
                      (string-split _name610928_ '#\.))))
              '#f))))
    (define std/actor-v18/tls#actor-tls-certificate-cap
      (lambda (_x509610920_)
        (let ((_san-uris610922_
               (std/net/ssl/libssl#X509_get_san_uris _x509610920_)))
          (if _san-uris610922_
              (let ((__tmp41662
                     (lambda (_x610924_)
                       (if (let ()
                             (declare (not safe))
                             (string-prefix? '"cap:" _x610924_))
                           (string->symbol
                            (substring
                             _x610924_
                             (string-length '"cap:")
                             (string-length _x610924_)))
                           '#f)))
                    (__tmp41661
                     (let ()
                       (declare (not safe))
                       (string-split _san-uris610922_ '#\,))))
                (declare (not safe))
                (filter-map1 __tmp41662 __tmp41661))
              '#f))))
    (define std/actor-v18/tls#actor-tls-domain
      (lambda ()
        (let ((__tmp41663
               (path-expand
                '"domain"
                (let ()
                  (declare (not safe))
                  (std/actor-v18/tls#ensemble-tls-base-path)))))
          (declare (not safe))
          (std/misc/ports#read-file-string__% '#f absent-value __tmp41663))))
    (define std/actor-v18/tls#actor-tls-host
      (lambda (_server-id610915_)
        (let ((_domain610917_
               (let ()
                 (declare (not safe))
                 (std/actor-v18/tls#actor-tls-domain))))
          (string-append
           (symbol->string _server-id610915_)
           '"."
           _domain610917_))))
    (define std/actor-v18/tls#generate-actor-tls-root-ca!__%
      (lambda (_g41664_
               _domain610764610770_
               _country-name610765610772_
               _organization-name610766610774_
               _common-name610767610776_
               _root-ca-passphrase610778_)
        (let* ((_domain610780_
                (if (let ()
                      (declare (not safe))
                      (eq? _domain610764610770_ absent-value))
                    '"ensemble.local"
                    _domain610764610770_))
               (_country-name610782_
                (if (let ()
                      (declare (not safe))
                      (eq? _country-name610765610772_ absent-value))
                    '"UN"
                    _country-name610765610772_))
               (_organization-name610784_
                (if (let ()
                      (declare (not safe))
                      (eq? _organization-name610766610774_ absent-value))
                    '"Mighty Gerbils"
                    _organization-name610766610774_))
               (_common-name610786_
                (if (let ()
                      (declare (not safe))
                      (eq? _common-name610767610776_ absent-value))
                    (string-append _organization-name610784_ '" Root CA")
                    _common-name610767610776_))
               (_base-path610788_
                (let ()
                  (declare (not safe))
                  (std/actor-v18/tls#ensemble-tls-base-path)))
               (_root-ca-path610790_
                (path-expand '"root-ca" _base-path610788_))
               (_root-ca.conf610792_
                (path-expand '"root-ca.conf" _root-ca-path610790_))
               (_root-ca.key610794_
                (path-expand '"private/root-ca.key" _root-ca-path610790_))
               (_root-ca.csr610796_
                (path-expand '"root-ca.csr" _root-ca-path610790_))
               (_root-ca.crt610798_
                (path-expand '"root-ca.crt" _root-ca-path610790_))
               (_ca-certificates610800_
                (path-expand '"ca-certificates" _base-path610788_)))
          (if (file-exists? _root-ca-path610790_)
              (let ()
                (declare (not safe))
                (error '"root-ca already exists" _root-ca-path610790_))
              '#!void)
          (let () (declare (not safe)) (create-directory* _base-path610788_))
          (let ((__tmp41665 (path-expand '"domain" _base-path610788_)))
            (declare (not safe))
            (std/misc/ports#write-file-string__%
             '#f
             absent-value
             absent-value
             __tmp41665
             _domain610780_))
          (let ()
            (declare (not safe))
            (create-directory* _root-ca-path610790_))
          (let ((_iterable610824_ '("certs" "db"))
                (_iter-do610826_
                 (lambda (_val610803_)
                   (let* ((_val610805610810_ _val610803_)
                          (_E610807610814_
                           (lambda ()
                             (let ()
                               (declare (not safe))
                               (error '"No clause matching"
                                      _val610805610810_))))
                          (_K610808610819_
                           (lambda (_dir610817_)
                             (let ((__tmp41666
                                    (path-expand
                                     _dir610817_
                                     _root-ca-path610790_)))
                               (declare (not safe))
                               (create-directory* __tmp41666))))
                          (_dir610822_ _val610805610810_))
                     (declare (not safe))
                     (_K610808610819_ _dir610822_)))))
            (if (let () (declare (not safe)) (pair? _iterable610824_))
                (for-each _iter-do610826_ _iterable610824_)
                (if (let () (declare (not safe)) (null? _iterable610824_))
                    '#!void
                    (let* ((_it610829_
                            (let ()
                              (declare (not safe))
                              (std/iter#iter _iterable610824_)))
                           (_next!610832_
                            (let ()
                              (declare (not safe))
                              (##unchecked-structure-ref
                               _it610829_
                               '2
                               std/iter#iterator::t
                               '#f))))
                      (declare (not safe))
                      (begin
                        (let _lp610837_ ()
                          (let ((_val610841_ (_next!610832_ _it610829_)))
                            (if (eq? std/iter#iter-end _val610841_)
                                '#!void
                                (begin
                                  (_iter-do610826_ _val610841_)
                                  (_lp610837_)))))
                        (let ((_$e610843_
                               (##unchecked-structure-ref
                                _it610829_
                                '3
                                std/iter#iterator::t
                                '#f)))
                          (if _$e610843_
                              ((lambda (_g610845610847_)
                                 (_g610845610847_ _it610829_))
                               _$e610843_)
                              '#!void))
                        '#!void)))))
          (let ((_iterable610871_ '("private"))
                (_iter-do610873_
                 (lambda (_val610850_)
                   (let* ((_val610852610857_ _val610850_)
                          (_E610854610861_
                           (lambda ()
                             (let ()
                               (declare (not safe))
                               (error '"No clause matching"
                                      _val610852610857_))))
                          (_K610855610866_
                           (lambda (_dir610864_)
                             (let ((__tmp41667
                                    (path-expand
                                     _dir610864_
                                     _root-ca-path610790_)))
                               (declare (not safe))
                               (create-directory* __tmp41667 '448))))
                          (_dir610869_ _val610852610857_))
                     (declare (not safe))
                     (_K610855610866_ _dir610869_)))))
            (if (let () (declare (not safe)) (pair? _iterable610871_))
                (for-each _iter-do610873_ _iterable610871_)
                (if (let () (declare (not safe)) (null? _iterable610871_))
                    '#!void
                    (let* ((_it610876_
                            (let ()
                              (declare (not safe))
                              (std/iter#iter _iterable610871_)))
                           (_next!610879_
                            (let ()
                              (declare (not safe))
                              (##unchecked-structure-ref
                               _it610876_
                               '2
                               std/iter#iterator::t
                               '#f))))
                      (declare (not safe))
                      (begin
                        (let _lp610884_ ()
                          (let ((_val610888_ (_next!610879_ _it610876_)))
                            (if (eq? std/iter#iter-end _val610888_)
                                '#!void
                                (begin
                                  (_iter-do610873_ _val610888_)
                                  (_lp610884_)))))
                        (let ((_$e610890_
                               (##unchecked-structure-ref
                                _it610876_
                                '3
                                std/iter#iterator::t
                                '#f)))
                          (if _$e610890_
                              ((lambda (_g610892610894_)
                                 (_g610892610894_ _it610876_))
                               _$e610890_)
                              '#!void))
                        '#!void)))))
          (let ((__tmp41668 (path-expand '"db/index" _root-ca-path610790_)))
            (declare (not safe))
            (std/misc/ports#write-file-string__%
             '#f
             absent-value
             absent-value
             __tmp41668
             '""))
          (let ((__tmp41673 (path-expand '"db/serial" _root-ca-path610790_))
                (__tmp41669
                 (let ((__tmp41670
                        (let ((__tmp41671
                               (let ((__tmp41672
                                      (let ()
                                        (declare (not safe))
                                        (cons '"16" '()))))
                                 (declare (not safe))
                                 (cons '"-hex" __tmp41672))))
                          (declare (not safe))
                          (cons '"rand" __tmp41671))))
                   (declare (not safe))
                   (std/misc/process#invoke__%
                    '#f
                    '#t
                    absent-value
                    absent-value
                    absent-value
                    absent-value
                    absent-value
                    absent-value
                    absent-value
                    '"openssl"
                    __tmp41670))))
            (declare (not safe))
            (std/misc/ports#write-file-string__%
             '#f
             absent-value
             absent-value
             __tmp41673
             __tmp41669))
          (let ((__tmp41674
                 (path-expand '"db/crlnumber" _root-ca-path610790_)))
            (declare (not safe))
            (std/misc/ports#write-file-string__%
             '#f
             absent-value
             absent-value
             __tmp41674
             '"1001"))
          (let ()
            (declare (not safe))
            (displayln '"... generate " _root-ca.conf610792_))
          (call-with-output-file
           _root-ca.conf610792_
           (lambda (_g610896610898_)
             (let ()
               (declare (not safe))
               (std/misc/template#write-template
                std/actor-v18/tls#root-ca.conf-template
                _g610896610898_
                'domain:
                _domain610780_
                'country-name:
                _country-name610782_
                'organization-name:
                _organization-name610784_
                'common-name:
                _common-name610786_
                'home:
                _root-ca-path610790_))))
          (let ()
            (declare (not safe))
            (displayln
             '"... generate "
             _root-ca.csr610796_
             '" "
             _root-ca.key610794_))
          (let ((__tmp41675
                 (let ((__tmp41676
                        (let ((__tmp41677
                               (let ((__tmp41678
                                      (let ((__tmp41679
                                             (let ((__tmp41680
                                                    (let ((__tmp41681
                                                           (let ((__tmp41682
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (let ((__tmp41683
                                 (let ((__tmp41684
                                        (let ((__tmp41685
                                               (string-append
                                                '"pass:"
                                                _root-ca-passphrase610778_)))
                                          (declare (not safe))
                                          (cons __tmp41685 '()))))
                                   (declare (not safe))
                                   (cons '"-passout" __tmp41684))))
                            (declare (not safe))
                            (cons _root-ca.key610794_ __tmp41683))))
                     (declare (not safe))
                     (cons '"-keyout" __tmp41682))))
              (declare (not safe))
              (cons _root-ca.csr610796_ __tmp41681))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                               (declare (not safe))
                                               (cons '"-out" __tmp41680))))
                                        (declare (not safe))
                                        (cons _root-ca.conf610792_
                                              __tmp41679))))
                                 (declare (not safe))
                                 (cons '"-config" __tmp41678))))
                          (declare (not safe))
                          (cons '"-new" __tmp41677))))
                   (declare (not safe))
                   (cons '"req" __tmp41676))))
            (declare (not safe))
            (std/misc/process#invoke__%
             '#f
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             '"openssl"
             __tmp41675))
          (let ()
            (declare (not safe))
            (displayln '"... generate " _root-ca.crt610798_))
          (let ((__tmp41686
                 (let ((__tmp41687
                        (let ((__tmp41688
                               (let ((__tmp41689
                                      (let ((__tmp41690
                                             (let ((__tmp41691
                                                    (let ((__tmp41692
                                                           (let ((__tmp41693
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (let ((__tmp41694
                                 (let ((__tmp41695
                                        (let ((__tmp41696
                                               (let ((__tmp41697
                                                      (let ((__tmp41698
                                                             (let ((__tmp41699
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            (let ((__tmp41700
                                   (string-append
                                    '"pass:"
                                    _root-ca-passphrase610778_)))
                              (declare (not safe))
                              (cons __tmp41700 '()))))
                       (declare (not safe))
                       (cons '"-passin" __tmp41699))))
                (declare (not safe))
                (cons '"ca_ext" __tmp41698))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 (declare (not safe))
                                                 (cons '"-extensions"
                                                       __tmp41697))))
                                          (declare (not safe))
                                          (cons _root-ca.crt610798_
                                                __tmp41696))))
                                   (declare (not safe))
                                   (cons '"-out" __tmp41695))))
                            (declare (not safe))
                            (cons _root-ca.csr610796_ __tmp41694))))
                     (declare (not safe))
                     (cons '"-in" __tmp41693))))
              (declare (not safe))
              (cons _root-ca.conf610792_ __tmp41692))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                               (declare (not safe))
                                               (cons '"-config" __tmp41691))))
                                        (declare (not safe))
                                        (cons '"-notext" __tmp41690))))
                                 (declare (not safe))
                                 (cons '"-batch" __tmp41689))))
                          (declare (not safe))
                          (cons '"-selfsign" __tmp41688))))
                   (declare (not safe))
                   (cons '"ca" __tmp41687))))
            (declare (not safe))
            (std/misc/process#invoke__%
             '#f
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             '"openssl"
             __tmp41686))
          (let ()
            (declare (not safe))
            (create-directory* _ca-certificates610800_))
          (copy-file
           _root-ca.crt610798_
           (path-expand '"root-ca.crt" _ca-certificates610800_)))))
    (define std/actor-v18/tls#generate-actor-tls-root-ca!__@
      (lambda (_keys610763610904_ . _args610906_)
        (apply std/actor-v18/tls#generate-actor-tls-root-ca!__%
               _keys610763610904_
               (let ()
                 (declare (not safe))
                 (table-ref _keys610763610904_ 'domain: absent-value))
               (let ()
                 (declare (not safe))
                 (table-ref _keys610763610904_ 'country-name: absent-value))
               (let ()
                 (declare (not safe))
                 (table-ref
                  _keys610763610904_
                  'organization-name:
                  absent-value))
               (let ()
                 (declare (not safe))
                 (table-ref _keys610763610904_ 'common-name: absent-value))
               _args610906_)))
    (define std/actor-v18/tls#generate-actor-tls-root-ca!
      (lambda _args610768610912_
        (apply keyword-dispatch
               '#(common-name: domain: organization-name: country-name:)
               std/actor-v18/tls#generate-actor-tls-root-ca!__@
               _args610768610912_)))
    (define std/actor-v18/tls#generate-actor-tls-sub-ca!__%
      (lambda (_g41701_
               _country-name610609610614_
               _organization-name610610610616_
               _common-name610611610618_
               _root-ca-passphrase610620_
               _sub-ca-passphrase610621_)
        (let* ((_country-name610623_
                (if (let ()
                      (declare (not safe))
                      (eq? _country-name610609610614_ absent-value))
                    '"UN"
                    _country-name610609610614_))
               (_organization-name610625_
                (if (let ()
                      (declare (not safe))
                      (eq? _organization-name610610610616_ absent-value))
                    '"Mighty Gerbils"
                    _organization-name610610610616_))
               (_common-name610627_
                (if (let ()
                      (declare (not safe))
                      (eq? _common-name610611610618_ absent-value))
                    (string-append
                     _organization-name610625_
                     '" Subordinate CA")
                    _common-name610611610618_))
               (_base-path610629_
                (let ()
                  (declare (not safe))
                  (std/actor-v18/tls#ensemble-tls-base-path)))
               (_root-ca-path610631_
                (path-expand '"root-ca" _base-path610629_))
               (_root-ca.conf610633_
                (path-expand '"root-ca.conf" _root-ca-path610631_))
               (_sub-ca-path610635_ (path-expand '"sub-ca" _base-path610629_))
               (_sub-ca.conf610637_
                (path-expand '"sub-ca.conf" _sub-ca-path610635_))
               (_sub-ca.key610639_
                (path-expand '"private/sub-ca.key" _sub-ca-path610635_))
               (_sub-ca.csr610641_
                (path-expand '"sub-ca.csr" _sub-ca-path610635_))
               (_sub-ca.crt610643_
                (path-expand '"sub-ca.crt" _sub-ca-path610635_))
               (_ca-certificates610645_
                (path-expand '"ca-certificates" _base-path610629_))
               (_domain610647_
                (let ()
                  (declare (not safe))
                  (std/actor-v18/tls#actor-tls-domain))))
          (if (file-exists? _root-ca-path610631_)
              '#!void
              (let ()
                (declare (not safe))
                (error '"root-ca does not exist" _root-ca-path610631_)))
          (if (file-exists? _sub-ca-path610635_)
              (let ()
                (declare (not safe))
                (error '"sub-ca already exists" _sub-ca-path610635_))
              '#!void)
          (let () (declare (not safe)) (create-directory* _sub-ca-path610635_))
          (let ((_iterable610671_ '("certs" "db"))
                (_iter-do610673_
                 (lambda (_val610650_)
                   (let* ((_val610652610657_ _val610650_)
                          (_E610654610661_
                           (lambda ()
                             (let ()
                               (declare (not safe))
                               (error '"No clause matching"
                                      _val610652610657_))))
                          (_K610655610666_
                           (lambda (_dir610664_)
                             (let ((__tmp41702
                                    (path-expand
                                     _dir610664_
                                     _sub-ca-path610635_)))
                               (declare (not safe))
                               (create-directory* __tmp41702))))
                          (_dir610669_ _val610652610657_))
                     (declare (not safe))
                     (_K610655610666_ _dir610669_)))))
            (if (let () (declare (not safe)) (pair? _iterable610671_))
                (for-each _iter-do610673_ _iterable610671_)
                (if (let () (declare (not safe)) (null? _iterable610671_))
                    '#!void
                    (let* ((_it610676_
                            (let ()
                              (declare (not safe))
                              (std/iter#iter _iterable610671_)))
                           (_next!610679_
                            (let ()
                              (declare (not safe))
                              (##unchecked-structure-ref
                               _it610676_
                               '2
                               std/iter#iterator::t
                               '#f))))
                      (declare (not safe))
                      (begin
                        (let _lp610684_ ()
                          (let ((_val610688_ (_next!610679_ _it610676_)))
                            (if (eq? std/iter#iter-end _val610688_)
                                '#!void
                                (begin
                                  (_iter-do610673_ _val610688_)
                                  (_lp610684_)))))
                        (let ((_$e610690_
                               (##unchecked-structure-ref
                                _it610676_
                                '3
                                std/iter#iterator::t
                                '#f)))
                          (if _$e610690_
                              ((lambda (_g610692610694_)
                                 (_g610692610694_ _it610676_))
                               _$e610690_)
                              '#!void))
                        '#!void)))))
          (let ((_iterable610718_ '("private"))
                (_iter-do610720_
                 (lambda (_val610697_)
                   (let* ((_val610699610704_ _val610697_)
                          (_E610701610708_
                           (lambda ()
                             (let ()
                               (declare (not safe))
                               (error '"No clause matching"
                                      _val610699610704_))))
                          (_K610702610713_
                           (lambda (_dir610711_)
                             (let ((__tmp41703
                                    (path-expand
                                     _dir610711_
                                     _sub-ca-path610635_)))
                               (declare (not safe))
                               (create-directory* __tmp41703 '448))))
                          (_dir610716_ _val610699610704_))
                     (declare (not safe))
                     (_K610702610713_ _dir610716_)))))
            (if (let () (declare (not safe)) (pair? _iterable610718_))
                (for-each _iter-do610720_ _iterable610718_)
                (if (let () (declare (not safe)) (null? _iterable610718_))
                    '#!void
                    (let* ((_it610723_
                            (let ()
                              (declare (not safe))
                              (std/iter#iter _iterable610718_)))
                           (_next!610726_
                            (let ()
                              (declare (not safe))
                              (##unchecked-structure-ref
                               _it610723_
                               '2
                               std/iter#iterator::t
                               '#f))))
                      (declare (not safe))
                      (begin
                        (let _lp610731_ ()
                          (let ((_val610735_ (_next!610726_ _it610723_)))
                            (if (eq? std/iter#iter-end _val610735_)
                                '#!void
                                (begin
                                  (_iter-do610720_ _val610735_)
                                  (_lp610731_)))))
                        (let ((_$e610737_
                               (##unchecked-structure-ref
                                _it610723_
                                '3
                                std/iter#iterator::t
                                '#f)))
                          (if _$e610737_
                              ((lambda (_g610739610741_)
                                 (_g610739610741_ _it610723_))
                               _$e610737_)
                              '#!void))
                        '#!void)))))
          (let ((__tmp41704 (path-expand '"db/index" _sub-ca-path610635_)))
            (declare (not safe))
            (std/misc/ports#write-file-string__%
             '#f
             absent-value
             absent-value
             __tmp41704
             '""))
          (let ((__tmp41709 (path-expand '"db/serial" _sub-ca-path610635_))
                (__tmp41705
                 (let ((__tmp41706
                        (let ((__tmp41707
                               (let ((__tmp41708
                                      (let ()
                                        (declare (not safe))
                                        (cons '"16" '()))))
                                 (declare (not safe))
                                 (cons '"-hex" __tmp41708))))
                          (declare (not safe))
                          (cons '"rand" __tmp41707))))
                   (declare (not safe))
                   (std/misc/process#invoke__%
                    '#f
                    '#t
                    absent-value
                    absent-value
                    absent-value
                    absent-value
                    absent-value
                    absent-value
                    absent-value
                    '"openssl"
                    __tmp41706))))
            (declare (not safe))
            (std/misc/ports#write-file-string__%
             '#f
             absent-value
             absent-value
             __tmp41709
             __tmp41705))
          (let ((__tmp41710 (path-expand '"db/crlnumber" _sub-ca-path610635_)))
            (declare (not safe))
            (std/misc/ports#write-file-string__%
             '#f
             absent-value
             absent-value
             __tmp41710
             '"1001"))
          (let ()
            (declare (not safe))
            (displayln '"... generate " _sub-ca.conf610637_))
          (call-with-output-file
           _sub-ca.conf610637_
           (lambda (_g610743610745_)
             (let ()
               (declare (not safe))
               (std/misc/template#write-template
                std/actor-v18/tls#sub-ca.conf-template
                _g610743610745_
                'domain:
                _domain610647_
                'home:
                _sub-ca-path610635_
                'country-name:
                _country-name610623_
                'organization-name:
                _organization-name610625_
                'common-name:
                _common-name610627_))))
          (let ()
            (declare (not safe))
            (displayln
             '"... generate "
             _sub-ca.csr610641_
             '" "
             _sub-ca.key610639_))
          (let ((__tmp41711
                 (let ((__tmp41712
                        (let ((__tmp41713
                               (let ((__tmp41714
                                      (let ((__tmp41715
                                             (let ((__tmp41716
                                                    (let ((__tmp41717
                                                           (let ((__tmp41718
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (let ((__tmp41719
                                 (let ((__tmp41720
                                        (let ((__tmp41721
                                               (string-append
                                                '"pass:"
                                                _sub-ca-passphrase610621_)))
                                          (declare (not safe))
                                          (cons __tmp41721 '()))))
                                   (declare (not safe))
                                   (cons '"-passout" __tmp41720))))
                            (declare (not safe))
                            (cons _sub-ca.key610639_ __tmp41719))))
                     (declare (not safe))
                     (cons '"-keyout" __tmp41718))))
              (declare (not safe))
              (cons _sub-ca.csr610641_ __tmp41717))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                               (declare (not safe))
                                               (cons '"-out" __tmp41716))))
                                        (declare (not safe))
                                        (cons _sub-ca.conf610637_
                                              __tmp41715))))
                                 (declare (not safe))
                                 (cons '"-config" __tmp41714))))
                          (declare (not safe))
                          (cons '"-new" __tmp41713))))
                   (declare (not safe))
                   (cons '"req" __tmp41712))))
            (declare (not safe))
            (std/misc/process#invoke__%
             '#f
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             '"openssl"
             __tmp41711))
          (let ()
            (declare (not safe))
            (displayln '"... generate " _sub-ca.crt610643_))
          (let ((__tmp41722
                 (let ((__tmp41723
                        (let ((__tmp41724
                               (let ((__tmp41725
                                      (let ((__tmp41726
                                             (let ((__tmp41727
                                                    (let ((__tmp41728
                                                           (let ((__tmp41729
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (let ((__tmp41730
                                 (let ((__tmp41731
                                        (let ((__tmp41732
                                               (let ((__tmp41733
                                                      (let ((__tmp41734
                                                             (let ((__tmp41735
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            (string-append
                             '"pass:"
                             _root-ca-passphrase610620_)))
                       (declare (not safe))
                       (cons __tmp41735 '()))))
                (declare (not safe))
                (cons '"-passin" __tmp41734))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 (declare (not safe))
                                                 (cons '"sub_ca_ext"
                                                       __tmp41733))))
                                          (declare (not safe))
                                          (cons '"-extensions" __tmp41732))))
                                   (declare (not safe))
                                   (cons _sub-ca.crt610643_ __tmp41731))))
                            (declare (not safe))
                            (cons '"-out" __tmp41730))))
                     (declare (not safe))
                     (cons _sub-ca.csr610641_ __tmp41729))))
              (declare (not safe))
              (cons '"-in" __tmp41728))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                               (declare (not safe))
                                               (cons _root-ca.conf610633_
                                                     __tmp41727))))
                                        (declare (not safe))
                                        (cons '"-config" __tmp41726))))
                                 (declare (not safe))
                                 (cons '"-notext" __tmp41725))))
                          (declare (not safe))
                          (cons '"-batch" __tmp41724))))
                   (declare (not safe))
                   (cons '"ca" __tmp41723))))
            (declare (not safe))
            (std/misc/process#invoke__%
             '#f
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             '"openssl"
             __tmp41722))
          (copy-file
           _sub-ca.crt610643_
           (path-expand '"sub-ca.crt" _ca-certificates610645_)))))
    (define std/actor-v18/tls#generate-actor-tls-sub-ca!__@
      (lambda (_keys610608610751_ . _args610753_)
        (apply std/actor-v18/tls#generate-actor-tls-sub-ca!__%
               _keys610608610751_
               (let ()
                 (declare (not safe))
                 (table-ref _keys610608610751_ 'country-name: absent-value))
               (let ()
                 (declare (not safe))
                 (table-ref
                  _keys610608610751_
                  'organization-name:
                  absent-value))
               (let ()
                 (declare (not safe))
                 (table-ref _keys610608610751_ 'common-name: absent-value))
               _args610753_)))
    (define std/actor-v18/tls#generate-actor-tls-sub-ca!
      (lambda _args610612610759_
        (apply keyword-dispatch
               '#(common-name: #f organization-name: country-name:)
               std/actor-v18/tls#generate-actor-tls-sub-ca!__@
               _args610612610759_)))
    (define std/actor-v18/tls#generate-actor-tls-cafiles!__%
      (lambda (_g41736_ _force?610521610524_)
        (let* ((_force?610527_
                (if (let ()
                      (declare (not safe))
                      (eq? _force?610521610524_ absent-value))
                    '#f
                    _force?610521610524_))
               (_cafile610529_
                (let ()
                  (declare (not safe))
                  (std/actor-v18/tls#ensemble-tls-cafile)))
               (_base-path610531_
                (let ()
                  (declare (not safe))
                  (std/actor-v18/tls#ensemble-tls-base-path)))
               (_ca-certificates610533_
                (path-expand '"ca-certificates" _base-path610531_))
               (_sub-ca.crt610535_
                (path-expand '"sub-ca.crt" _ca-certificates610533_))
               (_root-ca.crt610537_
                (path-expand '"root-ca.crt" _ca-certificates610533_))
               (_caroot.pem610539_
                (path-expand '"caroot.pem" _base-path610531_)))
          (if (file-exists? _cafile610529_)
              (if _force?610527_
                  (delete-file _cafile610529_)
                  (let ()
                    (declare (not safe))
                    (error '"cafile already exists" _cafile610529_)))
              '#!void)
          (let ((__tmp41737
                 (let ((__tmp41738
                        (let ()
                          (declare (not safe))
                          (cons _ca-certificates610533_ '()))))
                   (declare (not safe))
                   (cons '"rehash" __tmp41738))))
            (declare (not safe))
            (std/misc/process#invoke__%
             '#f
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             '"openssl"
             __tmp41737))
          (call-with-output-file
           _cafile610529_
           (lambda (_output610542_)
             (let ((_iterable610567_
                    (let ((__tmp41739
                           (let ()
                             (declare (not safe))
                             (cons _root-ca.crt610537_ '()))))
                      (declare (not safe))
                      (cons _sub-ca.crt610535_ __tmp41739)))
                   (_iter-do610569_
                    (lambda (_val610544_)
                      (let* ((_val610546610551_ _val610544_)
                             (_E610548610555_
                              (lambda ()
                                (let ()
                                  (declare (not safe))
                                  (error '"No clause matching"
                                         _val610546610551_))))
                             (_K610549610562_
                              (lambda (_f610558_)
                                (let ((_blob610560_
                                       (let ()
                                         (declare (not safe))
                                         (std/misc/ports#read-file-u8vector__%
                                          '#f
                                          absent-value
                                          _f610558_))))
                                  (write-subu8vector
                                   _blob610560_
                                   '0
                                   (u8vector-length _blob610560_)
                                   _output610542_))))
                             (_f610565_ _val610546610551_))
                        (declare (not safe))
                        (_K610549610562_ _f610565_)))))
               (if (let () (declare (not safe)) (pair? _iterable610567_))
                   (for-each _iter-do610569_ _iterable610567_)
                   (if (let () (declare (not safe)) (null? _iterable610567_))
                       '#!void
                       (let* ((_it610572_
                               (let ()
                                 (declare (not safe))
                                 (std/iter#iter _iterable610567_)))
                              (_next!610575_
                               (let ()
                                 (declare (not safe))
                                 (##unchecked-structure-ref
                                  _it610572_
                                  '2
                                  std/iter#iterator::t
                                  '#f))))
                         (declare (not safe))
                         (begin
                           (let _lp610580_ ()
                             (let ((_val610584_ (_next!610575_ _it610572_)))
                               (if (eq? std/iter#iter-end _val610584_)
                                   '#!void
                                   (begin
                                     (_iter-do610569_ _val610584_)
                                     (_lp610580_)))))
                           (let ((_$e610586_
                                  (##unchecked-structure-ref
                                   _it610572_
                                   '3
                                   std/iter#iterator::t
                                   '#f)))
                             (if _$e610586_
                                 ((lambda (_g610588610590_)
                                    (_g610588610590_ _it610572_))
                                  _$e610586_)
                                 '#!void))
                           '#!void)))))))
          (copy-file _root-ca.crt610537_ _caroot.pem610539_))))
    (define std/actor-v18/tls#generate-actor-tls-cafiles!__@
      (lambda (_keys610520610596_ . _args610598_)
        (apply std/actor-v18/tls#generate-actor-tls-cafiles!__%
               _keys610520610596_
               (let ()
                 (declare (not safe))
                 (table-ref _keys610520610596_ 'force: absent-value))
               _args610598_)))
    (define std/actor-v18/tls#generate-actor-tls-cafiles!
      (lambda _args610522610604_
        (apply keyword-dispatch
               '#(force:)
               std/actor-v18/tls#generate-actor-tls-cafiles!__@
               _args610522610604_)))
    (define std/actor-v18/tls#generate-actor-tls-cert!__%
      (lambda (_g41740_
               _server-id610395610402_
               _capabilities610396610404_
               _country-name610397610406_
               _organization-name610398610408_
               _location610399610410_
               _sub-ca-passphrase610412_)
        (let* ((_server-id610414_
                (if (let ()
                      (declare (not safe))
                      (eq? _server-id610395610402_ absent-value))
                    (let ()
                      (declare (not safe))
                      (error '"Missing required keyword argument" 'server-id:))
                    _server-id610395610402_))
               (_capabilities610416_
                (if (let ()
                      (declare (not safe))
                      (eq? _capabilities610396610404_ absent-value))
                    '()
                    _capabilities610396610404_))
               (_country-name610418_
                (if (let ()
                      (declare (not safe))
                      (eq? _country-name610397610406_ absent-value))
                    '"UN"
                    _country-name610397610406_))
               (_organization-name610420_
                (if (let ()
                      (declare (not safe))
                      (eq? _organization-name610398610408_ absent-value))
                    '"Mighty Gerbils"
                    _organization-name610398610408_))
               (_location610422_
                (if (let ()
                      (declare (not safe))
                      (eq? _location610399610410_ absent-value))
                    '"Internet"
                    _location610399610410_))
               (_base-path610424_
                (let ()
                  (declare (not safe))
                  (std/actor-v18/tls#ensemble-tls-base-path)))
               (_root-ca-path610426_
                (path-expand '"root-ca" _base-path610424_))
               (_sub-ca-path610428_ (path-expand '"sub-ca" _base-path610424_))
               (_sub-ca.conf610430_
                (path-expand '"sub-ca.conf" _sub-ca-path610428_))
               (_server-path610432_
                (let ()
                  (declare (not safe))
                  (std/actor-v18/tls#ensemble-tls-server-path
                   _server-id610414_)))
               (_server.conf610434_
                (path-expand '"server.conf" _server-path610432_))
               (_server.key610436_
                (path-expand '"server.key" _server-path610432_))
               (_server.csr610438_
                (path-expand '"server.csr" _server-path610432_))
               (_server.crt610440_
                (path-expand '"server.crt" _server-path610432_))
               (_chain.pem610442_
                (path-expand '"chain.pem" _server-path610432_))
               (_domain610444_
                (let ()
                  (declare (not safe))
                  (std/actor-v18/tls#actor-tls-domain))))
          (if (file-exists? _sub-ca-path610428_)
              '#!void
              (let ()
                (declare (not safe))
                (error '"sub-ca does not exist" _sub-ca-path610428_)))
          (if (file-exists? _server-path610432_)
              '#!void
              (let ()
                (declare (not safe))
                (create-directory* _server-path610432_)))
          (let ()
            (declare (not safe))
            (displayln '"... generate " _server.conf610434_))
          (call-with-output-file
           _server.conf610434_
           (lambda (_g610446610448_)
             (let ((__tmp41741
                    (let ((__tmp41742
                           (map (lambda (_i610451_ _x610452_)
                                  (string-append
                                   '"URI."
                                   (number->string _i610451_)
                                   '" = cap:"
                                   _x610452_))
                                (let ((__tmp41743
                                       (length _capabilities610416_)))
                                  (declare (not safe))
                                  (iota __tmp41743))
                                (map symbol->string _capabilities610416_))))
                      (declare (not safe))
                      (string-join __tmp41742 '"\n"))))
               (declare (not safe))
               (std/misc/template#write-template
                std/actor-v18/tls#server.conf-template
                _g610446610448_
                'server-id:
                _server-id610414_
                'capabilities:
                __tmp41741
                'domain:
                _domain610444_
                'country-name:
                _country-name610418_
                'organization-name:
                _organization-name610420_
                'location:
                _location610422_))))
          (if (file-exists? _server.key610436_)
              '#!void
              (begin
                (let ()
                  (declare (not safe))
                  (displayln '"... generate " _server.key610436_))
                (let ((__tmp41744
                       (let ((__tmp41745
                              (let ((__tmp41746
                                     (let ((__tmp41747
                                            (let ((__tmp41748
                                                   (let ((__tmp41749
                                                          (let ((__tmp41750
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (let ((__tmp41751
                                (let ()
                                  (declare (not safe))
                                  (cons _server.key610436_ '()))))
                           (declare (not safe))
                           (cons '"-out" __tmp41751))))
                    (declare (not safe))
                    (cons '"rsa_keygen_bits:4096" __tmp41750))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (declare (not safe))
                                                     (cons '"-pkeyopt"
                                                           __tmp41749))))
                                              (declare (not safe))
                                              (cons '"RSA" __tmp41748))))
                                       (declare (not safe))
                                       (cons '"-algorithm" __tmp41747))))
                                (declare (not safe))
                                (cons '"-quiet" __tmp41746))))
                         (declare (not safe))
                         (cons '"genpkey" __tmp41745))))
                  (declare (not safe))
                  (std/misc/process#invoke__%
                   '#f
                   absent-value
                   absent-value
                   absent-value
                   absent-value
                   absent-value
                   absent-value
                   absent-value
                   absent-value
                   '"openssl"
                   __tmp41744))))
          (if (file-exists? _server.csr610438_)
              (rename-file
               _server.csr610438_
               (string-append
                _server.csr610438_
                '".bak."
                (number->string
                 (let ()
                   (declare (not safe))
                   (std/actor-v18/tls#current-time-seconds)))))
              '#!void)
          (let ()
            (declare (not safe))
            (displayln '"... generate " _server.csr610438_))
          (let ((__tmp41752
                 (let ((__tmp41753
                        (let ((__tmp41754
                               (let ((__tmp41755
                                      (let ((__tmp41756
                                             (let ((__tmp41757
                                                    (let ((__tmp41758
                                                           (let ((__tmp41759
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (let ()
                            (declare (not safe))
                            (cons _server.csr610438_ '()))))
                     (declare (not safe))
                     (cons '"-out" __tmp41759))))
              (declare (not safe))
              (cons _server.key610436_ __tmp41758))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                               (declare (not safe))
                                               (cons '"-key" __tmp41757))))
                                        (declare (not safe))
                                        (cons _server.conf610434_
                                              __tmp41756))))
                                 (declare (not safe))
                                 (cons '"-config" __tmp41755))))
                          (declare (not safe))
                          (cons '"-new" __tmp41754))))
                   (declare (not safe))
                   (cons '"req" __tmp41753))))
            (declare (not safe))
            (std/misc/process#invoke__%
             '#f
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             '"openssl"
             __tmp41752))
          (if (file-exists? _server.crt610440_)
              (rename-file
               _server.crt610440_
               (string-append
                _server.crt610440_
                '".bak."
                (number->string
                 (number->string
                  (let ()
                    (declare (not safe))
                    (std/actor-v18/tls#current-time-seconds))))))
              '#!void)
          (let ()
            (declare (not safe))
            (displayln '"... generate " _server.crt610440_))
          (let ((__tmp41760
                 (let ((__tmp41761
                        (let ((__tmp41762
                               (let ((__tmp41763
                                      (let ((__tmp41764
                                             (let ((__tmp41765
                                                    (let ((__tmp41766
                                                           (let ((__tmp41767
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (let ((__tmp41768
                                 (let ((__tmp41769
                                        (let ((__tmp41770
                                               (let ((__tmp41771
                                                      (let ((__tmp41772
                                                             (let ((__tmp41773
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            (string-append
                             '"pass:"
                             _sub-ca-passphrase610412_)))
                       (declare (not safe))
                       (cons __tmp41773 '()))))
                (declare (not safe))
                (cons '"-passin" __tmp41772))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 (declare (not safe))
                                                 (cons '"actor_ext"
                                                       __tmp41771))))
                                          (declare (not safe))
                                          (cons '"-extensions" __tmp41770))))
                                   (declare (not safe))
                                   (cons _server.crt610440_ __tmp41769))))
                            (declare (not safe))
                            (cons '"-out" __tmp41768))))
                     (declare (not safe))
                     (cons _server.csr610438_ __tmp41767))))
              (declare (not safe))
              (cons '"-in" __tmp41766))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                               (declare (not safe))
                                               (cons _sub-ca.conf610430_
                                                     __tmp41765))))
                                        (declare (not safe))
                                        (cons '"-config" __tmp41764))))
                                 (declare (not safe))
                                 (cons '"-notext" __tmp41763))))
                          (declare (not safe))
                          (cons '"-batch" __tmp41762))))
                   (declare (not safe))
                   (cons '"ca" __tmp41761))))
            (declare (not safe))
            (std/misc/process#invoke__%
             '#f
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             absent-value
             '"openssl"
             __tmp41760))
          (let ()
            (declare (not safe))
            (displayln '"... generate " _chain.pem610442_))
          (call-with-output-file
           _chain.pem610442_
           (lambda (_output610454_)
             (let ((_iterable610479_
                    (let ((__tmp41774
                           (let ((__tmp41775
                                  (let ()
                                    (declare (not safe))
                                    (std/actor-v18/tls#ensemble-tls-cafile))))
                             (declare (not safe))
                             (cons __tmp41775 '()))))
                      (declare (not safe))
                      (cons _server.crt610440_ __tmp41774)))
                   (_iter-do610481_
                    (lambda (_val610456_)
                      (let* ((_val610458610463_ _val610456_)
                             (_E610460610467_
                              (lambda ()
                                (let ()
                                  (declare (not safe))
                                  (error '"No clause matching"
                                         _val610458610463_))))
                             (_K610461610474_
                              (lambda (_f610470_)
                                (let ((_blob610472_
                                       (let ()
                                         (declare (not safe))
                                         (std/misc/ports#read-file-u8vector__%
                                          '#f
                                          absent-value
                                          _f610470_))))
                                  (write-subu8vector
                                   _blob610472_
                                   '0
                                   (u8vector-length _blob610472_)
                                   _output610454_))))
                             (_f610477_ _val610458610463_))
                        (declare (not safe))
                        (_K610461610474_ _f610477_)))))
               (if (let () (declare (not safe)) (pair? _iterable610479_))
                   (for-each _iter-do610481_ _iterable610479_)
                   (if (let () (declare (not safe)) (null? _iterable610479_))
                       '#!void
                       (let* ((_it610484_
                               (let ()
                                 (declare (not safe))
                                 (std/iter#iter _iterable610479_)))
                              (_next!610487_
                               (let ()
                                 (declare (not safe))
                                 (##unchecked-structure-ref
                                  _it610484_
                                  '2
                                  std/iter#iterator::t
                                  '#f))))
                         (declare (not safe))
                         (begin
                           (let _lp610492_ ()
                             (let ((_val610496_ (_next!610487_ _it610484_)))
                               (if (eq? std/iter#iter-end _val610496_)
                                   '#!void
                                   (begin
                                     (_iter-do610481_ _val610496_)
                                     (_lp610492_)))))
                           (let ((_$e610498_
                                  (##unchecked-structure-ref
                                   _it610484_
                                   '3
                                   std/iter#iterator::t
                                   '#f)))
                             (if _$e610498_
                                 ((lambda (_g610500610502_)
                                    (_g610500610502_ _it610484_))
                                  _$e610498_)
                                 '#!void))
                           '#!void))))))))))
    (define std/actor-v18/tls#generate-actor-tls-cert!__@
      (lambda (_keys610394610508_ . _args610510_)
        (apply std/actor-v18/tls#generate-actor-tls-cert!__%
               _keys610394610508_
               (let ()
                 (declare (not safe))
                 (table-ref _keys610394610508_ 'server-id: absent-value))
               (let ()
                 (declare (not safe))
                 (table-ref _keys610394610508_ 'capabilities: absent-value))
               (let ()
                 (declare (not safe))
                 (table-ref _keys610394610508_ 'country-name: absent-value))
               (let ()
                 (declare (not safe))
                 (table-ref
                  _keys610394610508_
                  'organization-name:
                  absent-value))
               (let ()
                 (declare (not safe))
                 (table-ref _keys610394610508_ 'location: absent-value))
               _args610510_)))
    (define std/actor-v18/tls#generate-actor-tls-cert!
      (lambda _args610400610516_
        (apply keyword-dispatch
               '#(#f
                  country-name:
                  server-id:
                  #f
                  organization-name:
                  #f
                  location:
                  #f
                  #f
                  capabilities:)
               std/actor-v18/tls#generate-actor-tls-cert!__@
               _args610400610516_)))
    (define std/actor-v18/tls#root-ca.conf-template
      '"[default]\nname                    = root-ca\ndomain_suffix           = ${domain}\naia_url                 = http://$name.$domain_suffix/$name.crt\ncrl_url                 = http://$name.$domain_suffix/$name.crl\nocsp_url                = http://ocsp.$name.$domain_suffix:9080\ndefault_ca              = ca_default\nname_opt                = utf8,esc_ctrl,multiline,lname,align\n\n[ca_dn]\ncountryName             = \"${country-name}\"\norganizationName        = \"${organization-name}\"\ncommonName              = \"${common-name}\"\n\n[ca_default]\nhome                    = ${home}\ndatabase                = $home/db/index\nserial                  = $home/db/serial\ncrlnumber               = $home/db/crlnumber\ncertificate             = $home/$name.crt\nprivate_key             = $home/private/$name.key\nRANDFILE                = $home/private/random\nnew_certs_dir           = $home/certs\nunique_subject          = no\ncopy_extensions         = none\ndefault_days            = 3650\ndefault_crl_days        = 365\ndefault_md              = sha256\npolicy                  = policy_c_o_match\n\n[policy_c_o_match]\ncountryName             = optional\nstateOrProvinceName     = optional\norganizationName        = optional\norganizationalUnitName  = optional\ncommonName              = supplied\nemailAddress            = optional\n\n[req]\ndefault_bits            = 4096\nencrypt_key             = yes\ndefault_md              = sha256\nutf8                    = yes\nstring_mask             = utf8only\nprompt                  = no\ndistinguished_name      = ca_dn\nreq_extensions          = ca_ext\n\n[ca_ext]\nbasicConstraints        = critical,CA:true\nkeyUsage                = critical,keyCertSign,cRLSign\nsubjectKeyIdentifier    = hash\n\n[sub_ca_ext]\nauthorityInfoAccess     = @issuer_info\nauthorityKeyIdentifier  = keyid:always\nbasicConstraints        = critical,CA:true,pathlen:0\ncrlDistributionPoints   = @crl_info\nextendedKeyUsage        = clientAuth,serverAuth\nkeyUsage                = critical,keyCertSign,cRLSign\nsubjectKeyIdentifier    = hash\n\n[crl_info]\nURI.0                   = $crl_url\n\n[issuer_info]\ncaIssuers;URI.0         = $aia_url\nOCSP;URI.0              = $ocsp_url\n\n[ocsp_ext]\nauthorityKeyIdentifier  = keyid:always\nbasicConstraints        = critical,CA:false\nextendedKeyUsage        = OCSPSigning\nnoCheck                 = yes\nkeyUsage                = critical,digitalSignature\nsubjectKeyIdentifier    = hash\n")
    (define std/actor-v18/tls#sub-ca.conf-template
      '"[default]\nname                    = sub-ca\ndomain_suffix           = ${domain}\naia_url                 = http://$name.$domain_suffix/$name.crt\ncrl_url                 = http://$name.$domain_suffix/$name.crl\nocsp_url                = http://ocsp.$name.$domain_suffix:9081\ndefault_ca              = ca_default\nname_opt                = utf8,esc_ctrl,multiline,lname,align\n\n[ca_dn]\ncountryName             = \"${country-name}\"\norganizationName        = \"${organization-name}\"\ncommonName              = \"${common-name}\"\n\n[ca_default]\nhome                    = ${home}\ndatabase                = $home/db/index\nserial                  = $home/db/serial\ncrlnumber               = $home/db/crlnumber\ncertificate             = $home/$name.crt\nprivate_key             = $home/private/$name.key\nRANDFILE                = $home/private/random\nnew_certs_dir           = $home/certs\nunique_subject          = no\ncopy_extensions         = copy\ndefault_days            = 365\ndefault_crl_days        = 30\ndefault_md              = sha256\npolicy                  = policy_c_o_match\n\n[policy_c_o_match]\ncountryName             = optional\nstateOrProvinceName     = optional\norganizationName        = optional\norganizationalUnitName  = optional\ncommonName              = supplied\nemailAddress            = optional\n\n[req]\ndefault_bits            = 4096\nencrypt_key             = yes\ndefault_md              = sha256\nutf8                    = yes\nstring_mask             = utf8only\nprompt                  = no\ndistinguished_name      = ca_dn\n\n[actor_ext]\nauthorityInfoAccess     = @issuer_info\nauthorityKeyIdentifier  = keyid:always\nbasicConstraints        = critical,CA:false\ncrlDistributionPoints   = @crl_info\nextendedKeyUsage        = clientAuth,serverAuth\nkeyUsage                = critical,digitalSignature,keyEncipherment\nsubjectKeyIdentifier    = hash\n\n[crl_info]\nURI.0                   = $crl_url\n\n[issuer_info]\ncaIssuers;URI.0         = $aia_url\nOCSP;URI.0              = $ocsp_url\n\n[ocsp_ext]\nauthorityKeyIdentifier  = keyid:always\nbasicConstraints        = critical,CA:false\nextendedKeyUsage        = OCSPSigning\nkeyUsage                = critical,digitalSignature\nsubjectKeyIdentifier    = hash\n")
    (define std/actor-v18/tls#server.conf-template
      '"[req]\nprompt = no\ndistinguished_name = dn\nreq_extensions = ext\n\n[dn]\nCN = ${server-id}.${domain}\nO  = ${organization-name}\nL  = ${location}\nC  = ${country-name}\n\n[ext]\nsubjectAltName          = @sans\n\n[sans]\nDNS = ${server-id}.${domain}\n${capabilities}")))
