(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/crypto/pkey::timestamp 1701959212)
  (begin
    (define std/crypto/pkey#keygen/ed25519
      (lambda ()
        (letrec* ((_ctx609989_
                   (std/crypto/libcrypto#EVP_PKEY_CTX_new_id
                    std/crypto/libcrypto#EVP_PKEY_ED25519
                    '#f)))
          (if (and _ctx609989_
                   (< '0
                      (std/crypto/libcrypto#EVP_PKEY_keygen_init _ctx609989_)))
              '#!void
              (let ()
                (declare (not safe))
                (error '"Can't create ED25519 keygen context")))
          (let ((__tmp991810
                 (lambda ()
                   (std/crypto/libcrypto#EVP_PKEY_keygen _ctx609989_)))
                (__tmp991809 (lambda () (foreign-release! _ctx609989_))))
            (declare (not safe))
            (with-unwind-protect __tmp991810 __tmp991809)))))
    (define std/crypto/pkey#bytes->private-key__%
      (lambda (_g991811_ _engine609964609967_ _type609969_ _bytes609970_)
        (let ((_engine609972_
               (if (let ()
                     (declare (not safe))
                     (eq? _engine609964609967_ absent-value))
                   '#f
                   _engine609964609967_)))
          (std/crypto/libcrypto#EVP_PKEY_new_raw_private_key
           _type609969_
           _engine609972_
           _bytes609970_))))
    (define std/crypto/pkey#bytes->private-key__@
      (lambda (_keys609963609977_ . _args609979_)
        (apply std/crypto/pkey#bytes->private-key__%
               _keys609963609977_
               (let ()
                 (declare (not safe))
                 (table-ref _keys609963609977_ 'engine: absent-value))
               _args609979_)))
    (define std/crypto/pkey#bytes->private-key
      (lambda _args609965609985_
        (apply keyword-dispatch
               '#(engine:)
               std/crypto/pkey#bytes->private-key__@
               _args609965609985_)))
    (define std/crypto/pkey#bytes->public-key__%
      (lambda (_g991812_ _engine609938609941_ _type609943_ _bytes609944_)
        (let ((_engine609946_
               (if (let ()
                     (declare (not safe))
                     (eq? _engine609938609941_ absent-value))
                   '#f
                   _engine609938609941_)))
          (std/crypto/libcrypto#EVP_PKEY_new_raw_public_key
           _type609943_
           _engine609946_
           _bytes609944_))))
    (define std/crypto/pkey#bytes->public-key__@
      (lambda (_keys609937609951_ . _args609953_)
        (apply std/crypto/pkey#bytes->public-key__%
               _keys609937609951_
               (let ()
                 (declare (not safe))
                 (table-ref _keys609937609951_ 'engine: absent-value))
               _args609953_)))
    (define std/crypto/pkey#bytes->public-key
      (lambda _args609939609959_
        (apply keyword-dispatch
               '#(engine:)
               std/crypto/pkey#bytes->public-key__@
               _args609939609959_)))
    (define std/crypto/pkey#bytes-argument
      (lambda (_bytes609934_)
        (if (let () (declare (not safe)) (u8vector? _bytes609934_))
            _bytes609934_
            (if (fixnum? _bytes609934_)
                (make-u8vector _bytes609934_)
                (if (let () (declare (not safe)) (not _bytes609934_))
                    '#f
                    (let ()
                      (declare (not safe))
                      (error '"invalid bytes argument" _bytes609934_)))))))
    (define std/crypto/pkey#bytes-result
      (lambda (_bytes609931_ _len609932_)
        (if (let () (declare (not safe)) (zero? _len609932_))
            '#f
            (if (= _len609932_ (u8vector-length _bytes609931_))
                _bytes609931_
                (if (< _len609932_ (u8vector-length _bytes609931_))
                    (begin
                      (u8vector-shrink! _bytes609931_ _len609932_)
                      _bytes609931_)
                    '#f)))))
    (define std/crypto/pkey#key->bytes
      (lambda (_pkey609921_ _bytes609922_ _get_raw609923_)
        (letrec* ((_b609925_
                   (let ((_$e609928_
                          (let ()
                            (declare (not safe))
                            (std/crypto/pkey#bytes-argument _bytes609922_))))
                     (if _$e609928_
                         _$e609928_
                         (make-u8vector (_get_raw609923_ _pkey609921_ '#f)))))
                  (_len609926_ (_get_raw609923_ _pkey609921_ _b609925_)))
          (let ()
            (declare (not safe))
            (std/crypto/pkey#bytes-result _b609925_ _len609926_)))))
    (define std/crypto/pkey#private-key->bytes__%
      (lambda (_pkey609908_ _bytes609909_)
        (let ()
          (declare (not safe))
          (std/crypto/pkey#key->bytes
           _pkey609908_
           _bytes609909_
           std/crypto/libcrypto#EVP_PKEY_get_raw_private_key))))
    (define std/crypto/pkey#private-key->bytes__0
      (lambda (_pkey609914_)
        (let ((_bytes609916_ '#f))
          (declare (not safe))
          (std/crypto/pkey#private-key->bytes__% _pkey609914_ _bytes609916_))))
    (define std/crypto/pkey#private-key->bytes
      (lambda _g991814_
        (let ((_g991813_ (let () (declare (not safe)) (##length _g991814_))))
          (cond ((let () (declare (not safe)) (##fx= _g991813_ 1))
                 (apply (lambda (_pkey609914_)
                          (let ()
                            (declare (not safe))
                            (std/crypto/pkey#private-key->bytes__0
                             _pkey609914_)))
                        _g991814_))
                ((let () (declare (not safe)) (##fx= _g991813_ 2))
                 (apply (lambda (_pkey609918_ _bytes609919_)
                          (let ()
                            (declare (not safe))
                            (std/crypto/pkey#private-key->bytes__%
                             _pkey609918_
                             _bytes609919_)))
                        _g991814_))
                (else
                 (##raise-wrong-number-of-arguments-exception
                  std/crypto/pkey#private-key->bytes
                  _g991814_))))))
    (define std/crypto/pkey#public-key->bytes__%
      (lambda (_pkey609894_ _bytes609895_)
        (let ()
          (declare (not safe))
          (std/crypto/pkey#key->bytes
           _pkey609894_
           _bytes609895_
           std/crypto/libcrypto#EVP_PKEY_get_raw_public_key))))
    (define std/crypto/pkey#public-key->bytes__0
      (lambda (_pkey609900_)
        (let ((_bytes609902_ '#f))
          (declare (not safe))
          (std/crypto/pkey#public-key->bytes__% _pkey609900_ _bytes609902_))))
    (define std/crypto/pkey#public-key->bytes
      (lambda _g991816_
        (let ((_g991815_ (let () (declare (not safe)) (##length _g991816_))))
          (cond ((let () (declare (not safe)) (##fx= _g991815_ 1))
                 (apply (lambda (_pkey609900_)
                          (let ()
                            (declare (not safe))
                            (std/crypto/pkey#public-key->bytes__0
                             _pkey609900_)))
                        _g991816_))
                ((let () (declare (not safe)) (##fx= _g991815_ 2))
                 (apply (lambda (_pkey609904_ _bytes609905_)
                          (let ()
                            (declare (not safe))
                            (std/crypto/pkey#public-key->bytes__%
                             _pkey609904_
                             _bytes609905_)))
                        _g991816_))
                (else
                 (##raise-wrong-number-of-arguments-exception
                  std/crypto/pkey#public-key->bytes
                  _g991816_))))))
    (define std/crypto/pkey#digest-sign__%
      (lambda (_g991817_
               _engine609849609853_
               _sig609850609855_
               _pkey609857_
               _bytes609858_)
        (let* ((_engine609860_
                (if (let ()
                      (declare (not safe))
                      (eq? _engine609849609853_ absent-value))
                    '#f
                    _engine609849609853_))
               (_sig609862_
                (if (let ()
                      (declare (not safe))
                      (eq? _sig609850609855_ absent-value))
                    '#f
                    _sig609850609855_))
               (_mctx609864_ (std/crypto/libcrypto#EVP_MD_CTX_create)))
          (if _mctx609864_
              '#!void
              (let ()
                (declare (not safe))
                (error '"Cannot create signing context")))
          (let ((__tmp991819
                 (lambda ()
                   (let ((_res609867_
                          (std/crypto/libcrypto#EVP_DigestSignInit
                           _mctx609864_
                           _pkey609857_)))
                     (if (let ()
                           (declare (not safe))
                           (##fxpositive? _res609867_))
                         _res609867_
                         (let ((__tmp991820
                                (let ((__tmp991822
                                       (std/crypto/libcrypto#ERR_get_error))
                                      (__tmp991821
                                       (std/crypto/libcrypto#EVP_DigestSignInit
                                        _mctx609864_
                                        _pkey609857_)))
                                  (declare (not safe))
                                  (make-class-instance
                                   std/crypto/etc#LibCryptoError::t
                                   '"\"crypto/pkey.ss\"@62.31-62.61"
                                   __tmp991822
                                   __tmp991821))))
                           (declare (not safe))
                           (raise __tmp991820))))
                   (let* ((_s609873_
                           (let ((_$e609870_
                                  (let ()
                                    (declare (not safe))
                                    (std/crypto/pkey#bytes-argument
                                     _sig609862_))))
                             (if _$e609870_ _$e609870_ (make-u8vector '8192))))
                          (_result609875_
                           (std/crypto/libcrypto#EVP_DigestSign
                            _mctx609864_
                            _s609873_
                            _bytes609858_)))
                     (if (let ()
                           (declare (not safe))
                           (##fxzero? _result609875_))
                         (let ((__tmp991823
                                (let ((__tmp991824
                                       (std/crypto/libcrypto#ERR_get_error)))
                                  (declare (not safe))
                                  (make-class-instance
                                   std/crypto/etc#LibCryptoError::t
                                   '"\"crypto/pkey.ss\"@66.36-66.47"
                                   __tmp991824
                                   std/crypto/pkey#digest-sign))))
                           (declare (not safe))
                           (raise __tmp991823))
                         (let ()
                           (declare (not safe))
                           (std/crypto/pkey#bytes-result
                            _s609873_
                            _result609875_))))))
                (__tmp991818 (lambda () (foreign-release! _mctx609864_))))
            (declare (not safe))
            (with-unwind-protect __tmp991819 __tmp991818)))))
    (define std/crypto/pkey#digest-sign__@
      (lambda (_keys609848609882_ . _args609884_)
        (apply std/crypto/pkey#digest-sign__%
               _keys609848609882_
               (let ()
                 (declare (not safe))
                 (table-ref _keys609848609882_ 'engine: absent-value))
               (let ()
                 (declare (not safe))
                 (table-ref _keys609848609882_ 'sig: absent-value))
               _args609884_)))
    (define std/crypto/pkey#digest-sign
      (lambda _args609851609890_
        (apply keyword-dispatch
               '#(sig: engine:)
               std/crypto/pkey#digest-sign__@
               _args609851609890_)))
    (define std/crypto/pkey#digest-verify__%
      (lambda (_g991825_
               _engine609815609818_
               _pkey609820_
               _sig609821_
               _bytes609822_)
        (let* ((_engine609824_
                (if (let ()
                      (declare (not safe))
                      (eq? _engine609815609818_ absent-value))
                    '#f
                    _engine609815609818_))
               (_mctx609826_ (std/crypto/libcrypto#EVP_MD_CTX_create)))
          (if _mctx609826_
              '#!void
              (let ()
                (declare (not safe))
                (error '"Cannot create signing context")))
          (let ((__tmp991827
                 (lambda ()
                   (let ((_res609829_
                          (std/crypto/libcrypto#EVP_DigestVerifyInit
                           _mctx609826_
                           _pkey609820_)))
                     (if (let ()
                           (declare (not safe))
                           (##fxpositive? _res609829_))
                         _res609829_
                         (let ((__tmp991828
                                (let ((__tmp991830
                                       (std/crypto/libcrypto#ERR_get_error))
                                      (__tmp991829
                                       (std/crypto/libcrypto#EVP_DigestVerifyInit
                                        _mctx609826_
                                        _pkey609820_)))
                                  (declare (not safe))
                                  (make-class-instance
                                   std/crypto/etc#LibCryptoError::t
                                   '"\"crypto/pkey.ss\"@77.31-77.63"
                                   __tmp991830
                                   __tmp991829))))
                           (declare (not safe))
                           (raise __tmp991828))))
                   (= '1
                      (std/crypto/libcrypto#EVP_DigestVerify
                       _mctx609826_
                       _sig609821_
                       _bytes609822_))))
                (__tmp991826 (lambda () (foreign-release! _mctx609826_))))
            (declare (not safe))
            (with-unwind-protect __tmp991827 __tmp991826)))))
    (define std/crypto/pkey#digest-verify__@
      (lambda (_keys609814609836_ . _args609838_)
        (apply std/crypto/pkey#digest-verify__%
               _keys609814609836_
               (let ()
                 (declare (not safe))
                 (table-ref _keys609814609836_ 'engine: absent-value))
               _args609838_)))
    (define std/crypto/pkey#digest-verify
      (lambda _args609816609844_
        (apply keyword-dispatch
               '#(engine:)
               std/crypto/pkey#digest-verify__@
               _args609816609844_)))))
