(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/net/ssl/libssl::timestamp 1701959121)
  (begin
    (define-macro (define-guard guard defn)
      (if (eval `(cond-expand
                  (gerbil-separate-compilation #f)
                  (,guard #t)
                  (else #f)))
          '(begin)
          (begin (eval `(define-cond-expand-feature ,guard)) defn)))
    (define-macro (define-c-lambda id args ret #!optional (name #f))
      (let ((name (or name (symbol->string id))))
        `(define ,id (c-lambda ,args ,ret ,name))))
    (define-macro (define-const symbol)
      (let* ((str (symbol->string symbol))
             (ref (string-append "___return (" str ");")))
        `(define ,symbol ((c-lambda () int ,ref)))))
    (define-macro (define-const* symbol #!optional (ccond #f))
      (let* ((str (symbol->string symbol))
             (code (string-append
                    "#if "
                    (or ccond (string-append "defined(" str ")"))
                    "\n"
                    "___return (___FIX ("
                    str
                    "));\n"
                    "#else \n"
                    "___return (___FAL);\n"
                    "#endif")))
        `(define ,symbol ((c-lambda () scheme-object ,code)))))
    (define-macro (define-with-errno symbol ffi-symbol args)
      `(define (,symbol ,@args)
         (declare (not interrupts-enabled))
         (let ((r (,ffi-symbol ,@args)))
           (if (##fx< r 0)
               (##fx- (##c-code "___RESULT = ___FIX (errno);"))
               r))))
    (define-macro (define-c-struct
                   struct
                   #!optional
                   (members '())
                   release-function
                   compatible-tags
                   as-typedef)
      (let* ((struct-str (symbol->string struct))
             (struct-ptr (string->symbol (string-append struct-str "*")))
             (shallow-ptr
              (string->symbol (string-append struct-str "-shallow-ptr*")))
             (borrowed-ptr
              (string->symbol (string-append struct-str "-borrowed-ptr*")))
             (struct-keyword? (if as-typedef "" "struct "))
             (string-types
              '(char-string
                nonull-char-string
                UTF-8-string
                nonnull-UTF-8-string
                UTF-16-string
                nonnull-UTF16-string))
             (string-compat-required?
              (let loop ((m members))
                (cond ((null? m) #f)
                      ((member (cdr (car m)) string-types) #t)
                      (else (loop (cdr m))))))
             (string-setter-body
              (lambda (member-name)
                (let ((m (string-append "___arg1->" member-name)))
                  (string-append
                   "if("
                   m
                   " == NULL)"
                   "\n"
                   m
                   "= strdup(___arg2);"
                   "\n"
                   "else if (strcmp("
                   m
                   ", ___arg2) != 0) {"
                   "\n"
                   "free("
                   m
                   ");"
                   "\n"
                   m
                   "= strdup(___arg2);"
                   "\n"
                   "}"
                   "\n"
                   "___return;"
                   "\n"))))
             (default-free-body
              (and string-compat-required?
                   (string-append
                    "___SCMOBJ "
                    struct-str
                    "_ffi_free (void *ptr) {"
                    "\n"
                    struct-keyword?
                    struct-str
                    " *obj = ("
                    struct-keyword?
                    struct-str
                    "*) ptr;"
                    "\n"
                    (apply string-append
                           (map (lambda (m)
                                  (cond ((memq (cdr m) string-types)
                                         (let ((mem-name
                                                (symbol->string (car m))))
                                           (string-append
                                            "if(obj->"
                                            mem-name
                                            ") "
                                            "free(obj->"
                                            mem-name
                                            ");"
                                            "\n")))
                                        (else "")))
                                members))
                    "free(obj);"
                    "\n"
                    "return ___FIX (___NO_ERR);"
                    "\n"
                    "}")))
             (release-function
              (or release-function
                  (if string-compat-required?
                      (string-append struct-str "_ffi_free")
                      "ffi_free")))
             (string-compat-types
              (if string-compat-required?
                  `((c-declare ,default-free-body)
                    (c-define-type
                     ,shallow-ptr
                     (pointer ,struct (,struct-ptr) "ffi_free")))
                  '()))
             (compatible-tags (or compatible-tags '()))
             (ptr-tags
              (map (lambda (t)
                     (string->symbol (string-append (symbol->string t) "*")))
                   compatible-tags)))
        `(begin
           (c-define-type
            ,struct
            (,(if as-typedef 'type 'struct)
             ,struct-str
             (,struct ,@compatible-tags)))
           (c-define-type
            ,struct-ptr
            (pointer ,struct (,struct-ptr ,@ptr-tags) ,release-function))
           (c-define-type ,borrowed-ptr (pointer ,struct (,struct-ptr)))
           ,@string-compat-types
           (define ,(string->symbol (string-append struct-str "-ptr?"))
             (lambda (obj)
               (and (foreign? obj) (member ',struct-ptr (foreign-tags obj)))))
           ,@(apply append
                    (map (lambda (m)
                           (let* ((member-name (symbol->string (car m)))
                                  (member-type (cdr m))
                                  (getter-name
                                   (string-append struct-str "-" member-name))
                                  (setter-body
                                   (cond ((member member-type string-types)
                                          (string-setter-body member-name))
                                         (else
                                          (string-append
                                           "___arg1->"
                                           member-name
                                           " = ___arg2;"
                                           "\n"
                                           "___return;"
                                           "\n")))))
                             `((define ,(string->symbol getter-name)
                                 (c-lambda
                                  (,struct-ptr)
                                  ,member-type
                                  ,(string-append
                                    "___return(___arg1->"
                                    member-name
                                    ");")))
                               (define ,(string->symbol
                                         (string-append getter-name "-set!"))
                                 (c-lambda
                                  (,struct-ptr ,member-type)
                                  void
                                  ,setter-body)))))
                         members))
           (define ,(string->symbol (string-append "malloc-" struct-str))
             (c-lambda
              ()
              ,struct-ptr
              ,(string-append
                struct-keyword?
                struct-str
                "* var = ("
                struct-keyword?
                struct-str
                " *) malloc(sizeof("
                struct-keyword?
                struct-str
                "));"
                "\n"
                "if (var == NULL)"
                "\n"
                "    ___return (NULL);"
                "\n"
                "memset(var, 0, sizeof("
                struct-keyword?
                struct-str
                "));"
                "___return(var);")))
           (define ,(string->symbol (string-append "ptr->" struct-str))
             (c-lambda (,struct-ptr) ,struct "___return(*___arg1);"))
           (define ,(string->symbol
                     (string-append "malloc-" struct-str "-array"))
             (c-lambda
              (unsigned-int32)
              ,(if string-compat-required? shallow-ptr struct-ptr)
              ,(string-append
                struct-keyword?
                struct-str
                " *arr_var=("
                struct-keyword?
                struct-str
                " *) malloc(___arg1*sizeof("
                struct-keyword?
                struct-str
                "));"
                "\n"
                "if (arr_var == NULL)"
                "\n"
                "    ___return (NULL);"
                "\n"
                "memset(arr_var, 0, ___arg1*sizeof("
                struct-keyword?
                struct-str
                "));"
                "\n"
                "___return(arr_var);")))
           (define ,(string->symbol (string-append struct-str "-array-ref"))
             (c-lambda
              (,struct-ptr unsigned-int32)
              ,borrowed-ptr
              "___return (___arg1 + ___arg2);"))
           (define ,(string->symbol (string-append struct-str "-array-set!"))
             (c-lambda
              (,struct-ptr unsigned-int32 ,struct-ptr)
              void
              "*(___arg1 + ___arg2) = *___arg3; ___return;")))))
    (c-declare "#include <stdlib.h>")
    (c-declare "#include <string.h>")
    (c-declare "#include <errno.h>")
    (c-declare "static ___SCMOBJ ffi_free (void *ptr);")
    (c-declare
     "#ifndef ___HAVE_FFI_U8VECTOR\n#define ___HAVE_FFI_U8VECTOR\n#define U8_DATA(obj) ___CAST (___U8*, ___BODY_AS (obj, ___tSUBTYPED))\n#define U8_LEN(obj) ___HD_BYTES (___HEADER (obj))\n#endif")
    (namespace
     ("std/net/ssl/libssl#"
      TLS1_3_VERSION
      TLS1_2_VERSION
      TLS1_1_VERSION
      TLS1_VERSION
      make-actor-tls-context
      make-server-ssl-context/v
      make-server-ssl-context
      make-insecure-client-ssl-context
      make-client-ssl-context/v
      make-client-ssl-context
      X509_get_san_uris
      X509_get_subject_name
      X509_read
      SSL_ERROR_WANT_WRITE
      SSL_ERROR_WANT_READ
      SSL_get_peer_certificate
      SSL_set_fd
      SSL_set_host
      SSL_shutdown
      SSL_write
      SSL_read
      SSL_accept
      SSL_connect
      SSL_new))
    (c-declare
     "#include <openssl/ssl.h>\n#include <openssl/conf.h>\n#include <openssl/err.h>\n#include <openssl/bio.h>\n\n#include <openssl/x509v3.h>\nstatic int ffi_sk_GENERAL_NAME_num(const STACK_OF(GENERAL_NAME) *sk)\n{\n  return OPENSSL_sk_num((const OPENSSL_STACK *)sk);\n}\n\nstatic GENERAL_NAME *ffi_sk_GENERAL_NAME_value(const STACK_OF(GENERAL_NAME) *sk, int idx)\n{\n  return (GENERAL_NAME *)OPENSSL_sk_value((const OPENSSL_STACK *)sk, idx);\n}\n\nstatic int ffi_ssl_gerbil_data_index;\n\nstatic ___SCMOBJ ffi_release_SSL_CTX (void *ptr)\n{\n SSL_CTX_free((SSL_CTX*) ptr);\n return ___FIX (___NO_ERR);\n}\n\n\nstatic ___SCMOBJ ffi_release_SSL (void *ptr)\n{\n SSL_free((SSL*) ptr);\n return ___FIX (___NO_ERR);\n}\n\nstatic ___SCMOBJ ffi_release_X509 (void *ptr)\n{\n X509_free((X509*) ptr);\n return ___FIX (___NO_ERR);\n}\n\nstatic ___SCMOBJ ffi_ssl_error(SSL *ssl, int r)\n{\n unsigned long last = ERR_peek_last_error();\n int err = SSL_get_error(ssl, r);\n switch (err) {\n  case SSL_ERROR_WANT_READ:\n   return ___CHR(114);\n  case SSL_ERROR_WANT_WRITE:\n   return ___CHR(119);\n  case SSL_ERROR_ZERO_RETURN:\n   return ___FIX(0);\n   default: {\n   ___processor_state ___ps = ___GET_PSTATE();\n   ___SCMOBJ result = ___make_pair(___ps, ___FIX(last), ___NUL);\n   ___release_scmobj(result);\n   result = ___make_pair(___ps, ___FIX(err), result);\n   ___release_scmobj(result);\n   result = ___make_pair(___ps, ___FIX(r), result);\n   ___release_scmobj(result);\n   return result;\n   }\n }\n}\n\nstatic SSL* ffi_ssl_new(SSL_CTX *ctx)\n{\n SSL *ssl = SSL_new(ctx);\n if (!ssl) {\n  return NULL;\n }\n\n void *ctxdata = SSL_CTX_get_app_data(ctx);\n if (ctxdata) {\n   SSL_set_ex_data(ssl, ffi_ssl_gerbil_data_index, ctxdata);\n }\n\n return ssl;\n}\n\nstatic ___SCMOBJ ffi_ssl_connect(SSL *ssl)\n{\n int r = SSL_connect(ssl);\n if (r > 0) {\n  return ___FIX(r);\n }\n\n return ffi_ssl_error(ssl, r);\n}\n\nstatic ___SCMOBJ ffi_ssl_accept(SSL *ssl)\n{\n int r = SSL_accept(ssl);\n if (r > 0) {\n  return ___FIX(r);\n }\n\n return ffi_ssl_error(ssl, r);\n}\n\nstatic ___SCMOBJ ffi_ssl_read(SSL *ssl, ___SCMOBJ buf, int start, int end)\n{\n int r = SSL_read(ssl, U8_DATA (buf) + start, end - start);\n if (r > 0) {\n  return ___FIX(r);\n }\n\n return ffi_ssl_error(ssl, r);\n}\n\nstatic ___SCMOBJ ffi_ssl_write(SSL *ssl, ___SCMOBJ buf, int start, int end)\n{\n int r = SSL_write(ssl, U8_DATA (buf) + start, end - start);\n if (r > 0) {\n  return ___FIX(r);\n }\n\n return ffi_ssl_error(ssl, r);\n}\n\nstatic ___SCMOBJ ffi_ssl_shutdown(SSL *ssl)\n{\n int r = SSL_shutdown(ssl);\n if (r > 0) {\n  return ___FIX(r);\n }\n\n return ffi_ssl_error(ssl, r);\n}\n\nstatic ___SCMOBJ ffi_ssl_set_host(SSL *ssl, char* hostname)\n{\n int r = SSL_set1_host(ssl, hostname);\n if (r <= 0) {\n  return ffi_ssl_error(ssl, r);\n }\n\n r = SSL_set_tlsext_host_name(ssl, hostname);\n if (r <= 0) {\n  return ffi_ssl_error(ssl, r);\n }\n\n return ___FIX(r);\n}\n\nstatic ___SCMOBJ ffi_ssl_set_fd(SSL *ssl, int fd)\n{\n int r = SSL_set_fd(ssl, fd);\n if (r > 0) {\n  return ___FIX(r);\n }\n\n return ffi_ssl_error(ssl, r);\n }\n\nstatic SSL_CTX *ffi_client_ssl_ctx(int min_protocol_version)\n{\n SSL_CTX *ctx = SSL_CTX_new(TLS_client_method());\n if (!ctx) {\n  return NULL;\n }\n\n int r = SSL_CTX_set_min_proto_version(ctx, min_protocol_version);\n if (r <= 0) {\n   ERR_print_errors_fp(stderr);\n   SSL_CTX_free(ctx);\n   return NULL;\n }\n\n SSL_CTX_set_default_verify_paths(ctx);\n SSL_CTX_set_verify(ctx, SSL_VERIFY_PEER, NULL);\n return ctx;\n}\n\nstatic int ffi_ssl_verify_insecure(int preverify, X509_STORE_CTX *ctx)\n{\n return 1;\n}\n\nstatic SSL_CTX *ffi_insecure_ssl_ctx()\n{\n SSL_CTX *ctx = SSL_CTX_new(TLS_method());\n if (!ctx) {\n  return NULL;\n }\n\n SSL_CTX_set_verify(ctx, SSL_VERIFY_NONE, ffi_ssl_verify_insecure);\n return ctx;\n}\n\nstatic SSL_CTX *ffi_server_ssl_ctx(const char *cert_path, const char *privk_path, int min_protocol_version)\n{\n SSL_CTX *ctx = SSL_CTX_new(TLS_server_method());\n if (!ctx) {\n  return NULL;\n }\n\n int r = SSL_CTX_set_min_proto_version(ctx, min_protocol_version);\n  if (r <= 0) {\n   ERR_print_errors_fp(stderr);\n   SSL_CTX_free(ctx);\n   return NULL;\n }\n\n\n r = SSL_CTX_use_certificate_file(ctx, cert_path, SSL_FILETYPE_PEM);\n if (r <= 0) {\n  SSL_CTX_free(ctx);\n  ERR_print_errors_fp(stderr);\n  return NULL;\n  }\n\n r = SSL_CTX_use_PrivateKey_file(ctx, privk_path, SSL_FILETYPE_PEM);\n if (r <= 0) {\n  ERR_print_errors_fp(stderr);\n  SSL_CTX_free(ctx);\n  return NULL;\n  }\n\n SSL_CTX_set_verify(ctx, SSL_VERIFY_NONE, NULL);\n return ctx;\n}\n\nstatic int ffi_ssl_verify_actor(int preverify, X509_STORE_CTX *ctx)\n{\n if (preverify) {\n  return 1;\n }\n\n // this dance is REQUIRED because openssl won't accept a self-signed root CA otherwise.\n SSL *ssl = X509_STORE_CTX_get_ex_data(ctx, SSL_get_ex_data_X509_STORE_CTX_idx());\n STACK_OF(X509) *catrust = SSL_get_ex_data(ssl, ffi_ssl_gerbil_data_index);\n if (!catrust) {\n  return 0;\n }\n\n X509_STORE_CTX_set0_trusted_stack(ctx, catrust);\n return X509_verify_cert(ctx);\n}\n\nstatic X509 *ffi_X509_read(const char *path);\nstatic SSL_CTX *ffi_actor_tls_ctx(const char *caroot, const char *ca_file, const char *ca_path, const char *cert_chain_path, const char *privk_path)\n{\n int r;\n\n SSL_CTX *ctx = SSL_CTX_new(TLS_method());\n if (!ctx) {\n  return NULL;\n }\n\n // this dance is REQUIRED because openssl won't accept a self-signed root CA otherwise.\n X509 *caroot_cert = ffi_X509_read(caroot);\n if (caroot_cert) {\n  STACK_OF(X509) *catrust = sk_X509_new_null();\n  sk_X509_push(catrust, caroot_cert);\n\n  r = SSL_CTX_set_min_proto_version(ctx, TLS1_2_VERSION);\n  if (r <= 0) {\n   ERR_print_errors_fp(stderr);\n   SSL_CTX_free(ctx);\n   return NULL;\n }\n\n  r = SSL_CTX_set_app_data(ctx, catrust);\n  if (r <= 0) {\n   ERR_print_errors_fp(stderr);\n   SSL_CTX_free(ctx);\n   return NULL;\n  }\n }\n\n r = SSL_CTX_set_session_id_context(ctx, \"gerbil\", 6);\n if (r <= 0) {\n  ERR_print_errors_fp(stderr);\n  SSL_CTX_free(ctx);\n  return NULL;\n }\n\n r = SSL_CTX_use_certificate_chain_file(ctx, cert_chain_path);\n if (r <= 0) {\n  ERR_print_errors_fp(stderr);\n  SSL_CTX_free(ctx);\n  return NULL;\n }\n\n r = SSL_CTX_use_PrivateKey_file(ctx, privk_path, SSL_FILETYPE_PEM);\n if (r <= 0) {\n  ERR_print_errors_fp(stderr);\n  SSL_CTX_free(ctx);\n  return NULL;\n }\n\n r = SSL_CTX_load_verify_locations(ctx, ca_file, ca_path);\n if (r <= 0) {\n  ERR_print_errors_fp(stderr);\n  SSL_CTX_free(ctx);\n  return NULL;\n }\n\n r = SSL_CTX_build_cert_chain(ctx, SSL_BUILD_CHAIN_FLAG_CHECK);\n if (r <= 0) {\n  ERR_print_errors_fp(stderr);\n  SSL_CTX_free(ctx);\n  return NULL;\n }\n\n SSL_CTX_set_client_CA_list(ctx, SSL_load_client_CA_file(ca_file));\n SSL_CTX_set_verify(ctx, SSL_VERIFY_PEER|SSL_VERIFY_FAIL_IF_NO_PEER_CERT|0, ffi_ssl_verify_actor);\n return ctx;\n}\n\n__thread char openssl_x509_name_buf[16384];\nstatic char *ffi_X509_get_subject_name(X509 *cert)\n{\n X509_NAME *name = X509_get_subject_name(cert);\n if (!name) {\n  return NULL;\n }\n\n int r = X509_NAME_get_text_by_NID(name, NID_commonName, openssl_x509_name_buf, sizeof(openssl_x509_name_buf));\n if (r <= 0) {\n  return NULL;\n }\n\n return openssl_x509_name_buf;\n}\n\nstatic char *ffi_X509_get_san_uris(X509 *cert)\n{\n int cursor = 0;\n\n STACK_OF(GENERAL_NAME) *san_names = X509_get_ext_d2i(cert, NID_subject_alt_name, NULL, NULL);\n if (san_names == NULL) {\n  return NULL;\n }\n\n int count = ffi_sk_GENERAL_NAME_num(san_names);\n for (int i = 0; i < count; i++) {\n  const GENERAL_NAME *name = ffi_sk_GENERAL_NAME_value(san_names, i);\n  if (name->type == GEN_URI) {\n   int len = ASN1_STRING_length(name->d.uniformResourceIdentifier);\n   if (cursor + len < sizeof(openssl_x509_name_buf) - 2) {\n    const char *uri = ASN1_STRING_get0_data(name->d.uniformResourceIdentifier);\n    memcpy(openssl_x509_name_buf + cursor, uri, len);\n    cursor += len;\n    openssl_x509_name_buf[cursor] = ',';\n    cursor++;\n   } else {\n    openssl_x509_name_buf[cursor] = 0;\n    return  openssl_x509_name_buf;\n   }\n  }\n }\n\n if (!cursor) {\n  return NULL;\n }\n\n openssl_x509_name_buf[cursor] = 0;\n return openssl_x509_name_buf;\n}\n\nstatic X509 *ffi_X509_read(const char *path)\n{\n BIO *bp = BIO_new(BIO_s_file());\n if (!bp) {\n  return NULL;\n }\n\n int r = BIO_read_filename(bp, path);\n if (r <= 0) {\n  ERR_print_errors_fp(stderr);\n  return NULL;\n }\n\n X509 *x509 = PEM_read_bio_X509(bp, NULL, 0, NULL);\n if (!x509) {\n  ERR_print_errors_fp(stderr);\n  BIO_free(bp);\n  return NULL;\n }\n\n BIO_free(bp);\n return x509;\n}\n")
    (c-initialize
     "OPENSSL_init_ssl(0, NULL);\nffi_ssl_gerbil_data_index = SSL_get_ex_new_index(0, \"gerbil data\", NULL, NULL, NULL);")
    (define SSL_ERROR_WANT_READ #\r)
    (define SSL_ERROR_WANT_WRITE #\w)
    (c-define-type SSL_METHOD "SSL_METHOD")
    (c-define-type SSL_METHOD* (pointer SSL_METHOD (SSL_METHOD*)))
    (c-define-type SSL_CTX "SSL_CTX")
    (c-define-type SSL_CTX* (pointer SSL_CTX (SSL_CTX*) "ffi_release_SSL_CTX"))
    (c-define-type SSL "SSL")
    (c-define-type SSL* (pointer SSL (SSL*) "ffi_release_SSL"))
    (c-define-type X509 "X509")
    (c-define-type X509* (pointer X509 (X509*) "ffi_release_X509"))
    (define-c-lambda SSL_new (SSL_CTX*) SSL* "ffi_ssl_new")
    (define-c-lambda SSL_connect (SSL*) scheme-object "ffi_ssl_connect")
    (define-c-lambda SSL_accept (SSL*) scheme-object "ffi_ssl_accept")
    (define-c-lambda
     SSL_read
     (SSL* scheme-object int int)
     scheme-object
     "ffi_ssl_read")
    (define-c-lambda
     SSL_write
     (SSL* scheme-object int int)
     scheme-object
     "ffi_ssl_write")
    (define-c-lambda SSL_shutdown (SSL*) scheme-object "ffi_ssl_shutdown")
    (define-c-lambda
     SSL_set_host
     (SSL* char-string)
     scheme-object
     "ffi_ssl_set_host")
    (define-c-lambda SSL_set_fd (SSL* int) scheme-object "ffi_ssl_set_fd")
    (define-c-lambda SSL_get_peer_certificate (SSL*) X509*)
    (define-const TLS1_VERSION)
    (define-const TLS1_1_VERSION)
    (define-const TLS1_2_VERSION)
    (define-const TLS1_3_VERSION)
    (define (make-client-ssl-context
             #!optional
             (min-protocol-version TLS1_2_VERSION))
      (make-client-ssl-context/v min-protocol-version))
    (define (make-server-ssl-context
             cert-path
             key-path
             #!optional
             (min-protocol-version TLS1_2_VERSION))
      (make-server-ssl-context/v cert-path key-path min-protocol-version))
    (define-c-lambda
     make-client-ssl-context/v
     (int)
     SSL_CTX*
     "ffi_client_ssl_ctx")
    (define-c-lambda
     make-insecure-client-ssl-context
     ()
     SSL_CTX*
     "ffi_insecure_ssl_ctx")
    (define-c-lambda
     make-server-ssl-context/v
     (char-string char-string int)
     SSL_CTX*
     "ffi_server_ssl_ctx")
    (define-c-lambda
     make-actor-tls-context
     (char-string char-string char-string char-string char-string)
     SSL_CTX*
     "ffi_actor_tls_ctx")
    (define-c-lambda
     X509_get_subject_name
     (X509*)
     char-string
     "ffi_X509_get_subject_name")
    (define-c-lambda
     X509_get_san_uris
     (X509*)
     char-string
     "ffi_X509_get_san_uris")
    (define-c-lambda X509_read (char-string) X509* "ffi_X509_read")
    (c-declare
     "#ifndef ___HAVE_FFI_FREE\n#define ___HAVE_FFI_FREE\n___SCMOBJ ffi_free (void *ptr)\n{\n free (ptr);\n return ___FIX (___NO_ERR);\n}\n#endif")))
