(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/19::timestamp 1701958835)
  (begin
    (define std/srfi/19#time-tai 'time-tai)
    (define std/srfi/19#time-utc 'time-utc)
    (define std/srfi/19#time-monotonic 'time-monotonic)
    (define std/srfi/19#time-thread 'time-thread)
    (define std/srfi/19#time-process 'time-process)
    (define std/srfi/19#time-duration 'time-duration)
    (define std/srfi/19#tm:locale-number-separator '".")
    (define std/srfi/19#tm:locale-abbr-weekday-vector
      (vector '"Sun" '"Mon" '"Tue" '"Wed" '"Thu" '"Fri" '"Sat"))
    (define std/srfi/19#tm:locale-long-weekday-vector
      (vector '"Sunday"
              '"Monday"
              '"Tuesday"
              '"Wednesday"
              '"Thursday"
              '"Friday"
              '"Saturday"))
    (define std/srfi/19#tm:locale-abbr-month-vector
      (vector '""
              '"Jan"
              '"Feb"
              '"Mar"
              '"Apr"
              '"May"
              '"Jun"
              '"Jul"
              '"Aug"
              '"Sep"
              '"Oct"
              '"Nov"
              '"Dec"))
    (define std/srfi/19#tm:locale-long-month-vector
      (vector '""
              '"January"
              '"February"
              '"March"
              '"April"
              '"May"
              '"June"
              '"July"
              '"August"
              '"September"
              '"October"
              '"November"
              '"December"))
    (define std/srfi/19#tm:locale-pm '"PM")
    (define std/srfi/19#tm:locale-am '"AM")
    (define std/srfi/19#tm:locale-date-time-format '"~a ~b ~d ~H:~M:~S~z ~Y")
    (define std/srfi/19#tm:locale-short-date-format '"~m/~d/~y")
    (define std/srfi/19#tm:locale-time-format '"~H:~M:~S")
    (define std/srfi/19#tm:iso-8601-date-time-format '"~Y-~m-~dT~H:~M:~S~z")
    (define std/srfi/19#tm:nano (expt '10 '9))
    (define std/srfi/19#tm:sid '86400)
    (define std/srfi/19#tm:sihd '43200)
    (define std/srfi/19#tm:tai-epoch-in-jd '4881175/2)
    (define std/srfi/19#tm:time-error-types
      '(invalid-clock-type
        unsupported-clock-type
        incompatible-time-types
        not-duration
        dates-are-immutable
        bad-date-format-string
        bad-date-template-string
        invalid-month-specification))
    (define std/srfi/19#tm:time-error
      (lambda (_caller111001_ _type111002_ _value111003_)
        (if (member _type111002_ std/srfi/19#tm:time-error-types)
            (if _value111003_
                (let ()
                  (declare (not safe))
                  (error '"TIME-ERROR type"
                         _caller111001_
                         _type111002_
                         _value111003_))
                (let ()
                  (declare (not safe))
                  (error '"TIME-ERROR type" _caller111001_ _type111002_)))
            (let ()
              (declare (not safe))
              (error '"TIME-ERROR unsupported error type"
                     _caller111001_
                     _type111002_)))))
    (define std/srfi/19#tm:read-tai-utc-data
      (lambda (_filename110976_)
        (letrec ((_convert-jd110978_
                  (lambda (_jd110999_)
                    (* (- (inexact->exact _jd110999_)
                          std/srfi/19#tm:tai-epoch-in-jd)
                       std/srfi/19#tm:sid)))
                 (_convert-sec110979_
                  (lambda (_sec110997_) (inexact->exact _sec110997_))))
          (let ((_port110981_ (open-input-file _filename110976_))
                (_table110982_ '()))
            (let _loop110984_ ((_line110986_ (read-line _port110981_)))
              (if (let ((__tmp955572
                         (let ()
                           (declare (not safe))
                           (eof-object? _line110986_))))
                    (declare (not safe))
                    (not __tmp955572))
                  (let* ((_data110988_
                          (read (open-input-string
                                 (string-append '"(" _line110986_ '")"))))
                         (_year110990_ (car _data110988_))
                         (_jd110992_ (cadddr (cdr _data110988_)))
                         (_secs110994_ (cadddr (cdddr _data110988_))))
                    (if (>= _year110990_ '1972)
                        (set! _table110982_
                              (let ((__tmp955568
                                     (let ((__tmp955570
                                            (let ()
                                              (declare (not safe))
                                              (_convert-jd110978_ _jd110992_)))
                                           (__tmp955569
                                            (let ()
                                              (declare (not safe))
                                              (inexact->exact _secs110994_))))
                                       (declare (not safe))
                                       (cons __tmp955570 __tmp955569))))
                                (declare (not safe))
                                (cons __tmp955568 _table110982_)))
                        '#!void)
                    (let ((__tmp955571 (read-line _port110981_)))
                      (declare (not safe))
                      (_loop110984_ __tmp955571)))
                  '#!void))
            _table110982_))))
    (define std/srfi/19#tm:leap-second-table
      '((1483228800 . 37)
        (1435708800 . 36)
        (1341100800 . 35)
        (1230768000 . 34)
        (1136073600 . 33)
        (915148800 . 32)
        (867715200 . 31)
        (820454400 . 30)
        (773020800 . 29)
        (741484800 . 28)
        (709948800 . 27)
        (662688000 . 26)
        (631152000 . 25)
        (567993600 . 24)
        (489024000 . 23)
        (425865600 . 22)
        (394329600 . 21)
        (362793600 . 20)
        (315532800 . 19)
        (283996800 . 18)
        (252460800 . 17)
        (220924800 . 16)
        (189302400 . 15)
        (157766400 . 14)
        (126230400 . 13)
        (94694400 . 12)
        (78796800 . 11)
        (63072000 . 10)))
    (define std/srfi/19#read-leap-second-table
      (lambda (_filename110974_)
        (set! std/srfi/19#tm:leap-second-table
              (let ()
                (declare (not safe))
                (std/srfi/19#tm:read-tai-utc-data _filename110974_)))
        '#!void))
    (define std/srfi/19#tm:leap-second-delta
      (lambda (_utc-seconds110968_)
        (letrec ((_lsd110970_
                  (lambda (_table110972_)
                    (if (>= _utc-seconds110968_ (caar _table110972_))
                        (cdar _table110972_)
                        (let ((__tmp955573 (cdr _table110972_)))
                          (declare (not safe))
                          (_lsd110970_ __tmp955573))))))
          (if (< _utc-seconds110968_
                 (* (- '1972 '1970) '365 std/srfi/19#tm:sid))
              '0
              (let ()
                (declare (not safe))
                (_lsd110970_ std/srfi/19#tm:leap-second-table))))))
    (define std/srfi/19#tm:leap-second-neg-delta
      (lambda (_tai-seconds110962_)
        (letrec ((_lsd110964_
                  (lambda (_table110966_)
                    (if (let () (declare (not safe)) (null? _table110966_))
                        '0
                        (if (<= (cdar _table110966_)
                                (- _tai-seconds110962_ (caar _table110966_)))
                            (cdar _table110966_)
                            (let ((__tmp955574 (cdr _table110966_)))
                              (declare (not safe))
                              (_lsd110964_ __tmp955574)))))))
          (if (< _tai-seconds110962_
                 (* (- '1972 '1970) '365 std/srfi/19#tm:sid))
              '0
              (let ()
                (declare (not safe))
                (_lsd110964_ std/srfi/19#tm:leap-second-table))))))
    (define std/srfi/19#time::t
      (let ()
        (declare (not safe))
        (make-struct-type
         'std/srfi/19#time::t
         '#f
         '3
         'time
         '((transparent: . #t))
         '#f
         '(type nanosecond second))))
    (define std/srfi/19#time?
      (let ()
        (declare (not safe))
        (make-struct-predicate std/srfi/19#time::t)))
    (define std/srfi/19#make-time
      (lambda _$args110959_
        (apply make-struct-instance std/srfi/19#time::t _$args110959_)))
    (define std/srfi/19#time-type
      (let ()
        (declare (not safe))
        (make-struct-field-accessor std/srfi/19#time::t '0)))
    (define std/srfi/19#time-nanosecond
      (let ()
        (declare (not safe))
        (make-struct-field-accessor std/srfi/19#time::t '1)))
    (define std/srfi/19#time-second
      (let ()
        (declare (not safe))
        (make-struct-field-accessor std/srfi/19#time::t '2)))
    (define std/srfi/19#time-type-set!
      (let ()
        (declare (not safe))
        (make-struct-field-mutator std/srfi/19#time::t '0)))
    (define std/srfi/19#time-nanosecond-set!
      (let ()
        (declare (not safe))
        (make-struct-field-mutator std/srfi/19#time::t '1)))
    (define std/srfi/19#time-second-set!
      (let ()
        (declare (not safe))
        (make-struct-field-mutator std/srfi/19#time::t '2)))
    (define std/srfi/19#&time-type
      (let ()
        (declare (not safe))
        (make-struct-field-unchecked-accessor std/srfi/19#time::t '0)))
    (define std/srfi/19#&time-nanosecond
      (let ()
        (declare (not safe))
        (make-struct-field-unchecked-accessor std/srfi/19#time::t '1)))
    (define std/srfi/19#&time-second
      (let ()
        (declare (not safe))
        (make-struct-field-unchecked-accessor std/srfi/19#time::t '2)))
    (define std/srfi/19#&time-type-set!
      (let ()
        (declare (not safe))
        (make-struct-field-unchecked-mutator std/srfi/19#time::t '0)))
    (define std/srfi/19#&time-nanosecond-set!
      (let ()
        (declare (not safe))
        (make-struct-field-unchecked-mutator std/srfi/19#time::t '1)))
    (define std/srfi/19#&time-second-set!
      (let ()
        (declare (not safe))
        (make-struct-field-unchecked-mutator std/srfi/19#time::t '2)))
    (define std/srfi/19#make-time%
      (lambda (_type110937_ _nanosecond110938_ _second110939_)
        (let ((_$e110941_ _type110937_))
          (if (or (let () (declare (not safe)) (eq? 'time-tai _$e110941_))
                  (let () (declare (not safe)) (eq? 'time-utc _$e110941_))
                  (let ()
                    (declare (not safe))
                    (eq? 'time-monotonic _$e110941_))
                  (let () (declare (not safe)) (eq? 'time-thread _$e110941_))
                  (let () (declare (not safe)) (eq? 'time-process _$e110941_))
                  (let ()
                    (declare (not safe))
                    (eq? 'time-duration _$e110941_)))
              '#t
              (let ()
                (declare (not safe))
                (error '"Wrong time type" _type110937_))))
        (if (exact-integer? _second110939_)
            '#!void
            (let ()
              (declare (not safe))
              (error '"Invalid time second" _second110939_)))
        (if (and (exact-integer? _nanosecond110938_)
                 (<= (if (let ()
                           (declare (not safe))
                           (eq? _type110937_ std/srfi/19#time-duration))
                         '-999999999
                         '0)
                     _nanosecond110938_
                     '999999999))
            '#!void
            (let ()
              (declare (not safe))
              (error '"Invalid time nanosecond" _nanosecond110938_)))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/19#time::t
           _type110937_
           _nanosecond110938_
           _second110939_))))
    (define std/srfi/19#copy-time
      (lambda (_time110935_)
        (let ((__tmp955577
               (##structure-ref _time110935_ '1 std/srfi/19#time::t '#f))
              (__tmp955576
               (##structure-ref _time110935_ '2 std/srfi/19#time::t '#f))
              (__tmp955575
               (##structure-ref _time110935_ '3 std/srfi/19#time::t '#f)))
          (declare (not safe))
          (##structure
           std/srfi/19#time::t
           __tmp955577
           __tmp955576
           __tmp955575))))
    (define std/srfi/19#current-seconds
      (lambda ()
        (inexact->exact
         (floor (let () (declare (not safe)) (##current-time-point))))))
    (define std/srfi/19#current-milliseconds
      (lambda ()
        (inexact->exact
         (floor (fl* '1000.
                     (let () (declare (not safe)) (##current-time-point)))))))
    (define std/srfi/19#tm:get-time-of-day
      (lambda ()
        (let* ((_now110928_
                (let () (declare (not safe)) (##current-time-point)))
               (_sec110930_ (floor _now110928_)))
          (values (inexact->exact _sec110930_)
                  (inexact->exact
                   (floor (fl* (fl- _now110928_ _sec110930_)
                               '1000000000.)))))))
    (define std/srfi/19#tm:current-time-utc
      (lambda ()
        (let ((_g955578_
               (let () (declare (not safe)) (std/srfi/19#tm:get-time-of-day))))
          (begin
            (let ((_g955579_
                   (let ()
                     (declare (not safe))
                     (if (##values? _g955578_)
                         (##vector-length _g955578_)
                         1))))
              (if (not (let () (declare (not safe)) (##fx= _g955579_ 2)))
                  (error "Context expects 2 values" _g955579_)))
            (let ((_seconds110924_
                   (let () (declare (not safe)) (##vector-ref _g955578_ 0)))
                  (_ns110925_
                   (let () (declare (not safe)) (##vector-ref _g955578_ 1))))
              (let ()
                (declare (not safe))
                (##structure
                 std/srfi/19#time::t
                 std/srfi/19#time-utc
                 _ns110925_
                 _seconds110924_)))))))
    (define std/srfi/19#tm:current-time-tai
      (lambda ()
        (let ((_g955580_
               (let () (declare (not safe)) (std/srfi/19#tm:get-time-of-day))))
          (begin
            (let ((_g955581_
                   (let ()
                     (declare (not safe))
                     (if (##values? _g955580_)
                         (##vector-length _g955580_)
                         1))))
              (if (not (let () (declare (not safe)) (##fx= _g955581_ 2)))
                  (error "Context expects 2 values" _g955581_)))
            (let ((_seconds110920_
                   (let () (declare (not safe)) (##vector-ref _g955580_ 0)))
                  (_ns110921_
                   (let () (declare (not safe)) (##vector-ref _g955580_ 1))))
              (let ((__tmp955582
                     (+ _seconds110920_
                        (let ()
                          (declare (not safe))
                          (std/srfi/19#tm:leap-second-delta
                           _seconds110920_)))))
                (declare (not safe))
                (##structure
                 std/srfi/19#time::t
                 std/srfi/19#time-tai
                 _ns110921_
                 __tmp955582)))))))
    (define std/srfi/19#tm:current-time-monotonic
      (lambda ()
        (let ((_g955583_
               (let () (declare (not safe)) (std/srfi/19#tm:get-time-of-day))))
          (begin
            (let ((_g955584_
                   (let ()
                     (declare (not safe))
                     (if (##values? _g955583_)
                         (##vector-length _g955583_)
                         1))))
              (if (not (let () (declare (not safe)) (##fx= _g955584_ 2)))
                  (error "Context expects 2 values" _g955584_)))
            (let ((_seconds110916_
                   (let () (declare (not safe)) (##vector-ref _g955583_ 0)))
                  (_ns110917_
                   (let () (declare (not safe)) (##vector-ref _g955583_ 1))))
              (let ((__tmp955585
                     (+ _seconds110916_
                        (let ()
                          (declare (not safe))
                          (std/srfi/19#tm:leap-second-delta
                           _seconds110916_)))))
                (declare (not safe))
                (##structure
                 std/srfi/19#time::t
                 std/srfi/19#time-monotonic
                 _ns110917_
                 __tmp955585)))))))
    (define std/srfi/19#tm:current-time-thread
      (lambda () (let () (declare (not safe)) (error '"Unimplemented"))))
    (define std/srfi/19#tm:current-time-process
      (lambda () (let () (declare (not safe)) (error '"Unimplemented"))))
    (define std/srfi/19#current-time
      (lambda _clock-type110906_
        (let ((_clock-type110911_
               (let ((_maybe-arg110908_ _clock-type110906_))
                 (if (let () (declare (not safe)) (null? _maybe-arg110908_))
                     std/srfi/19#time-utc
                     (if (let ((__tmp955586 (cdr _maybe-arg110908_)))
                           (declare (not safe))
                           (null? __tmp955586))
                         (car _maybe-arg110908_)
                         (let ()
                           (declare (not safe))
                           (error '"too many optional arguments"
                                  _maybe-arg110908_)))))))
          (if (let ()
                (declare (not safe))
                (eq? _clock-type110911_ std/srfi/19#time-tai))
              (let () (declare (not safe)) (std/srfi/19#tm:current-time-tai))
              (if (let ()
                    (declare (not safe))
                    (eq? _clock-type110911_ std/srfi/19#time-utc))
                  (let ()
                    (declare (not safe))
                    (std/srfi/19#tm:current-time-utc))
                  (if (let ()
                        (declare (not safe))
                        (eq? _clock-type110911_ std/srfi/19#time-monotonic))
                      (let ()
                        (declare (not safe))
                        (std/srfi/19#tm:current-time-monotonic))
                      (if (let ()
                            (declare (not safe))
                            (eq? _clock-type110911_ std/srfi/19#time-thread))
                          (let ()
                            (declare (not safe))
                            (std/srfi/19#tm:current-time-thread))
                          (if (let ()
                                (declare (not safe))
                                (eq? _clock-type110911_
                                     std/srfi/19#time-process))
                              (let ()
                                (declare (not safe))
                                (std/srfi/19#tm:current-time-process))
                              (let ()
                                (declare (not safe))
                                (std/srfi/19#tm:time-error
                                 'current-time
                                 'invalid-clock-type
                                 _clock-type110911_))))))))))
    (define std/srfi/19#time-resolution
      (lambda _clock-type110899_
        (let ((_clock-type110904_
               (let ((_maybe-arg110901_ _clock-type110899_))
                 (if (let () (declare (not safe)) (null? _maybe-arg110901_))
                     std/srfi/19#time-utc
                     (if (let ((__tmp955587 (cdr _maybe-arg110901_)))
                           (declare (not safe))
                           (null? __tmp955587))
                         (car _maybe-arg110901_)
                         (let ()
                           (declare (not safe))
                           (error '"too many optional arguments"
                                  _maybe-arg110901_)))))))
          (if (let ()
                (declare (not safe))
                (eq? _clock-type110904_ std/srfi/19#time-tai))
              '1
              (if (let ()
                    (declare (not safe))
                    (eq? _clock-type110904_ std/srfi/19#time-utc))
                  '1
                  (if (let ()
                        (declare (not safe))
                        (eq? _clock-type110904_ std/srfi/19#time-monotonic))
                      '1
                      (if (let ()
                            (declare (not safe))
                            (eq? _clock-type110904_ std/srfi/19#time-thread))
                          '1000
                          (if (let ()
                                (declare (not safe))
                                (eq? _clock-type110904_
                                     std/srfi/19#time-process))
                              '1000
                              (let ()
                                (declare (not safe))
                                (std/srfi/19#tm:time-error
                                 'time-resolution
                                 'invalid-clock-type
                                 _clock-type110904_))))))))))
    (define std/srfi/19#tm:time-compare-check
      (lambda (_time1110892_ _time2110893_ _caller110894_)
        (if (or (let ((__tmp955588
                       (and (let ()
                              (declare (not safe))
                              (##structure-instance-of?
                               _time1110892_
                               'std/srfi/19#time::t))
                            (let ()
                              (declare (not safe))
                              (##structure-instance-of?
                               _time2110893_
                               'std/srfi/19#time::t)))))
                  (declare (not safe))
                  (not __tmp955588))
                (let ((__tmp955589
                       (let ((__tmp955591
                              (##structure-ref
                               _time1110892_
                               '1
                               std/srfi/19#time::t
                               '#f))
                             (__tmp955590
                              (##structure-ref
                               _time2110893_
                               '1
                               std/srfi/19#time::t
                               '#f)))
                         (declare (not safe))
                         (eq? __tmp955591 __tmp955590))))
                  (declare (not safe))
                  (not __tmp955589)))
            (let ()
              (declare (not safe))
              (std/srfi/19#tm:time-error
               _caller110894_
               'incompatible-time-types
               '#f))
            '#t)))
    (define std/srfi/19#time=?
      (lambda (_time1110889_ _time2110890_)
        (let ()
          (declare (not safe))
          (std/srfi/19#tm:time-compare-check
           _time1110889_
           _time2110890_
           'time=?))
        (if (= (##structure-ref _time1110889_ '3 std/srfi/19#time::t '#f)
               (##structure-ref _time2110890_ '3 std/srfi/19#time::t '#f))
            (= (##structure-ref _time1110889_ '2 std/srfi/19#time::t '#f)
               (##structure-ref _time2110890_ '2 std/srfi/19#time::t '#f))
            '#f)))
    (define std/srfi/19#time>?
      (lambda (_time1110883_ _time2110884_)
        (let ()
          (declare (not safe))
          (std/srfi/19#tm:time-compare-check
           _time1110883_
           _time2110884_
           'time>?))
        (let ((_$e110886_
               (> (##structure-ref _time1110883_ '3 std/srfi/19#time::t '#f)
                  (##structure-ref _time2110884_ '3 std/srfi/19#time::t '#f))))
          (if _$e110886_
              _$e110886_
              (if (= (##structure-ref _time1110883_ '3 std/srfi/19#time::t '#f)
                     (##structure-ref
                      _time2110884_
                      '3
                      std/srfi/19#time::t
                      '#f))
                  (> (##structure-ref _time1110883_ '2 std/srfi/19#time::t '#f)
                     (##structure-ref
                      _time2110884_
                      '2
                      std/srfi/19#time::t
                      '#f))
                  '#f)))))
    (define std/srfi/19#time<?
      (lambda (_time1110877_ _time2110878_)
        (let ()
          (declare (not safe))
          (std/srfi/19#tm:time-compare-check
           _time1110877_
           _time2110878_
           'time<?))
        (let ((_$e110880_
               (< (##structure-ref _time1110877_ '3 std/srfi/19#time::t '#f)
                  (##structure-ref _time2110878_ '3 std/srfi/19#time::t '#f))))
          (if _$e110880_
              _$e110880_
              (if (= (##structure-ref _time1110877_ '3 std/srfi/19#time::t '#f)
                     (##structure-ref
                      _time2110878_
                      '3
                      std/srfi/19#time::t
                      '#f))
                  (< (##structure-ref _time1110877_ '2 std/srfi/19#time::t '#f)
                     (##structure-ref
                      _time2110878_
                      '2
                      std/srfi/19#time::t
                      '#f))
                  '#f)))))
    (define std/srfi/19#time>=?
      (lambda (_time1110871_ _time2110872_)
        (let ()
          (declare (not safe))
          (std/srfi/19#tm:time-compare-check
           _time1110871_
           _time2110872_
           'time>=?))
        (let ((_$e110874_
               (>= (##structure-ref _time1110871_ '3 std/srfi/19#time::t '#f)
                   (##structure-ref
                    _time2110872_
                    '3
                    std/srfi/19#time::t
                    '#f))))
          (if _$e110874_
              _$e110874_
              (if (= (##structure-ref _time1110871_ '3 std/srfi/19#time::t '#f)
                     (##structure-ref
                      _time2110872_
                      '3
                      std/srfi/19#time::t
                      '#f))
                  (>= (##structure-ref
                       _time1110871_
                       '2
                       std/srfi/19#time::t
                       '#f)
                      (##structure-ref
                       _time2110872_
                       '2
                       std/srfi/19#time::t
                       '#f))
                  '#f)))))
    (define std/srfi/19#time<=?
      (lambda (_time1110865_ _time2110866_)
        (let ()
          (declare (not safe))
          (std/srfi/19#tm:time-compare-check
           _time1110865_
           _time2110866_
           'time<=?))
        (let ((_$e110868_
               (<= (##structure-ref _time1110865_ '3 std/srfi/19#time::t '#f)
                   (##structure-ref
                    _time2110866_
                    '3
                    std/srfi/19#time::t
                    '#f))))
          (if _$e110868_
              _$e110868_
              (if (= (##structure-ref _time1110865_ '3 std/srfi/19#time::t '#f)
                     (##structure-ref
                      _time2110866_
                      '3
                      std/srfi/19#time::t
                      '#f))
                  (<= (##structure-ref
                       _time1110865_
                       '2
                       std/srfi/19#time::t
                       '#f)
                      (##structure-ref
                       _time2110866_
                       '2
                       std/srfi/19#time::t
                       '#f))
                  '#f)))))
    (define std/srfi/19#tm:time->nanoseconds
      (lambda (_time110859_)
        (letrec ((_sign1110861_
                  (lambda (_n110863_)
                    (if (let () (declare (not safe)) (negative? _n110863_))
                        '-1
                        '1))))
          (+ (* (##structure-ref _time110859_ '3 std/srfi/19#time::t '#f)
                std/srfi/19#tm:nano)
             (##structure-ref _time110859_ '2 std/srfi/19#time::t '#f)))))
    (define std/srfi/19#tm:nanoseconds->time
      (lambda (_time-type110856_ _nanoseconds110857_)
        (let ((__tmp955593 (remainder _nanoseconds110857_ std/srfi/19#tm:nano))
              (__tmp955592 (quotient _nanoseconds110857_ std/srfi/19#tm:nano)))
          (declare (not safe))
          (##structure
           std/srfi/19#time::t
           _time-type110856_
           __tmp955593
           __tmp955592))))
    (define std/srfi/19#tm:nanoseconds->values
      (lambda (_nanoseconds110854_)
        (values (abs (remainder _nanoseconds110854_ std/srfi/19#tm:nano))
                (quotient _nanoseconds110854_ std/srfi/19#tm:nano))))
    (define std/srfi/19#tm:time-difference
      (lambda (_time1110844_ _time2110845_ _time3110846_)
        (if (or (let ((__tmp955594
                       (and (let ()
                              (declare (not safe))
                              (##structure-instance-of?
                               _time1110844_
                               'std/srfi/19#time::t))
                            (let ()
                              (declare (not safe))
                              (##structure-instance-of?
                               _time2110845_
                               'std/srfi/19#time::t)))))
                  (declare (not safe))
                  (not __tmp955594))
                (let ((__tmp955595
                       (let ((__tmp955597
                              (##structure-ref
                               _time1110844_
                               '1
                               std/srfi/19#time::t
                               '#f))
                             (__tmp955596
                              (##structure-ref
                               _time2110845_
                               '1
                               std/srfi/19#time::t
                               '#f)))
                         (declare (not safe))
                         (eq? __tmp955597 __tmp955596))))
                  (declare (not safe))
                  (not __tmp955595)))
            (let ()
              (declare (not safe))
              (std/srfi/19#tm:time-error
               'time-difference
               'incompatible-time-types
               '#f))
            '#!void)
        (##structure-set!
         _time3110846_
         std/srfi/19#time-duration
         '1
         std/srfi/19#time::t
         '#f)
        (if (let ()
              (declare (not safe))
              (std/srfi/19#time=? _time1110844_ _time2110845_))
            (begin
              (##structure-set! _time3110846_ '0 '3 std/srfi/19#time::t '#f)
              (##structure-set! _time3110846_ '0 '2 std/srfi/19#time::t '#f))
            (let ((_g955598_
                   (let ((__tmp955600
                          (- (let ()
                               (declare (not safe))
                               (std/srfi/19#tm:time->nanoseconds
                                _time1110844_))
                             (let ()
                               (declare (not safe))
                               (std/srfi/19#tm:time->nanoseconds
                                _time2110845_)))))
                     (declare (not safe))
                     (std/srfi/19#tm:nanoseconds->values __tmp955600))))
              (begin
                (let ((_g955599_
                       (let ()
                         (declare (not safe))
                         (if (##values? _g955598_)
                             (##vector-length _g955598_)
                             1))))
                  (if (not (let () (declare (not safe)) (##fx= _g955599_ 2)))
                      (error "Context expects 2 values" _g955599_)))
                (let ((_nanos110851_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g955598_ 0)))
                      (_secs110852_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g955598_ 1))))
                  (begin
                    (##structure-set!
                     _time3110846_
                     _secs110852_
                     '3
                     std/srfi/19#time::t
                     '#f)
                    (##structure-set!
                     _time3110846_
                     _nanos110851_
                     '2
                     std/srfi/19#time::t
                     '#f))))))
        _time3110846_))
    (define std/srfi/19#time-difference
      (lambda (_time1110841_ _time2110842_)
        (let ((__tmp955601
               (let ()
                 (declare (not safe))
                 (##structure std/srfi/19#time::t '#f '#f '#f))))
          (declare (not safe))
          (std/srfi/19#tm:time-difference
           _time1110841_
           _time2110842_
           __tmp955601))))
    (define std/srfi/19#time-difference!
      (lambda (_time1110838_ _time2110839_)
        (let ()
          (declare (not safe))
          (std/srfi/19#tm:time-difference
           _time1110838_
           _time2110839_
           _time1110838_))))
    (define std/srfi/19#tm:add-duration
      (lambda (_time1110828_ _duration110829_ _time3110830_)
        (if (let ((__tmp955602
                   (and (let ()
                          (declare (not safe))
                          (##structure-instance-of?
                           _time1110828_
                           'std/srfi/19#time::t))
                        (let ()
                          (declare (not safe))
                          (##structure-instance-of?
                           _duration110829_
                           'std/srfi/19#time::t)))))
              (declare (not safe))
              (not __tmp955602))
            (let ()
              (declare (not safe))
              (std/srfi/19#tm:time-error
               'add-duration
               'incompatible-time-types
               '#f))
            '#!void)
        (if (let ((__tmp955603
                   (let ((__tmp955604
                          (##structure-ref
                           _duration110829_
                           '1
                           std/srfi/19#time::t
                           '#f)))
                     (declare (not safe))
                     (eq? __tmp955604 std/srfi/19#time-duration))))
              (declare (not safe))
              (not __tmp955603))
            (let ()
              (declare (not safe))
              (std/srfi/19#tm:time-error
               'add-duration
               'not-duration
               _duration110829_))
            (let ((_sec-plus110832_
                   (+ (##structure-ref
                       _time1110828_
                       '3
                       std/srfi/19#time::t
                       '#f)
                      (##structure-ref
                       _duration110829_
                       '3
                       std/srfi/19#time::t
                       '#f)))
                  (_nsec-plus110833_
                   (+ (##structure-ref
                       _time1110828_
                       '2
                       std/srfi/19#time::t
                       '#f)
                      (##structure-ref
                       _duration110829_
                       '2
                       std/srfi/19#time::t
                       '#f))))
              (let ((_r110835_
                     (remainder _nsec-plus110833_ std/srfi/19#tm:nano))
                    (_q110836_
                     (quotient _nsec-plus110833_ std/srfi/19#tm:nano)))
                (if (let () (declare (not safe)) (negative? _r110835_))
                    (begin
                      (##structure-set!
                       _time3110830_
                       (+ _sec-plus110832_ _q110836_ '-1)
                       '3
                       std/srfi/19#time::t
                       '#f)
                      (##structure-set!
                       _time3110830_
                       (+ std/srfi/19#tm:nano _r110835_)
                       '2
                       std/srfi/19#time::t
                       '#f))
                    (begin
                      (##structure-set!
                       _time3110830_
                       (+ _sec-plus110832_ _q110836_)
                       '3
                       std/srfi/19#time::t
                       '#f)
                      (##structure-set!
                       _time3110830_
                       _r110835_
                       '2
                       std/srfi/19#time::t
                       '#f)))
                _time3110830_)))))
    (define std/srfi/19#add-duration
      (lambda (_time1110825_ _duration110826_)
        (let ((__tmp955605
               (let ((__tmp955606
                      (##structure-ref
                       _time1110825_
                       '1
                       std/srfi/19#time::t
                       '#f)))
                 (declare (not safe))
                 (##structure std/srfi/19#time::t __tmp955606 '#f '#f))))
          (declare (not safe))
          (std/srfi/19#tm:add-duration
           _time1110825_
           _duration110826_
           __tmp955605))))
    (define std/srfi/19#add-duration!
      (lambda (_time1110822_ _duration110823_)
        (let ()
          (declare (not safe))
          (std/srfi/19#tm:add-duration
           _time1110822_
           _duration110823_
           _time1110822_))))
    (define std/srfi/19#tm:subtract-duration
      (lambda (_time1110812_ _duration110813_ _time3110814_)
        (if (let ((__tmp955607
                   (and (let ()
                          (declare (not safe))
                          (##structure-instance-of?
                           _time1110812_
                           'std/srfi/19#time::t))
                        (let ()
                          (declare (not safe))
                          (##structure-instance-of?
                           _duration110813_
                           'std/srfi/19#time::t)))))
              (declare (not safe))
              (not __tmp955607))
            (let ()
              (declare (not safe))
              (std/srfi/19#tm:time-error
               'add-duration
               'incompatible-time-types
               '#f))
            '#!void)
        (if (let ((__tmp955608
                   (let ((__tmp955609
                          (##structure-ref
                           _duration110813_
                           '1
                           std/srfi/19#time::t
                           '#f)))
                     (declare (not safe))
                     (eq? __tmp955609 std/srfi/19#time-duration))))
              (declare (not safe))
              (not __tmp955608))
            (let ()
              (declare (not safe))
              (std/srfi/19#tm:time-error
               'tm:subtract-duration
               'not-duration
               _duration110813_))
            (let ((_sec-minus110816_
                   (- (##structure-ref
                       _time1110812_
                       '3
                       std/srfi/19#time::t
                       '#f)
                      (##structure-ref
                       _duration110813_
                       '3
                       std/srfi/19#time::t
                       '#f)))
                  (_nsec-minus110817_
                   (- (##structure-ref
                       _time1110812_
                       '2
                       std/srfi/19#time::t
                       '#f)
                      (##structure-ref
                       _duration110813_
                       '2
                       std/srfi/19#time::t
                       '#f))))
              (let ((_r110819_
                     (remainder _nsec-minus110817_ std/srfi/19#tm:nano))
                    (_q110820_
                     (quotient _nsec-minus110817_ std/srfi/19#tm:nano)))
                (if (let () (declare (not safe)) (negative? _r110819_))
                    (begin
                      (##structure-set!
                       _time3110814_
                       (- _sec-minus110816_ _q110820_ '1)
                       '3
                       std/srfi/19#time::t
                       '#f)
                      (##structure-set!
                       _time3110814_
                       (+ std/srfi/19#tm:nano _r110819_)
                       '2
                       std/srfi/19#time::t
                       '#f))
                    (begin
                      (##structure-set!
                       _time3110814_
                       (- _sec-minus110816_ _q110820_)
                       '3
                       std/srfi/19#time::t
                       '#f)
                      (##structure-set!
                       _time3110814_
                       _r110819_
                       '2
                       std/srfi/19#time::t
                       '#f)))
                _time3110814_)))))
    (define std/srfi/19#subtract-duration
      (lambda (_time1110809_ _duration110810_)
        (let ((__tmp955610
               (let ((__tmp955611
                      (##structure-ref
                       _time1110809_
                       '1
                       std/srfi/19#time::t
                       '#f)))
                 (declare (not safe))
                 (##structure std/srfi/19#time::t __tmp955611 '#f '#f))))
          (declare (not safe))
          (std/srfi/19#tm:subtract-duration
           _time1110809_
           _duration110810_
           __tmp955610))))
    (define std/srfi/19#subtract-duration!
      (lambda (_time1110806_ _duration110807_)
        (let ()
          (declare (not safe))
          (std/srfi/19#tm:subtract-duration
           _time1110806_
           _duration110807_
           _time1110806_))))
    (define std/srfi/19#tm:time-tai->time-utc!
      (lambda (_time-in110802_ _time-out110803_ _caller110804_)
        (if (let ((__tmp955612
                   (let ((__tmp955613
                          (##structure-ref
                           _time-in110802_
                           '1
                           std/srfi/19#time::t
                           '#f)))
                     (declare (not safe))
                     (eq? __tmp955613 std/srfi/19#time-tai))))
              (declare (not safe))
              (not __tmp955612))
            (let ()
              (declare (not safe))
              (std/srfi/19#tm:time-error
               _caller110804_
               'incompatible-time-types
               _time-in110802_))
            '#!void)
        (##structure-set!
         _time-out110803_
         std/srfi/19#time-utc
         '1
         std/srfi/19#time::t
         '#f)
        (##structure-set!
         _time-out110803_
         (##structure-ref _time-in110802_ '2 std/srfi/19#time::t '#f)
         '2
         std/srfi/19#time::t
         '#f)
        (##structure-set!
         _time-out110803_
         (- (##structure-ref _time-in110802_ '3 std/srfi/19#time::t '#f)
            (let ((__tmp955614
                   (##structure-ref
                    _time-in110802_
                    '3
                    std/srfi/19#time::t
                    '#f)))
              (declare (not safe))
              (std/srfi/19#tm:leap-second-neg-delta __tmp955614)))
         '3
         std/srfi/19#time::t
         '#f)
        _time-out110803_))
    (define std/srfi/19#time-tai->time-utc
      (lambda (_time-in110800_)
        (let ((__tmp955615
               (let ()
                 (declare (not safe))
                 (##structure std/srfi/19#time::t '#f '#f '#f))))
          (declare (not safe))
          (std/srfi/19#tm:time-tai->time-utc!
           _time-in110800_
           __tmp955615
           'time-tai->time-utc))))
    (define std/srfi/19#time-tai->time-utc!
      (lambda (_time-in110798_)
        (let ()
          (declare (not safe))
          (std/srfi/19#tm:time-tai->time-utc!
           _time-in110798_
           _time-in110798_
           'time-tai->time-utc!))))
    (define std/srfi/19#tm:time-utc->time-tai!
      (lambda (_time-in110794_ _time-out110795_ _caller110796_)
        (if (let ((__tmp955616
                   (let ((__tmp955617
                          (##structure-ref
                           _time-in110794_
                           '1
                           std/srfi/19#time::t
                           '#f)))
                     (declare (not safe))
                     (eq? __tmp955617 std/srfi/19#time-utc))))
              (declare (not safe))
              (not __tmp955616))
            (let ()
              (declare (not safe))
              (std/srfi/19#tm:time-error
               _caller110796_
               'incompatible-time-types
               _time-in110794_))
            '#!void)
        (##structure-set!
         _time-out110795_
         std/srfi/19#time-tai
         '1
         std/srfi/19#time::t
         '#f)
        (##structure-set!
         _time-out110795_
         (##structure-ref _time-in110794_ '2 std/srfi/19#time::t '#f)
         '2
         std/srfi/19#time::t
         '#f)
        (##structure-set!
         _time-out110795_
         (+ (##structure-ref _time-in110794_ '3 std/srfi/19#time::t '#f)
            (let ((__tmp955618
                   (##structure-ref
                    _time-in110794_
                    '3
                    std/srfi/19#time::t
                    '#f)))
              (declare (not safe))
              (std/srfi/19#tm:leap-second-delta __tmp955618)))
         '3
         std/srfi/19#time::t
         '#f)
        _time-out110795_))
    (define std/srfi/19#time-utc->time-tai
      (lambda (_time-in110792_)
        (let ((__tmp955619
               (let ()
                 (declare (not safe))
                 (##structure std/srfi/19#time::t '#f '#f '#f))))
          (declare (not safe))
          (std/srfi/19#tm:time-utc->time-tai!
           _time-in110792_
           __tmp955619
           'time-utc->time-tai))))
    (define std/srfi/19#time-utc->time-tai!
      (lambda (_time-in110790_)
        (let ()
          (declare (not safe))
          (std/srfi/19#tm:time-utc->time-tai!
           _time-in110790_
           _time-in110790_
           'time-utc->time-tai!))))
    (define std/srfi/19#time-monotonic->time-utc
      (lambda (_time-in110786_)
        (if (let ((__tmp955620
                   (let ((__tmp955621
                          (##structure-ref
                           _time-in110786_
                           '1
                           std/srfi/19#time::t
                           '#f)))
                     (declare (not safe))
                     (eq? __tmp955621 std/srfi/19#time-monotonic))))
              (declare (not safe))
              (not __tmp955620))
            (let ()
              (declare (not safe))
              (std/srfi/19#tm:time-error
               'time-monotonic->time-utc
               'incompatible-time-types
               _time-in110786_))
            '#!void)
        (let ((_ntime110788_
               (let ()
                 (declare (not safe))
                 (std/srfi/19#copy-time _time-in110786_))))
          (##structure-set!
           _ntime110788_
           std/srfi/19#time-tai
           '1
           std/srfi/19#time::t
           '#f)
          (let ()
            (declare (not safe))
            (std/srfi/19#tm:time-tai->time-utc!
             _ntime110788_
             _ntime110788_
             'time-monotonic->time-utc)))))
    (define std/srfi/19#time-monotonic->time-utc!
      (lambda (_time-in110784_)
        (if (let ((__tmp955622
                   (let ((__tmp955623
                          (##structure-ref
                           _time-in110784_
                           '1
                           std/srfi/19#time::t
                           '#f)))
                     (declare (not safe))
                     (eq? __tmp955623 std/srfi/19#time-monotonic))))
              (declare (not safe))
              (not __tmp955622))
            (let ()
              (declare (not safe))
              (std/srfi/19#tm:time-error
               'time-monotonic->time-utc!
               'incompatible-time-types
               _time-in110784_))
            '#!void)
        (##structure-set!
         _time-in110784_
         std/srfi/19#time-tai
         '1
         std/srfi/19#time::t
         '#f)
        (let ()
          (declare (not safe))
          (std/srfi/19#tm:time-tai->time-utc!
           _time-in110784_
           _time-in110784_
           'time-monotonic->time-utc))))
    (define std/srfi/19#time-monotonic->time-tai
      (lambda (_time-in110780_)
        (if (let ((__tmp955624
                   (let ((__tmp955625
                          (##structure-ref
                           _time-in110780_
                           '1
                           std/srfi/19#time::t
                           '#f)))
                     (declare (not safe))
                     (eq? __tmp955625 std/srfi/19#time-monotonic))))
              (declare (not safe))
              (not __tmp955624))
            (let ()
              (declare (not safe))
              (std/srfi/19#tm:time-error
               'time-monotonic->time-tai
               'incompatible-time-types
               _time-in110780_))
            '#!void)
        (let ((_ntime110782_
               (let ()
                 (declare (not safe))
                 (std/srfi/19#copy-time _time-in110780_))))
          (##structure-set!
           _ntime110782_
           std/srfi/19#time-tai
           '1
           std/srfi/19#time::t
           '#f)
          _ntime110782_)))
    (define std/srfi/19#time-monotonic->time-tai!
      (lambda (_time-in110778_)
        (if (let ((__tmp955626
                   (let ((__tmp955627
                          (##structure-ref
                           _time-in110778_
                           '1
                           std/srfi/19#time::t
                           '#f)))
                     (declare (not safe))
                     (eq? __tmp955627 std/srfi/19#time-monotonic))))
              (declare (not safe))
              (not __tmp955626))
            (let ()
              (declare (not safe))
              (std/srfi/19#tm:time-error
               'time-monotonic->time-tai!
               'incompatible-time-types
               _time-in110778_))
            '#!void)
        (##structure-set!
         _time-in110778_
         std/srfi/19#time-tai
         '1
         std/srfi/19#time::t
         '#f)
        _time-in110778_))
    (define std/srfi/19#time-utc->time-monotonic
      (lambda (_time-in110774_)
        (if (let ((__tmp955628
                   (let ((__tmp955629
                          (##structure-ref
                           _time-in110774_
                           '1
                           std/srfi/19#time::t
                           '#f)))
                     (declare (not safe))
                     (eq? __tmp955629 std/srfi/19#time-utc))))
              (declare (not safe))
              (not __tmp955628))
            (let ()
              (declare (not safe))
              (std/srfi/19#tm:time-error
               'time-utc->time-monotonic
               'incompatible-time-types
               _time-in110774_))
            '#!void)
        (let ((_ntime110776_
               (let ((__tmp955630
                      (let ()
                        (declare (not safe))
                        (##structure std/srfi/19#time::t '#f '#f '#f))))
                 (declare (not safe))
                 (std/srfi/19#tm:time-utc->time-tai!
                  _time-in110774_
                  __tmp955630
                  'time-utc->time-monotonic))))
          (##structure-set!
           _ntime110776_
           std/srfi/19#time-monotonic
           '1
           std/srfi/19#time::t
           '#f)
          _ntime110776_)))
    (define std/srfi/19#time-utc->time-monotonic!
      (lambda (_time-in110770_)
        (if (let ((__tmp955631
                   (let ((__tmp955632
                          (##structure-ref
                           _time-in110770_
                           '1
                           std/srfi/19#time::t
                           '#f)))
                     (declare (not safe))
                     (eq? __tmp955632 std/srfi/19#time-utc))))
              (declare (not safe))
              (not __tmp955631))
            (let ()
              (declare (not safe))
              (std/srfi/19#tm:time-error
               'time-utc->time-montonic!
               'incompatible-time-types
               _time-in110770_))
            '#!void)
        (let ((_ntime110772_
               (let ()
                 (declare (not safe))
                 (std/srfi/19#tm:time-utc->time-tai!
                  _time-in110770_
                  _time-in110770_
                  'time-utc->time-monotonic!))))
          (##structure-set!
           _ntime110772_
           std/srfi/19#time-monotonic
           '1
           std/srfi/19#time::t
           '#f)
          _ntime110772_)))
    (define std/srfi/19#time-tai->time-monotonic
      (lambda (_time-in110766_)
        (if (let ((__tmp955633
                   (let ((__tmp955634
                          (##structure-ref
                           _time-in110766_
                           '1
                           std/srfi/19#time::t
                           '#f)))
                     (declare (not safe))
                     (eq? __tmp955634 std/srfi/19#time-tai))))
              (declare (not safe))
              (not __tmp955633))
            (let ()
              (declare (not safe))
              (std/srfi/19#tm:time-error
               'time-tai->time-monotonic
               'incompatible-time-types
               _time-in110766_))
            '#!void)
        (let ((_ntime110768_
               (let ()
                 (declare (not safe))
                 (std/srfi/19#copy-time _time-in110766_))))
          (##structure-set!
           _ntime110768_
           std/srfi/19#time-monotonic
           '1
           std/srfi/19#time::t
           '#f)
          _ntime110768_)))
    (define std/srfi/19#time-tai->time-monotonic!
      (lambda (_time-in110764_)
        (if (let ((__tmp955635
                   (let ((__tmp955636
                          (##structure-ref
                           _time-in110764_
                           '1
                           std/srfi/19#time::t
                           '#f)))
                     (declare (not safe))
                     (eq? __tmp955636 std/srfi/19#time-tai))))
              (declare (not safe))
              (not __tmp955635))
            (let ()
              (declare (not safe))
              (std/srfi/19#tm:time-error
               'time-tai->time-monotonic!
               'incompatible-time-types
               _time-in110764_))
            '#!void)
        (##structure-set!
         _time-in110764_
         std/srfi/19#time-monotonic
         '1
         std/srfi/19#time::t
         '#f)
        _time-in110764_))
    (define std/srfi/19#date::t
      (let ()
        (declare (not safe))
        (make-struct-type
         'std/srfi/19#date::t
         '#f
         '8
         'date
         '((transparent: . #t))
         '#f
         '(nanosecond second minute hour day month year zone-offset))))
    (define std/srfi/19#date?
      (let ()
        (declare (not safe))
        (make-struct-predicate std/srfi/19#date::t)))
    (define std/srfi/19#make-date
      (lambda _$args110761_
        (apply make-struct-instance std/srfi/19#date::t _$args110761_)))
    (define std/srfi/19#date-nanosecond
      (let ()
        (declare (not safe))
        (make-struct-field-accessor std/srfi/19#date::t '0)))
    (define std/srfi/19#date-second
      (let ()
        (declare (not safe))
        (make-struct-field-accessor std/srfi/19#date::t '1)))
    (define std/srfi/19#date-minute
      (let ()
        (declare (not safe))
        (make-struct-field-accessor std/srfi/19#date::t '2)))
    (define std/srfi/19#date-hour
      (let ()
        (declare (not safe))
        (make-struct-field-accessor std/srfi/19#date::t '3)))
    (define std/srfi/19#date-day
      (let ()
        (declare (not safe))
        (make-struct-field-accessor std/srfi/19#date::t '4)))
    (define std/srfi/19#date-month
      (let ()
        (declare (not safe))
        (make-struct-field-accessor std/srfi/19#date::t '5)))
    (define std/srfi/19#date-year
      (let ()
        (declare (not safe))
        (make-struct-field-accessor std/srfi/19#date::t '6)))
    (define std/srfi/19#date-zone-offset
      (let ()
        (declare (not safe))
        (make-struct-field-accessor std/srfi/19#date::t '7)))
    (define std/srfi/19#date-nanosecond-set!
      (let ()
        (declare (not safe))
        (make-struct-field-mutator std/srfi/19#date::t '0)))
    (define std/srfi/19#date-second-set!
      (let ()
        (declare (not safe))
        (make-struct-field-mutator std/srfi/19#date::t '1)))
    (define std/srfi/19#date-minute-set!
      (let ()
        (declare (not safe))
        (make-struct-field-mutator std/srfi/19#date::t '2)))
    (define std/srfi/19#date-hour-set!
      (let ()
        (declare (not safe))
        (make-struct-field-mutator std/srfi/19#date::t '3)))
    (define std/srfi/19#date-day-set!
      (let ()
        (declare (not safe))
        (make-struct-field-mutator std/srfi/19#date::t '4)))
    (define std/srfi/19#date-month-set!
      (let ()
        (declare (not safe))
        (make-struct-field-mutator std/srfi/19#date::t '5)))
    (define std/srfi/19#date-year-set!
      (let ()
        (declare (not safe))
        (make-struct-field-mutator std/srfi/19#date::t '6)))
    (define std/srfi/19#date-zone-offset-set!
      (let ()
        (declare (not safe))
        (make-struct-field-mutator std/srfi/19#date::t '7)))
    (define std/srfi/19#&date-nanosecond
      (let ()
        (declare (not safe))
        (make-struct-field-unchecked-accessor std/srfi/19#date::t '0)))
    (define std/srfi/19#&date-second
      (let ()
        (declare (not safe))
        (make-struct-field-unchecked-accessor std/srfi/19#date::t '1)))
    (define std/srfi/19#&date-minute
      (let ()
        (declare (not safe))
        (make-struct-field-unchecked-accessor std/srfi/19#date::t '2)))
    (define std/srfi/19#&date-hour
      (let ()
        (declare (not safe))
        (make-struct-field-unchecked-accessor std/srfi/19#date::t '3)))
    (define std/srfi/19#&date-day
      (let ()
        (declare (not safe))
        (make-struct-field-unchecked-accessor std/srfi/19#date::t '4)))
    (define std/srfi/19#&date-month
      (let ()
        (declare (not safe))
        (make-struct-field-unchecked-accessor std/srfi/19#date::t '5)))
    (define std/srfi/19#&date-year
      (let ()
        (declare (not safe))
        (make-struct-field-unchecked-accessor std/srfi/19#date::t '6)))
    (define std/srfi/19#&date-zone-offset
      (let ()
        (declare (not safe))
        (make-struct-field-unchecked-accessor std/srfi/19#date::t '7)))
    (define std/srfi/19#&date-nanosecond-set!
      (let ()
        (declare (not safe))
        (make-struct-field-unchecked-mutator std/srfi/19#date::t '0)))
    (define std/srfi/19#&date-second-set!
      (let ()
        (declare (not safe))
        (make-struct-field-unchecked-mutator std/srfi/19#date::t '1)))
    (define std/srfi/19#&date-minute-set!
      (let ()
        (declare (not safe))
        (make-struct-field-unchecked-mutator std/srfi/19#date::t '2)))
    (define std/srfi/19#&date-hour-set!
      (let ()
        (declare (not safe))
        (make-struct-field-unchecked-mutator std/srfi/19#date::t '3)))
    (define std/srfi/19#&date-day-set!
      (let ()
        (declare (not safe))
        (make-struct-field-unchecked-mutator std/srfi/19#date::t '4)))
    (define std/srfi/19#&date-month-set!
      (let ()
        (declare (not safe))
        (make-struct-field-unchecked-mutator std/srfi/19#date::t '5)))
    (define std/srfi/19#&date-year-set!
      (let ()
        (declare (not safe))
        (make-struct-field-unchecked-mutator std/srfi/19#date::t '6)))
    (define std/srfi/19#&date-zone-offset-set!
      (let ()
        (declare (not safe))
        (make-struct-field-unchecked-mutator std/srfi/19#date::t '7)))
    (define std/srfi/19#tm:encode-julian-day-number
      (lambda (_day110750_ _month110751_ _year110752_)
        (let* ((_a110754_ (quotient (- '14 _month110751_) '12))
               (_y110756_
                (- (- (+ _year110752_ '4800) _a110754_)
                   (if (let () (declare (not safe)) (negative? _year110752_))
                       '-1
                       '0)))
               (_m110758_ (- (+ _month110751_ (* '12 _a110754_)) '3)))
          (+ _day110750_
             (quotient (+ (* '153 _m110758_) '2) '5)
             (* '365 _y110756_)
             (quotient _y110756_ '4)
             (- (quotient _y110756_ '100))
             (quotient _y110756_ '400)
             '-32045))))
    (define std/srfi/19#tm:char-pos
      (lambda (_char110745_ _str110746_ _index110747_ _len110748_)
        (if (>= _index110747_ _len110748_)
            '#f
            (if (char=? (string-ref _str110746_ _index110747_) _char110745_)
                _index110747_
                (let ((__tmp955637 (+ _index110747_ '1)))
                  (declare (not safe))
                  (std/srfi/19#tm:char-pos
                   _char110745_
                   _str110746_
                   __tmp955637
                   _len110748_))))))
    (define std/srfi/19#tm:fractional-part
      (lambda (_r110739_)
        (if (let () (declare (not safe)) (integer? _r110739_))
            '"0"
            (let* ((_str110741_ (number->string (exact->inexact _r110739_)))
                   (_ppos110743_
                    (let ((__tmp955638 (string-length _str110741_)))
                      (declare (not safe))
                      (std/srfi/19#tm:char-pos
                       '#\.
                       _str110741_
                       '0
                       __tmp955638))))
              (substring
               _str110741_
               (+ _ppos110743_ '1)
               (string-length _str110741_))))))
    (define std/srfi/19#tm:decode-julian-day-number
      (lambda (_jdn110720_)
        (let* ((_days110722_ (truncate _jdn110720_))
               (_a110724_ (+ _days110722_ '32044))
               (_b110726_ (quotient (+ (* '4 _a110724_) '3) '146097))
               (_c110728_ (- _a110724_ (quotient (* '146097 _b110726_) '4)))
               (_d110730_ (quotient (+ (* '4 _c110728_) '3) '1461))
               (_e110732_ (- _c110728_ (quotient (* '1461 _d110730_) '4)))
               (_m110734_ (quotient (+ (* '5 _e110732_) '2) '153))
               (_y110736_
                (+ (* '100 _b110726_)
                   _d110730_
                   '-4800
                   (quotient _m110734_ '10))))
          (values (* (- _jdn110720_ _days110722_) std/srfi/19#tm:sid)
                  (+ _e110732_ (- (quotient (+ (* '153 _m110734_) '2) '5)) '1)
                  (+ _m110734_ '3 (* '-12 (quotient _m110734_ '10)))
                  (if (>= '0 _y110736_) (- _y110736_ '1) _y110736_)))))
    (define std/srfi/19#tm:local-tz-offset (lambda () '0))
    (define std/srfi/19#tm:time->julian-day-number
      (lambda (_seconds110716_ _tz-offset110717_)
        (+ (/ (+ _seconds110716_ _tz-offset110717_ std/srfi/19#tm:sihd)
              std/srfi/19#tm:sid)
           std/srfi/19#tm:tai-epoch-in-jd)))
    (define std/srfi/19#tm:find
      (lambda (_proc110713_ _l110714_)
        (if (let () (declare (not safe)) (null? _l110714_))
            '#f
            (if (_proc110713_ (car _l110714_))
                '#t
                (let ((__tmp955639 (cdr _l110714_)))
                  (declare (not safe))
                  (std/srfi/19#tm:find _proc110713_ __tmp955639))))))
    (define std/srfi/19#tm:tai-before-leap-second?
      (lambda (_second110709_)
        (let ((__tmp955640
               (lambda (_x110711_)
                 (= _second110709_
                    (- (+ (car _x110711_) (cdr _x110711_)) '1)))))
          (declare (not safe))
          (std/srfi/19#tm:find __tmp955640 std/srfi/19#tm:leap-second-table))))
    (define std/srfi/19#tm:time->date
      (lambda (_time110685_ _tz-offset110686_ _ttype110687_)
        (if (let ((__tmp955641
                   (let ((__tmp955642
                          (##structure-ref
                           _time110685_
                           '1
                           std/srfi/19#time::t
                           '#f)))
                     (declare (not safe))
                     (eq? __tmp955642 _ttype110687_))))
              (declare (not safe))
              (not __tmp955641))
            (let ()
              (declare (not safe))
              (std/srfi/19#tm:time-error
               'time->date
               'incompatible-time-types
               _time110685_))
            '#!void)
        (let ((_offset110692_
               (let ((_maybe-arg110689_ _tz-offset110686_))
                 (if (let () (declare (not safe)) (null? _maybe-arg110689_))
                     (let ()
                       (declare (not safe))
                       (std/srfi/19#tm:local-tz-offset))
                     (if (let ((__tmp955643 (cdr _maybe-arg110689_)))
                           (declare (not safe))
                           (null? __tmp955643))
                         (car _maybe-arg110689_)
                         (let ()
                           (declare (not safe))
                           (error '"too many optional arguments"
                                  _maybe-arg110689_)))))))
          (let ((_g955644_
                 (let ((__tmp955646
                        (let ((__tmp955647
                               (##structure-ref
                                _time110685_
                                '3
                                std/srfi/19#time::t
                                '#f)))
                          (declare (not safe))
                          (std/srfi/19#tm:time->julian-day-number
                           __tmp955647
                           _offset110692_))))
                   (declare (not safe))
                   (std/srfi/19#tm:decode-julian-day-number __tmp955646))))
            (begin
              (let ((_g955645_
                     (let ()
                       (declare (not safe))
                       (if (##values? _g955644_)
                           (##vector-length _g955644_)
                           1))))
                (if (not (let () (declare (not safe)) (##fx= _g955645_ 4)))
                    (error "Context expects 4 values" _g955645_)))
              (let ((_secs110695_
                     (let () (declare (not safe)) (##vector-ref _g955644_ 0)))
                    (_date110696_
                     (let () (declare (not safe)) (##vector-ref _g955644_ 1)))
                    (_month110697_
                     (let () (declare (not safe)) (##vector-ref _g955644_ 2)))
                    (_year110698_
                     (let () (declare (not safe)) (##vector-ref _g955644_ 3))))
                (let* ((_hours110700_ (quotient _secs110695_ (* '60 '60)))
                       (_rem110702_ (remainder _secs110695_ (* '60 '60)))
                       (_minutes110704_ (quotient _rem110702_ '60))
                       (_seconds110706_ (remainder _rem110702_ '60)))
                  (let ((__tmp955648
                         (##structure-ref
                          _time110685_
                          '2
                          std/srfi/19#time::t
                          '#f)))
                    (declare (not safe))
                    (##structure
                     std/srfi/19#date::t
                     __tmp955648
                     _seconds110706_
                     _minutes110704_
                     _hours110700_
                     _date110696_
                     _month110697_
                     _year110698_
                     _offset110692_)))))))))
    (define std/srfi/19#time-tai->date
      (lambda (_time110680_ . _tz-offset110681_)
        (if (let ((__tmp955653
                   (##structure-ref _time110680_ '3 std/srfi/19#time::t '#f)))
              (declare (not safe))
              (std/srfi/19#tm:tai-before-leap-second? __tmp955653))
            (let ((_d110683_
                   (let ((__tmp955650
                          (let ((__tmp955652
                                 (let ()
                                   (declare (not safe))
                                   (std/srfi/19#time-tai->time-utc
                                    _time110680_)))
                                (__tmp955651
                                 (let ()
                                   (declare (not safe))
                                   (##structure
                                    std/srfi/19#time::t
                                    std/srfi/19#time-duration
                                    '0
                                    '1))))
                            (declare (not safe))
                            (std/srfi/19#subtract-duration!
                             __tmp955652
                             __tmp955651))))
                     (declare (not safe))
                     (std/srfi/19#tm:time->date
                      __tmp955650
                      _tz-offset110681_
                      std/srfi/19#time-utc))))
              (##structure-set! _d110683_ '60 '2 std/srfi/19#date::t '#f)
              _d110683_)
            (let ((__tmp955649
                   (let ()
                     (declare (not safe))
                     (std/srfi/19#time-tai->time-utc _time110680_))))
              (declare (not safe))
              (std/srfi/19#tm:time->date
               __tmp955649
               _tz-offset110681_
               std/srfi/19#time-utc)))))
    (define std/srfi/19#time-utc->date
      (lambda (_time110677_ . _tz-offset110678_)
        (let ()
          (declare (not safe))
          (std/srfi/19#tm:time->date
           _time110677_
           _tz-offset110678_
           std/srfi/19#time-utc))))
    (define std/srfi/19#time-monotonic->date
      (lambda (_time110674_ . _tz-offset110675_)
        (let ()
          (declare (not safe))
          (std/srfi/19#tm:time->date
           _time110674_
           _tz-offset110675_
           std/srfi/19#time-monotonic))))
    (define std/srfi/19#date->time-utc
      (lambda (_date110661_)
        (let ((_nanosecond110663_
               (##structure-ref _date110661_ '1 std/srfi/19#date::t '#f))
              (_second110664_
               (##structure-ref _date110661_ '2 std/srfi/19#date::t '#f))
              (_minute110665_
               (##structure-ref _date110661_ '3 std/srfi/19#date::t '#f))
              (_hour110666_
               (##structure-ref _date110661_ '4 std/srfi/19#date::t '#f))
              (_day110667_
               (##structure-ref _date110661_ '5 std/srfi/19#date::t '#f))
              (_month110668_
               (##structure-ref _date110661_ '6 std/srfi/19#date::t '#f))
              (_year110669_
               (##structure-ref _date110661_ '7 std/srfi/19#date::t '#f))
              (_offset110670_
               (##structure-ref _date110661_ '8 std/srfi/19#date::t '#f)))
          (let* ((_jdays110672_
                  (- (let ()
                       (declare (not safe))
                       (std/srfi/19#tm:encode-julian-day-number
                        _day110667_
                        _month110668_
                        _year110669_))
                     std/srfi/19#tm:tai-epoch-in-jd))
                 (__tmp955654
                  (+ (* (- _jdays110672_ '1/2) '24 '60 '60)
                     (* _hour110666_ '60 '60)
                     (* _minute110665_ '60)
                     _second110664_
                     (- _offset110670_))))
            (declare (not safe))
            (##structure
             std/srfi/19#time::t
             std/srfi/19#time-utc
             _nanosecond110663_
             __tmp955654)))))
    (define std/srfi/19#date->time-tai
      (lambda (_d110659_)
        (if (= (##structure-ref _d110659_ '2 std/srfi/19#date::t '#f) '60)
            (let ((__tmp955657
                   (let ((__tmp955658
                          (let ()
                            (declare (not safe))
                            (std/srfi/19#date->time-utc _d110659_))))
                     (declare (not safe))
                     (std/srfi/19#time-utc->time-tai! __tmp955658)))
                  (__tmp955656
                   (let ()
                     (declare (not safe))
                     (##structure
                      std/srfi/19#time::t
                      std/srfi/19#time-duration
                      '0
                      '1))))
              (declare (not safe))
              (std/srfi/19#subtract-duration! __tmp955657 __tmp955656))
            (let ((__tmp955655
                   (let ()
                     (declare (not safe))
                     (std/srfi/19#date->time-utc _d110659_))))
              (declare (not safe))
              (std/srfi/19#time-utc->time-tai! __tmp955655)))))
    (define std/srfi/19#date->time-monotonic
      (lambda (_date110657_)
        (let ((__tmp955659
               (let ()
                 (declare (not safe))
                 (std/srfi/19#date->time-utc _date110657_))))
          (declare (not safe))
          (std/srfi/19#time-utc->time-monotonic! __tmp955659))))
    (define std/srfi/19#tm:leap-year?
      (lambda (_year110652_)
        (let ((_$e110654_ (= (modulo _year110652_ '400) '0)))
          (if _$e110654_
              _$e110654_
              (if (= (modulo _year110652_ '4) '0)
                  (let ((__tmp955660 (= (modulo _year110652_ '100) '0)))
                    (declare (not safe))
                    (not __tmp955660))
                  '#f)))))
    (define std/srfi/19#leap-year?
      (lambda (_date110650_)
        (let ((__tmp955661
               (##structure-ref _date110650_ '7 std/srfi/19#date::t '#f)))
          (declare (not safe))
          (std/srfi/19#tm:leap-year? __tmp955661))))
    (define std/srfi/19#tm:month-assoc
      '((0 . 0)
        (1 . 31)
        (2 . 59)
        (3 . 90)
        (4 . 120)
        (5 . 151)
        (6 . 181)
        (7 . 212)
        (8 . 243)
        (9 . 273)
        (10 . 304)
        (11 . 334)))
    (define std/srfi/19#tm:year-day
      (lambda (_day110644_ _month110645_ _year110646_)
        (let ((_days-pr110648_
               (assoc (- _month110645_ '1) std/srfi/19#tm:month-assoc)))
          (if (let () (declare (not safe)) (not _days-pr110648_))
              (let ()
                (declare (not safe))
                (std/srfi/19#tm:time-error
                 'date-year-day
                 'invalid-month-specification
                 _month110645_))
              '#!void)
          (if (and (let ()
                     (declare (not safe))
                     (std/srfi/19#tm:leap-year? _year110646_))
                   (> _month110645_ '2))
              (+ _day110644_ (cdr _days-pr110648_) '1)
              (+ _day110644_ (cdr _days-pr110648_))))))
    (define std/srfi/19#date-year-day
      (lambda (_date110642_)
        (let ((__tmp955664
               (##structure-ref _date110642_ '5 std/srfi/19#date::t '#f))
              (__tmp955663
               (##structure-ref _date110642_ '6 std/srfi/19#date::t '#f))
              (__tmp955662
               (##structure-ref _date110642_ '7 std/srfi/19#date::t '#f)))
          (declare (not safe))
          (std/srfi/19#tm:year-day __tmp955664 __tmp955663 __tmp955662))))
    (define std/srfi/19#tm:week-day
      (lambda (_day110631_ _month110632_ _year110633_)
        (let* ((_a110635_ (quotient (- '14 _month110632_) '12))
               (_y110637_ (- _year110633_ _a110635_))
               (_m110639_ (+ _month110632_ (* '12 _a110635_) '-2)))
          (modulo (+ _day110631_
                     _y110637_
                     (quotient _y110637_ '4)
                     (- (quotient _y110637_ '100))
                     (quotient _y110637_ '400)
                     (quotient (* '31 _m110639_) '12))
                  '7))))
    (define std/srfi/19#date-week-day
      (lambda (_date110629_)
        (let ((__tmp955667
               (##structure-ref _date110629_ '5 std/srfi/19#date::t '#f))
              (__tmp955666
               (##structure-ref _date110629_ '6 std/srfi/19#date::t '#f))
              (__tmp955665
               (##structure-ref _date110629_ '7 std/srfi/19#date::t '#f)))
          (declare (not safe))
          (std/srfi/19#tm:week-day __tmp955667 __tmp955666 __tmp955665))))
    (define std/srfi/19#tm:days-before-first-week
      (lambda (_date110621_ _day-of-week-starting-week110622_)
        (let* ((_first-day110624_
                (let ((__tmp955668
                       (##structure-ref
                        _date110621_
                        '7
                        std/srfi/19#date::t
                        '#f)))
                  (declare (not safe))
                  (##structure
                   std/srfi/19#date::t
                   '0
                   '0
                   '0
                   '0
                   '1
                   '1
                   __tmp955668
                   '#f)))
               (_fdweek-day110626_
                (let ()
                  (declare (not safe))
                  (std/srfi/19#date-week-day _first-day110624_))))
          (modulo (- _day-of-week-starting-week110622_ _fdweek-day110626_)
                  '7))))
    (define std/srfi/19#date-week-number
      (lambda (_date110618_ _day-of-week-starting-week110619_)
        (quotient
         (- (let ()
              (declare (not safe))
              (std/srfi/19#date-year-day _date110618_))
            (let ()
              (declare (not safe))
              (std/srfi/19#tm:days-before-first-week
               _date110618_
               _day-of-week-starting-week110619_)))
         '7)))
    (define std/srfi/19#current-date
      (lambda _tz-offset110613_
        (let ((__tmp955671
               (let ()
                 (declare (not safe))
                 (std/srfi/19#current-time std/srfi/19#time-utc)))
              (__tmp955669
               (let ((_maybe-arg110615_ _tz-offset110613_))
                 (if (let () (declare (not safe)) (null? _maybe-arg110615_))
                     (let ()
                       (declare (not safe))
                       (std/srfi/19#tm:local-tz-offset))
                     (if (let ((__tmp955670 (cdr _maybe-arg110615_)))
                           (declare (not safe))
                           (null? __tmp955670))
                         (car _maybe-arg110615_)
                         (let ()
                           (declare (not safe))
                           (error '"too many optional arguments"
                                  _maybe-arg110615_)))))))
          (declare (not safe))
          (std/srfi/19#time-utc->date __tmp955671 __tmp955669))))
    (define std/srfi/19#tm:natural-year
      (lambda (_n110606_)
        (let* ((_current-year110608_
                (##structure-ref
                 (let () (declare (not safe)) (std/srfi/19#current-date))
                 '7
                 std/srfi/19#date::t
                 '#f))
               (_current-century110610_
                (* (quotient _current-year110608_ '100) '100)))
          (if (>= _n110606_ '100)
              _n110606_
              (if (< _n110606_ '0)
                  _n110606_
                  (if (<= (- (+ _current-century110610_ _n110606_)
                             _current-year110608_)
                          '50)
                      (+ _current-century110610_ _n110606_)
                      (+ (- _current-century110610_ '100) _n110606_)))))))
    (define std/srfi/19#date->julian-day
      (lambda (_date110595_)
        (let ((_nanosecond110597_
               (##structure-ref _date110595_ '1 std/srfi/19#date::t '#f))
              (_second110598_
               (##structure-ref _date110595_ '2 std/srfi/19#date::t '#f))
              (_minute110599_
               (##structure-ref _date110595_ '3 std/srfi/19#date::t '#f))
              (_hour110600_
               (##structure-ref _date110595_ '4 std/srfi/19#date::t '#f))
              (_day110601_
               (##structure-ref _date110595_ '5 std/srfi/19#date::t '#f))
              (_month110602_
               (##structure-ref _date110595_ '6 std/srfi/19#date::t '#f))
              (_year110603_
               (##structure-ref _date110595_ '7 std/srfi/19#date::t '#f))
              (_offset110604_
               (##structure-ref _date110595_ '8 std/srfi/19#date::t '#f)))
          (+ (let ()
               (declare (not safe))
               (std/srfi/19#tm:encode-julian-day-number
                _day110601_
                _month110602_
                _year110603_))
             (- '1/2)
             (+ (/ (/ (+ (* _hour110600_ '60 '60)
                         (* _minute110599_ '60)
                         _second110598_
                         (/ _nanosecond110597_ std/srfi/19#tm:nano))
                      std/srfi/19#tm:sid)
                   (- _offset110604_)))))))
    (define std/srfi/19#date->modified-julian-day
      (lambda (_date110593_)
        (- (let ()
             (declare (not safe))
             (std/srfi/19#date->julian-day _date110593_))
           '4800001/2)))
    (define std/srfi/19#time-utc->julian-day
      (lambda (_time110591_)
        (if (let ((__tmp955672
                   (let ((__tmp955673
                          (##structure-ref
                           _time110591_
                           '1
                           std/srfi/19#time::t
                           '#f)))
                     (declare (not safe))
                     (eq? __tmp955673 std/srfi/19#time-utc))))
              (declare (not safe))
              (not __tmp955672))
            (let ()
              (declare (not safe))
              (std/srfi/19#tm:time-error
               'time-utc->julian-day
               'incompatible-time-types
               _time110591_))
            '#!void)
        (+ (/ (+ (##structure-ref _time110591_ '3 std/srfi/19#time::t '#f)
                 (/ (##structure-ref _time110591_ '2 std/srfi/19#time::t '#f)
                    std/srfi/19#tm:nano))
              std/srfi/19#tm:sid)
           std/srfi/19#tm:tai-epoch-in-jd)))
    (define std/srfi/19#time-utc->modified-julian-day
      (lambda (_time110589_)
        (- (let ()
             (declare (not safe))
             (std/srfi/19#time-utc->julian-day _time110589_))
           '4800001/2)))
    (define std/srfi/19#time-tai->julian-day
      (lambda (_time110587_)
        (if (let ((__tmp955674
                   (let ((__tmp955675
                          (##structure-ref
                           _time110587_
                           '1
                           std/srfi/19#time::t
                           '#f)))
                     (declare (not safe))
                     (eq? __tmp955675 std/srfi/19#time-tai))))
              (declare (not safe))
              (not __tmp955674))
            (let ()
              (declare (not safe))
              (std/srfi/19#tm:time-error
               'time-tai->julian-day
               'incompatible-time-types
               _time110587_))
            '#!void)
        (+ (/ (+ (- (##structure-ref _time110587_ '3 std/srfi/19#time::t '#f)
                    (let ((__tmp955676
                           (##structure-ref
                            _time110587_
                            '3
                            std/srfi/19#time::t
                            '#f)))
                      (declare (not safe))
                      (std/srfi/19#tm:leap-second-delta __tmp955676)))
                 (/ (##structure-ref _time110587_ '2 std/srfi/19#time::t '#f)
                    std/srfi/19#tm:nano))
              std/srfi/19#tm:sid)
           std/srfi/19#tm:tai-epoch-in-jd)))
    (define std/srfi/19#time-tai->modified-julian-day
      (lambda (_time110585_)
        (- (let ()
             (declare (not safe))
             (std/srfi/19#time-tai->julian-day _time110585_))
           '4800001/2)))
    (define std/srfi/19#time-monotonic->julian-day
      (lambda (_time110583_)
        (if (let ((__tmp955677
                   (let ((__tmp955678
                          (##structure-ref
                           _time110583_
                           '1
                           std/srfi/19#time::t
                           '#f)))
                     (declare (not safe))
                     (eq? __tmp955678 std/srfi/19#time-monotonic))))
              (declare (not safe))
              (not __tmp955677))
            (let ()
              (declare (not safe))
              (std/srfi/19#tm:time-error
               'time-monotonic->julian-day
               'incompatible-time-types
               _time110583_))
            '#!void)
        (+ (/ (+ (- (##structure-ref _time110583_ '3 std/srfi/19#time::t '#f)
                    (let ((__tmp955679
                           (##structure-ref
                            _time110583_
                            '3
                            std/srfi/19#time::t
                            '#f)))
                      (declare (not safe))
                      (std/srfi/19#tm:leap-second-delta __tmp955679)))
                 (/ (##structure-ref _time110583_ '2 std/srfi/19#time::t '#f)
                    std/srfi/19#tm:nano))
              std/srfi/19#tm:sid)
           std/srfi/19#tm:tai-epoch-in-jd)))
    (define std/srfi/19#time-monotonic->modified-julian-day
      (lambda (_time110581_)
        (- (let ()
             (declare (not safe))
             (std/srfi/19#time-monotonic->julian-day _time110581_))
           '4800001/2)))
    (define std/srfi/19#julian-day->time-utc
      (lambda (_jdn110577_)
        (let ((_nanosecs110579_
               (* std/srfi/19#tm:nano
                  std/srfi/19#tm:sid
                  (- _jdn110577_ std/srfi/19#tm:tai-epoch-in-jd))))
          (let ((__tmp955681 (remainder _nanosecs110579_ std/srfi/19#tm:nano))
                (__tmp955680 (floor (/ _nanosecs110579_ std/srfi/19#tm:nano))))
            (declare (not safe))
            (##structure
             std/srfi/19#time::t
             std/srfi/19#time-utc
             __tmp955681
             __tmp955680)))))
    (define std/srfi/19#julian-day->time-tai
      (lambda (_jdn110575_)
        (let ((__tmp955682
               (let ()
                 (declare (not safe))
                 (std/srfi/19#julian-day->time-utc _jdn110575_))))
          (declare (not safe))
          (std/srfi/19#time-utc->time-tai! __tmp955682))))
    (define std/srfi/19#julian-day->time-monotonic
      (lambda (_jdn110573_)
        (let ((__tmp955683
               (let ()
                 (declare (not safe))
                 (std/srfi/19#julian-day->time-utc _jdn110573_))))
          (declare (not safe))
          (std/srfi/19#time-utc->time-monotonic! __tmp955683))))
    (define std/srfi/19#julian-day->date
      (lambda (_jdn110565_ . _tz-offset110566_)
        (let* ((_offset110571_
                (let ((_maybe-arg110568_ _tz-offset110566_))
                  (if (let () (declare (not safe)) (null? _maybe-arg110568_))
                      (let ()
                        (declare (not safe))
                        (std/srfi/19#tm:local-tz-offset))
                      (if (let ((__tmp955684 (cdr _maybe-arg110568_)))
                            (declare (not safe))
                            (null? __tmp955684))
                          (car _maybe-arg110568_)
                          (let ()
                            (declare (not safe))
                            (error '"too many optional arguments"
                                   _maybe-arg110568_))))))
               (__tmp955685
                (let ()
                  (declare (not safe))
                  (std/srfi/19#julian-day->time-utc _jdn110565_))))
          (declare (not safe))
          (std/srfi/19#time-utc->date __tmp955685 _offset110571_))))
    (define std/srfi/19#modified-julian-day->date
      (lambda (_jdn110557_ . _tz-offset110558_)
        (let* ((_offset110563_
                (let ((_maybe-arg110560_ _tz-offset110558_))
                  (if (let () (declare (not safe)) (null? _maybe-arg110560_))
                      (let ()
                        (declare (not safe))
                        (std/srfi/19#tm:local-tz-offset))
                      (if (let ((__tmp955686 (cdr _maybe-arg110560_)))
                            (declare (not safe))
                            (null? __tmp955686))
                          (car _maybe-arg110560_)
                          (let ()
                            (declare (not safe))
                            (error '"too many optional arguments"
                                   _maybe-arg110560_))))))
               (__tmp955687 (+ _jdn110557_ '4800001/2)))
          (declare (not safe))
          (std/srfi/19#julian-day->date __tmp955687 _offset110563_))))
    (define std/srfi/19#modified-julian-day->time-utc
      (lambda (_jdn110555_)
        (let ((__tmp955688 (+ _jdn110555_ '4800001/2)))
          (declare (not safe))
          (std/srfi/19#julian-day->time-utc __tmp955688))))
    (define std/srfi/19#modified-julian-day->time-tai
      (lambda (_jdn110553_)
        (let ((__tmp955689 (+ _jdn110553_ '4800001/2)))
          (declare (not safe))
          (std/srfi/19#julian-day->time-tai __tmp955689))))
    (define std/srfi/19#modified-julian-day->time-monotonic
      (lambda (_jdn110551_)
        (let ((__tmp955690 (+ _jdn110551_ '4800001/2)))
          (declare (not safe))
          (std/srfi/19#julian-day->time-monotonic __tmp955690))))
    (define std/srfi/19#current-julian-day
      (lambda ()
        (let ((__tmp955691
               (let ()
                 (declare (not safe))
                 (std/srfi/19#current-time std/srfi/19#time-utc))))
          (declare (not safe))
          (std/srfi/19#time-utc->julian-day __tmp955691))))
    (define std/srfi/19#current-modified-julian-day
      (lambda ()
        (let ((__tmp955692
               (let ()
                 (declare (not safe))
                 (std/srfi/19#current-time std/srfi/19#time-utc))))
          (declare (not safe))
          (std/srfi/19#time-utc->modified-julian-day __tmp955692))))
    (define std/srfi/19#tm:padding
      (lambda (_n110527_ _pad-with110528_ _length110529_)
        (let* ((_str110531_ (number->string _n110527_))
               (_str-len110533_ (string-length _str110531_)))
          (if (or (> _str-len110533_ _length110529_)
                  (let () (declare (not safe)) (not _pad-with110528_)))
              _str110531_
              (let* ((_new-str110539_
                      (make-string _length110529_ _pad-with110528_))
                     (_new-str-offset110541_
                      (- (string-length _new-str110539_) _str-len110533_)))
                (let _$loop110544_ ((_i110547_ '0))
                  (if (>= _i110547_ (string-length _str110531_))
                      '#!void
                      (begin
                        (string-set!
                         _new-str110539_
                         (+ _new-str-offset110541_ _i110547_)
                         (string-ref _str110531_ _i110547_))
                        (let ((__tmp955693 (+ _i110547_ '1)))
                          (declare (not safe))
                          (_$loop110544_ __tmp955693)))))
                _new-str110539_)))))
    (define std/srfi/19#tm:last-n-digits
      (lambda (_i110524_ _n110525_)
        (abs (remainder _i110524_ (expt '10 _n110525_)))))
    (define std/srfi/19#tm:locale-abbr-weekday
      (lambda (_n110522_)
        (vector-ref std/srfi/19#tm:locale-abbr-weekday-vector _n110522_)))
    (define std/srfi/19#tm:locale-long-weekday
      (lambda (_n110520_)
        (vector-ref std/srfi/19#tm:locale-long-weekday-vector _n110520_)))
    (define std/srfi/19#tm:locale-abbr-month
      (lambda (_n110518_)
        (vector-ref std/srfi/19#tm:locale-abbr-month-vector _n110518_)))
    (define std/srfi/19#tm:locale-long-month
      (lambda (_n110516_)
        (vector-ref std/srfi/19#tm:locale-long-month-vector _n110516_)))
    (define std/srfi/19#tm:vector-find
      (lambda (_needle110506_ _haystack110507_ _comparator110508_)
        (let ((_len110510_ (vector-length _haystack110507_)))
          (letrec ((_tm:vector-find-int110512_
                    (lambda (_index110514_)
                      (if (>= _index110514_ _len110510_)
                          '#f
                          (if (_comparator110508_
                               _needle110506_
                               (vector-ref _haystack110507_ _index110514_))
                              _index110514_
                              (let ((__tmp955694 (+ _index110514_ '1)))
                                (declare (not safe))
                                (_tm:vector-find-int110512_ __tmp955694)))))))
            (let () (declare (not safe)) (_tm:vector-find-int110512_ '0))))))
    (define std/srfi/19#tm:locale-abbr-weekday->index
      (lambda (_string110504_)
        (let ()
          (declare (not safe))
          (std/srfi/19#tm:vector-find
           _string110504_
           std/srfi/19#tm:locale-abbr-weekday-vector
           string=?))))
    (define std/srfi/19#tm:locale-long-weekday->index
      (lambda (_string110502_)
        (let ()
          (declare (not safe))
          (std/srfi/19#tm:vector-find
           _string110502_
           std/srfi/19#tm:locale-long-weekday-vector
           string=?))))
    (define std/srfi/19#tm:locale-abbr-month->index
      (lambda (_string110500_)
        (let ()
          (declare (not safe))
          (std/srfi/19#tm:vector-find
           _string110500_
           std/srfi/19#tm:locale-abbr-month-vector
           string=?))))
    (define std/srfi/19#tm:locale-long-month->index
      (lambda (_string110498_)
        (let ()
          (declare (not safe))
          (std/srfi/19#tm:vector-find
           _string110498_
           std/srfi/19#tm:locale-long-month-vector
           string=?))))
    (define std/srfi/19#tm:locale-print-time-zone
      (lambda (_date110495_ _port110496_) '#!void))
    (define std/srfi/19#tm:locale-am/pm
      (lambda (_hr110493_)
        (if (> _hr110493_ '11)
            std/srfi/19#tm:locale-pm
            std/srfi/19#tm:locale-am)))
    (define std/srfi/19#tm:tz-printer
      (lambda (_offset110487_ _port110488_)
        (if (= _offset110487_ '0)
            (display '"Z" _port110488_)
            (if (let () (declare (not safe)) (negative? _offset110487_))
                (display '"-" _port110488_)
                (display '"+" _port110488_)))
        (if (let ((__tmp955695 (= _offset110487_ '0)))
              (declare (not safe))
              (not __tmp955695))
            (let ((_hours110490_ (abs (quotient _offset110487_ (* '60 '60))))
                  (_minutes110491_
                   (abs (quotient
                         (remainder _offset110487_ (* '60 '60))
                         '60))))
              (display (let ()
                         (declare (not safe))
                         (std/srfi/19#tm:padding _hours110490_ '#\0 '2))
                       _port110488_)
              (display (let ()
                         (declare (not safe))
                         (std/srfi/19#tm:padding _minutes110491_ '#\0 '2))
                       _port110488_))
            '#!void)))
    (define std/srfi/19#tm:directives
      (list (let ((__tmp955696
                   (lambda (_date110314_ _pad-with110315_ _port110316_)
                     (display '#\~ _port110316_))))
              (declare (not safe))
              (cons '#\~ __tmp955696))
            (let ((__tmp955697
                   (lambda (_date110318_ _pad-with110319_ _port110320_)
                     (display (let ((__tmp955698
                                     (let ()
                                       (declare (not safe))
                                       (std/srfi/19#date-week-day
                                        _date110318_))))
                                (declare (not safe))
                                (std/srfi/19#tm:locale-abbr-weekday
                                 __tmp955698))
                              _port110320_))))
              (declare (not safe))
              (cons '#\a __tmp955697))
            (let ((__tmp955699
                   (lambda (_date110322_ _pad-with110323_ _port110324_)
                     (display (let ((__tmp955700
                                     (let ()
                                       (declare (not safe))
                                       (std/srfi/19#date-week-day
                                        _date110322_))))
                                (declare (not safe))
                                (std/srfi/19#tm:locale-long-weekday
                                 __tmp955700))
                              _port110324_))))
              (declare (not safe))
              (cons '#\A __tmp955699))
            (let ((__tmp955701
                   (lambda (_date110326_ _pad-with110327_ _port110328_)
                     (display (let ((__tmp955702
                                     (##structure-ref
                                      _date110326_
                                      '6
                                      std/srfi/19#date::t
                                      '#f)))
                                (declare (not safe))
                                (std/srfi/19#tm:locale-abbr-month __tmp955702))
                              _port110328_))))
              (declare (not safe))
              (cons '#\b __tmp955701))
            (let ((__tmp955703
                   (lambda (_date110330_ _pad-with110331_ _port110332_)
                     (display (let ((__tmp955704
                                     (##structure-ref
                                      _date110330_
                                      '6
                                      std/srfi/19#date::t
                                      '#f)))
                                (declare (not safe))
                                (std/srfi/19#tm:locale-long-month __tmp955704))
                              _port110332_))))
              (declare (not safe))
              (cons '#\B __tmp955703))
            (let ((__tmp955705
                   (lambda (_date110334_ _pad-with110335_ _port110336_)
                     (display (let ()
                                (declare (not safe))
                                (std/srfi/19#date->string
                                 _date110334_
                                 std/srfi/19#tm:locale-date-time-format))
                              _port110336_))))
              (declare (not safe))
              (cons '#\c __tmp955705))
            (let ((__tmp955706
                   (lambda (_date110338_ _pad-with110339_ _port110340_)
                     (display (let ((__tmp955707
                                     (##structure-ref
                                      _date110338_
                                      '5
                                      std/srfi/19#date::t
                                      '#f)))
                                (declare (not safe))
                                (std/srfi/19#tm:padding __tmp955707 '#\0 '2))
                              _port110340_))))
              (declare (not safe))
              (cons '#\d __tmp955706))
            (let ((__tmp955708
                   (lambda (_date110342_ _pad-with110343_ _port110344_)
                     (display (let ()
                                (declare (not safe))
                                (std/srfi/19#date->string
                                 _date110342_
                                 '"~m/~d/~y"))
                              _port110344_))))
              (declare (not safe))
              (cons '#\D __tmp955708))
            (let ((__tmp955709
                   (lambda (_date110346_ _pad-with110347_ _port110348_)
                     (display (let ((__tmp955710
                                     (##structure-ref
                                      _date110346_
                                      '5
                                      std/srfi/19#date::t
                                      '#f)))
                                (declare (not safe))
                                (std/srfi/19#tm:padding
                                 __tmp955710
                                 '#\space
                                 '2))
                              _port110348_))))
              (declare (not safe))
              (cons '#\e __tmp955709))
            (let ((__tmp955711
                   (lambda (_date110350_ _pad-with110351_ _port110352_)
                     (if (> (##structure-ref
                             _date110350_
                             '1
                             std/srfi/19#date::t
                             '#f)
                            std/srfi/19#tm:nano)
                         (display (let ((__tmp955713
                                         (+ (##structure-ref
                                             _date110350_
                                             '2
                                             std/srfi/19#date::t
                                             '#f)
                                            '1)))
                                    (declare (not safe))
                                    (std/srfi/19#tm:padding
                                     __tmp955713
                                     _pad-with110351_
                                     '2))
                                  _port110352_)
                         (display (let ((__tmp955712
                                         (##structure-ref
                                          _date110350_
                                          '2
                                          std/srfi/19#date::t
                                          '#f)))
                                    (declare (not safe))
                                    (std/srfi/19#tm:padding
                                     __tmp955712
                                     _pad-with110351_
                                     '2))
                                  _port110352_))
                     (let* ((_ns110354_
                             (let ((__tmp955714
                                    (/ (##structure-ref
                                        _date110350_
                                        '1
                                        std/srfi/19#date::t
                                        '#f)
                                       std/srfi/19#tm:nano
                                       '1.)))
                               (declare (not safe))
                               (std/srfi/19#tm:fractional-part __tmp955714)))
                            (_le110356_ (string-length _ns110354_)))
                       (if (> _le110356_ '2)
                           (begin
                             (display std/srfi/19#tm:locale-number-separator
                                      _port110352_)
                             (display (substring _ns110354_ '2 _le110356_)
                                      _port110352_))
                           '#!void)))))
              (declare (not safe))
              (cons '#\f __tmp955711))
            (let ((__tmp955715
                   (lambda (_date110359_ _pad-with110360_ _port110361_)
                     (display (let ()
                                (declare (not safe))
                                (std/srfi/19#date->string _date110359_ '"~b"))
                              _port110361_))))
              (declare (not safe))
              (cons '#\h __tmp955715))
            (let ((__tmp955716
                   (lambda (_date110363_ _pad-with110364_ _port110365_)
                     (display (let ((__tmp955717
                                     (##structure-ref
                                      _date110363_
                                      '4
                                      std/srfi/19#date::t
                                      '#f)))
                                (declare (not safe))
                                (std/srfi/19#tm:padding
                                 __tmp955717
                                 _pad-with110364_
                                 '2))
                              _port110365_))))
              (declare (not safe))
              (cons '#\H __tmp955716))
            (let ((__tmp955718
                   (lambda (_date110367_ _pad-with110368_ _port110369_)
                     (let ((_hr110371_
                            (##structure-ref
                             _date110367_
                             '4
                             std/srfi/19#date::t
                             '#f)))
                       (if (> _hr110371_ '12)
                           (display (let ((__tmp955719 (- _hr110371_ '12)))
                                      (declare (not safe))
                                      (std/srfi/19#tm:padding
                                       __tmp955719
                                       _pad-with110368_
                                       '2))
                                    _port110369_)
                           (display (let ()
                                      (declare (not safe))
                                      (std/srfi/19#tm:padding
                                       _hr110371_
                                       _pad-with110368_
                                       '2))
                                    _port110369_))))))
              (declare (not safe))
              (cons '#\I __tmp955718))
            (let ((__tmp955720
                   (lambda (_date110373_ _pad-with110374_ _port110375_)
                     (display (let ((__tmp955721
                                     (let ()
                                       (declare (not safe))
                                       (std/srfi/19#date-year-day
                                        _date110373_))))
                                (declare (not safe))
                                (std/srfi/19#tm:padding
                                 __tmp955721
                                 _pad-with110374_
                                 '3))
                              _port110375_))))
              (declare (not safe))
              (cons '#\j __tmp955720))
            (let ((__tmp955722
                   (lambda (_date110377_ _pad-with110378_ _port110379_)
                     (display (let ((__tmp955723
                                     (##structure-ref
                                      _date110377_
                                      '4
                                      std/srfi/19#date::t
                                      '#f)))
                                (declare (not safe))
                                (std/srfi/19#tm:padding __tmp955723 '#\0 '2))
                              _port110379_))))
              (declare (not safe))
              (cons '#\k __tmp955722))
            (let ((__tmp955724
                   (lambda (_date110381_ _pad-with110382_ _port110383_)
                     (let ((_hr110385_
                            (if (> (##structure-ref
                                    _date110381_
                                    '4
                                    std/srfi/19#date::t
                                    '#f)
                                   '12)
                                (- (##structure-ref
                                    _date110381_
                                    '4
                                    std/srfi/19#date::t
                                    '#f)
                                   '12)
                                (##structure-ref
                                 _date110381_
                                 '4
                                 std/srfi/19#date::t
                                 '#f))))
                       (display (let ()
                                  (declare (not safe))
                                  (std/srfi/19#tm:padding
                                   _hr110385_
                                   '#\space
                                   '2))
                                _port110383_)))))
              (declare (not safe))
              (cons '#\l __tmp955724))
            (let ((__tmp955725
                   (lambda (_date110387_ _pad-with110388_ _port110389_)
                     (display (let ((__tmp955726
                                     (##structure-ref
                                      _date110387_
                                      '6
                                      std/srfi/19#date::t
                                      '#f)))
                                (declare (not safe))
                                (std/srfi/19#tm:padding
                                 __tmp955726
                                 _pad-with110388_
                                 '2))
                              _port110389_))))
              (declare (not safe))
              (cons '#\m __tmp955725))
            (let ((__tmp955727
                   (lambda (_date110391_ _pad-with110392_ _port110393_)
                     (display (let ((__tmp955728
                                     (##structure-ref
                                      _date110391_
                                      '3
                                      std/srfi/19#date::t
                                      '#f)))
                                (declare (not safe))
                                (std/srfi/19#tm:padding
                                 __tmp955728
                                 _pad-with110392_
                                 '2))
                              _port110393_))))
              (declare (not safe))
              (cons '#\M __tmp955727))
            (let ((__tmp955729
                   (lambda (_date110395_ _pad-with110396_ _port110397_)
                     (newline _port110397_))))
              (declare (not safe))
              (cons '#\n __tmp955729))
            (let ((__tmp955730
                   (lambda (_date110399_ _pad-with110400_ _port110401_)
                     (display (let ((__tmp955731
                                     (##structure-ref
                                      _date110399_
                                      '1
                                      std/srfi/19#date::t
                                      '#f)))
                                (declare (not safe))
                                (std/srfi/19#tm:padding
                                 __tmp955731
                                 _pad-with110400_
                                 '9))
                              _port110401_))))
              (declare (not safe))
              (cons '#\N __tmp955730))
            (let ((__tmp955732
                   (lambda (_date110403_ _pad-with110404_ _port110405_)
                     (display (let ((__tmp955733
                                     (##structure-ref
                                      _date110403_
                                      '4
                                      std/srfi/19#date::t
                                      '#f)))
                                (declare (not safe))
                                (std/srfi/19#tm:locale-am/pm __tmp955733))
                              _port110405_))))
              (declare (not safe))
              (cons '#\p __tmp955732))
            (let ((__tmp955734
                   (lambda (_date110407_ _pad-with110408_ _port110409_)
                     (display (let ()
                                (declare (not safe))
                                (std/srfi/19#date->string
                                 _date110407_
                                 '"~I:~M:~S ~p"))
                              _port110409_))))
              (declare (not safe))
              (cons '#\r __tmp955734))
            (let ((__tmp955735
                   (lambda (_date110411_ _pad-with110412_ _port110413_)
                     (display (##structure-ref
                               (let ()
                                 (declare (not safe))
                                 (std/srfi/19#date->time-utc _date110411_))
                               '3
                               std/srfi/19#time::t
                               '#f)
                              _port110413_))))
              (declare (not safe))
              (cons '#\s __tmp955735))
            (let ((__tmp955736
                   (lambda (_date110415_ _pad-with110416_ _port110417_)
                     (if (> (##structure-ref
                             _date110415_
                             '1
                             std/srfi/19#date::t
                             '#f)
                            std/srfi/19#tm:nano)
                         (display (let ((__tmp955738
                                         (+ (##structure-ref
                                             _date110415_
                                             '2
                                             std/srfi/19#date::t
                                             '#f)
                                            '1)))
                                    (declare (not safe))
                                    (std/srfi/19#tm:padding
                                     __tmp955738
                                     _pad-with110416_
                                     '2))
                                  _port110417_)
                         (display (let ((__tmp955737
                                         (##structure-ref
                                          _date110415_
                                          '2
                                          std/srfi/19#date::t
                                          '#f)))
                                    (declare (not safe))
                                    (std/srfi/19#tm:padding
                                     __tmp955737
                                     _pad-with110416_
                                     '2))
                                  _port110417_)))))
              (declare (not safe))
              (cons '#\S __tmp955736))
            (let ((__tmp955739
                   (lambda (_date110419_ _pad-with110420_ _port110421_)
                     (display (integer->char '9) _port110421_))))
              (declare (not safe))
              (cons '#\t __tmp955739))
            (let ((__tmp955740
                   (lambda (_date110423_ _pad-with110424_ _port110425_)
                     (display (let ()
                                (declare (not safe))
                                (std/srfi/19#date->string
                                 _date110423_
                                 '"~H:~M:~S"))
                              _port110425_))))
              (declare (not safe))
              (cons '#\T __tmp955740))
            (let ((__tmp955741
                   (lambda (_date110427_ _pad-with110428_ _port110429_)
                     (if (> (let ()
                              (declare (not safe))
                              (std/srfi/19#tm:days-before-first-week
                               _date110427_
                               '0))
                            '0)
                         (display (let ((__tmp955743
                                         (+ (let ()
                                              (declare (not safe))
                                              (std/srfi/19#date-week-number
                                               _date110427_
                                               '0))
                                            '1)))
                                    (declare (not safe))
                                    (std/srfi/19#tm:padding
                                     __tmp955743
                                     '#\0
                                     '2))
                                  _port110429_)
                         (display (let ((__tmp955742
                                         (let ()
                                           (declare (not safe))
                                           (std/srfi/19#date-week-number
                                            _date110427_
                                            '0))))
                                    (declare (not safe))
                                    (std/srfi/19#tm:padding
                                     __tmp955742
                                     '#\0
                                     '2))
                                  _port110429_)))))
              (declare (not safe))
              (cons '#\U __tmp955741))
            (let ((__tmp955744
                   (lambda (_date110431_ _pad-with110432_ _port110433_)
                     (display (let ((__tmp955745
                                     (let ()
                                       (declare (not safe))
                                       (std/srfi/19#date-week-number
                                        _date110431_
                                        '1))))
                                (declare (not safe))
                                (std/srfi/19#tm:padding __tmp955745 '#\0 '2))
                              _port110433_))))
              (declare (not safe))
              (cons '#\V __tmp955744))
            (let ((__tmp955746
                   (lambda (_date110435_ _pad-with110436_ _port110437_)
                     (display (let ()
                                (declare (not safe))
                                (std/srfi/19#date-week-day _date110435_))
                              _port110437_))))
              (declare (not safe))
              (cons '#\w __tmp955746))
            (let ((__tmp955747
                   (lambda (_date110439_ _pad-with110440_ _port110441_)
                     (display (let ()
                                (declare (not safe))
                                (std/srfi/19#date->string
                                 _date110439_
                                 std/srfi/19#tm:locale-short-date-format))
                              _port110441_))))
              (declare (not safe))
              (cons '#\x __tmp955747))
            (let ((__tmp955748
                   (lambda (_date110443_ _pad-with110444_ _port110445_)
                     (display (let ()
                                (declare (not safe))
                                (std/srfi/19#date->string
                                 _date110443_
                                 std/srfi/19#tm:locale-time-format))
                              _port110445_))))
              (declare (not safe))
              (cons '#\X __tmp955748))
            (let ((__tmp955749
                   (lambda (_date110447_ _pad-with110448_ _port110449_)
                     (if (> (let ()
                              (declare (not safe))
                              (std/srfi/19#tm:days-before-first-week
                               _date110447_
                               '1))
                            '0)
                         (display (let ((__tmp955751
                                         (+ (let ()
                                              (declare (not safe))
                                              (std/srfi/19#date-week-number
                                               _date110447_
                                               '1))
                                            '1)))
                                    (declare (not safe))
                                    (std/srfi/19#tm:padding
                                     __tmp955751
                                     '#\0
                                     '2))
                                  _port110449_)
                         (display (let ((__tmp955750
                                         (let ()
                                           (declare (not safe))
                                           (std/srfi/19#date-week-number
                                            _date110447_
                                            '1))))
                                    (declare (not safe))
                                    (std/srfi/19#tm:padding
                                     __tmp955750
                                     '#\0
                                     '2))
                                  _port110449_)))))
              (declare (not safe))
              (cons '#\W __tmp955749))
            (let ((__tmp955752
                   (lambda (_date110451_ _pad-with110452_ _port110453_)
                     (display (let ((__tmp955753
                                     (let ((__tmp955754
                                            (##structure-ref
                                             _date110451_
                                             '7
                                             std/srfi/19#date::t
                                             '#f)))
                                       (declare (not safe))
                                       (std/srfi/19#tm:last-n-digits
                                        __tmp955754
                                        '2))))
                                (declare (not safe))
                                (std/srfi/19#tm:padding
                                 __tmp955753
                                 _pad-with110452_
                                 '2))
                              _port110453_))))
              (declare (not safe))
              (cons '#\y __tmp955752))
            (let ((__tmp955755
                   (lambda (_date110455_ _pad-with110456_ _port110457_)
                     (display (##structure-ref
                               _date110455_
                               '7
                               std/srfi/19#date::t
                               '#f)
                              _port110457_))))
              (declare (not safe))
              (cons '#\Y __tmp955755))
            (let ((__tmp955756
                   (lambda (_date110459_ _pad-with110460_ _port110461_)
                     (let ((__tmp955757
                            (##structure-ref
                             _date110459_
                             '8
                             std/srfi/19#date::t
                             '#f)))
                       (declare (not safe))
                       (std/srfi/19#tm:tz-printer __tmp955757 _port110461_)))))
              (declare (not safe))
              (cons '#\z __tmp955756))
            (let ((__tmp955758
                   (lambda (_date110463_ _pad-with110464_ _port110465_)
                     (let ()
                       (declare (not safe))
                       (std/srfi/19#tm:locale-print-time-zone
                        _date110463_
                        _port110465_)))))
              (declare (not safe))
              (cons '#\Z __tmp955758))
            (let ((__tmp955759
                   (lambda (_date110467_ _pad-with110468_ _port110469_)
                     (display (let ()
                                (declare (not safe))
                                (std/srfi/19#date->string
                                 _date110467_
                                 '"~Y-~m-~d"))
                              _port110469_))))
              (declare (not safe))
              (cons '#\1 __tmp955759))
            (let ((__tmp955760
                   (lambda (_date110471_ _pad-with110472_ _port110473_)
                     (display (let ()
                                (declare (not safe))
                                (std/srfi/19#date->string
                                 _date110471_
                                 '"~k:~M:~S~z"))
                              _port110473_))))
              (declare (not safe))
              (cons '#\2 __tmp955760))
            (let ((__tmp955761
                   (lambda (_date110475_ _pad-with110476_ _port110477_)
                     (display (let ()
                                (declare (not safe))
                                (std/srfi/19#date->string
                                 _date110475_
                                 '"~k:~M:~S"))
                              _port110477_))))
              (declare (not safe))
              (cons '#\3 __tmp955761))
            (let ((__tmp955762
                   (lambda (_date110479_ _pad-with110480_ _port110481_)
                     (display (let ()
                                (declare (not safe))
                                (std/srfi/19#date->string
                                 _date110479_
                                 '"~Y-~m-~dT~k:~M:~S~z"))
                              _port110481_))))
              (declare (not safe))
              (cons '#\4 __tmp955762))
            (let ((__tmp955763
                   (lambda (_date110483_ _pad-with110484_ _port110485_)
                     (display (let ()
                                (declare (not safe))
                                (std/srfi/19#date->string
                                 _date110483_
                                 '"~Y-~m-~dT~k:~M:~S"))
                              _port110485_))))
              (declare (not safe))
              (cons '#\5 __tmp955763))))
    (define std/srfi/19#tm:get-formatter
      (lambda (_char110310_)
        (let ((_associated110312_
               (assoc _char110310_ std/srfi/19#tm:directives)))
          (if _associated110312_ (cdr _associated110312_) '#f))))
    (define std/srfi/19#tm:date-printer
      (lambda (_date110294_
               _index110295_
               _format-string110296_
               _str-len110297_
               _port110298_)
        (if (>= _index110295_ _str-len110297_)
            '#!void
            (let ((_current-char110300_
                   (string-ref _format-string110296_ _index110295_)))
              (if (let ((__tmp955771 (char=? _current-char110300_ '#\~)))
                    (declare (not safe))
                    (not __tmp955771))
                  (begin
                    (display _current-char110300_ _port110298_)
                    (let ((__tmp955770 (+ _index110295_ '1)))
                      (declare (not safe))
                      (std/srfi/19#tm:date-printer
                       _date110294_
                       __tmp955770
                       _format-string110296_
                       _str-len110297_
                       _port110298_)))
                  (if (= (+ _index110295_ '1) _str-len110297_)
                      (let ()
                        (declare (not safe))
                        (std/srfi/19#tm:time-error
                         'tm:date-printer
                         'bad-date-format-string
                         _format-string110296_))
                      (let ((_pad-char?110302_
                             (string-ref
                              _format-string110296_
                              (+ _index110295_ '1))))
                        (if (char=? _pad-char?110302_ '#\-)
                            (if (= (+ _index110295_ '2) _str-len110297_)
                                (let ()
                                  (declare (not safe))
                                  (std/srfi/19#tm:time-error
                                   'tm:date-printer
                                   'bad-date-format-string
                                   _format-string110296_))
                                (let ((_formatter110304_
                                       (let ((__tmp955768
                                              (string-ref
                                               _format-string110296_
                                               (+ _index110295_ '2))))
                                         (declare (not safe))
                                         (std/srfi/19#tm:get-formatter
                                          __tmp955768))))
                                  (if (let ()
                                        (declare (not safe))
                                        (not _formatter110304_))
                                      (let ()
                                        (declare (not safe))
                                        (std/srfi/19#tm:time-error
                                         'tm:date-printer
                                         'bad-date-format-string
                                         _format-string110296_))
                                      (begin
                                        (_formatter110304_
                                         _date110294_
                                         '#f
                                         _port110298_)
                                        (let ((__tmp955769
                                               (+ _index110295_ '3)))
                                          (declare (not safe))
                                          (std/srfi/19#tm:date-printer
                                           _date110294_
                                           __tmp955769
                                           _format-string110296_
                                           _str-len110297_
                                           _port110298_))))))
                            (if (char=? _pad-char?110302_ '#\_)
                                (if (= (+ _index110295_ '2) _str-len110297_)
                                    (let ()
                                      (declare (not safe))
                                      (std/srfi/19#tm:time-error
                                       'tm:date-printer
                                       'bad-date-format-string
                                       _format-string110296_))
                                    (let ((_formatter110306_
                                           (let ((__tmp955766
                                                  (string-ref
                                                   _format-string110296_
                                                   (+ _index110295_ '2))))
                                             (declare (not safe))
                                             (std/srfi/19#tm:get-formatter
                                              __tmp955766))))
                                      (if (let ()
                                            (declare (not safe))
                                            (not _formatter110306_))
                                          (let ()
                                            (declare (not safe))
                                            (std/srfi/19#tm:time-error
                                             'tm:date-printer
                                             'bad-date-format-string
                                             _format-string110296_))
                                          (begin
                                            (_formatter110306_
                                             _date110294_
                                             '#\space
                                             _port110298_)
                                            (let ((__tmp955767
                                                   (+ _index110295_ '3)))
                                              (declare (not safe))
                                              (std/srfi/19#tm:date-printer
                                               _date110294_
                                               __tmp955767
                                               _format-string110296_
                                               _str-len110297_
                                               _port110298_))))))
                                (let ((_formatter110308_
                                       (let ((__tmp955764
                                              (string-ref
                                               _format-string110296_
                                               (+ _index110295_ '1))))
                                         (declare (not safe))
                                         (std/srfi/19#tm:get-formatter
                                          __tmp955764))))
                                  (if (let ()
                                        (declare (not safe))
                                        (not _formatter110308_))
                                      (let ()
                                        (declare (not safe))
                                        (std/srfi/19#tm:time-error
                                         'tm:date-printer
                                         'bad-date-format-string
                                         _format-string110296_))
                                      (begin
                                        (_formatter110308_
                                         _date110294_
                                         '#\0
                                         _port110298_)
                                        (let ((__tmp955765
                                               (+ _index110295_ '2)))
                                          (declare (not safe))
                                          (std/srfi/19#tm:date-printer
                                           _date110294_
                                           __tmp955765
                                           _format-string110296_
                                           _str-len110297_
                                           _port110298_))))))))))))))
    (define std/srfi/19#date->string
      (lambda (_date110285_ . _format-string110286_)
        (let ((_str-port110291_ (open-output-string))
              (_fmt-str110292_
               (let ((_maybe-arg110288_ _format-string110286_))
                 (if (let () (declare (not safe)) (null? _maybe-arg110288_))
                     '"~c"
                     (if (let ((__tmp955772 (cdr _maybe-arg110288_)))
                           (declare (not safe))
                           (null? __tmp955772))
                         (car _maybe-arg110288_)
                         (let ()
                           (declare (not safe))
                           (error '"too many optional arguments"
                                  _maybe-arg110288_)))))))
          (let ((__tmp955773 (string-length _fmt-str110292_)))
            (declare (not safe))
            (std/srfi/19#tm:date-printer
             _date110285_
             '0
             _fmt-str110292_
             __tmp955773
             _str-port110291_))
          (get-output-string _str-port110291_))))
    (define std/srfi/19#tm:char->int
      (lambda (_ch110283_)
        (if (char=? _ch110283_ '#\0)
            '0
            (if (char=? _ch110283_ '#\1)
                '1
                (if (char=? _ch110283_ '#\2)
                    '2
                    (if (char=? _ch110283_ '#\3)
                        '3
                        (if (char=? _ch110283_ '#\4)
                            '4
                            (if (char=? _ch110283_ '#\5)
                                '5
                                (if (char=? _ch110283_ '#\6)
                                    '6
                                    (if (char=? _ch110283_ '#\7)
                                        '7
                                        (if (char=? _ch110283_ '#\8)
                                            '8
                                            (if (char=? _ch110283_ '#\9)
                                                '9
                                                (let ((__tmp955774
                                                       (list '"Non-integer character"
                                                             _ch110283_)))
                                                  (declare (not safe))
                                                  (std/srfi/19#tm:time-error
                                                   'string->date
                                                   'bad-date-template-string
                                                   __tmp955774))))))))))))))
    (define std/srfi/19#tm:integer-reader
      (lambda (_upto110266_ _port110267_)
        (letrec ((_accum-int110269_
                  (lambda (_port110271_ _accum110272_ _nchars110273_)
                    (let ((_ch110275_ (peek-char _port110271_)))
                      (if (or (let ()
                                (declare (not safe))
                                (eof-object? _ch110275_))
                              (let ((__tmp955778 (char-numeric? _ch110275_)))
                                (declare (not safe))
                                (not __tmp955778))
                              (and _upto110266_
                                   (>= _nchars110273_ _upto110266_)))
                          _accum110272_
                          (let ((__tmp955776
                                 (+ (* _accum110272_ '10)
                                    (let ((__tmp955777
                                           (read-char _port110271_)))
                                      (declare (not safe))
                                      (std/srfi/19#tm:char->int __tmp955777))))
                                (__tmp955775 (+ _nchars110273_ '1)))
                            (declare (not safe))
                            (_accum-int110269_
                             _port110271_
                             __tmp955776
                             __tmp955775)))))))
          (let ()
            (declare (not safe))
            (_accum-int110269_ _port110267_ '0 '0)))))
    (define std/srfi/19#tm:make-integer-reader
      (lambda (_upto110262_)
        (lambda (_port110264_)
          (let ()
            (declare (not safe))
            (std/srfi/19#tm:integer-reader _upto110262_ _port110264_)))))
    (define std/srfi/19#tm:fractional-integer-reader
      (lambda (_upto110245_ _port110246_)
        (letrec ((_accum-int110248_
                  (lambda (_port110250_ _accum110251_ _nchars110252_)
                    (let ((_ch110254_ (peek-char _port110250_)))
                      (if (or (let ()
                                (declare (not safe))
                                (eof-object? _ch110254_))
                              (let ((__tmp955782 (char-numeric? _ch110254_)))
                                (declare (not safe))
                                (not __tmp955782))
                              (and _upto110245_
                                   (>= _nchars110252_ _upto110245_)))
                          (* _accum110251_
                             (expt '10 (- _upto110245_ _nchars110252_)))
                          (let ((__tmp955780
                                 (+ (* _accum110251_ '10)
                                    (let ((__tmp955781
                                           (read-char _port110250_)))
                                      (declare (not safe))
                                      (std/srfi/19#tm:char->int __tmp955781))))
                                (__tmp955779 (+ _nchars110252_ '1)))
                            (declare (not safe))
                            (_accum-int110248_
                             _port110250_
                             __tmp955780
                             __tmp955779)))))))
          (let ()
            (declare (not safe))
            (_accum-int110248_ _port110246_ '0 '0)))))
    (define std/srfi/19#tm:make-fractional-integer-reader
      (lambda (_upto110241_)
        (lambda (_port110243_)
          (let ()
            (declare (not safe))
            (std/srfi/19#tm:fractional-integer-reader
             _upto110241_
             _port110243_)))))
    (define std/srfi/19#tm:integer-reader-exact
      (lambda (_n110228_ _port110229_)
        (let ((_padding-ok110231_ '#t))
          (letrec ((_accum-int110233_
                    (lambda (_port110235_ _accum110236_ _nchars110237_)
                      (let ((_ch110239_ (peek-char _port110235_)))
                        (if (>= _nchars110237_ _n110228_)
                            _accum110236_
                            (if (let ()
                                  (declare (not safe))
                                  (eof-object? _ch110239_))
                                (let ()
                                  (declare (not safe))
                                  (std/srfi/19#tm:time-error
                                   'string->date
                                   'bad-date-template-string
                                   '"Premature ending to integer read."))
                                (if (char-numeric? _ch110239_)
                                    (begin
                                      (set! _padding-ok110231_ '#f)
                                      (let ((__tmp955785
                                             (+ (* _accum110236_ '10)
                                                (let ((__tmp955786
                                                       (read-char
                                                        _port110235_)))
                                                  (declare (not safe))
                                                  (std/srfi/19#tm:char->int
                                                   __tmp955786))))
                                            (__tmp955784
                                             (+ _nchars110237_ '1)))
                                        (declare (not safe))
                                        (_accum-int110233_
                                         _port110235_
                                         __tmp955785
                                         __tmp955784)))
                                    (if _padding-ok110231_
                                        (begin
                                          (read-char _port110235_)
                                          (let ((__tmp955783
                                                 (+ _nchars110237_ '1)))
                                            (declare (not safe))
                                            (_accum-int110233_
                                             _port110235_
                                             _accum110236_
                                             __tmp955783)))
                                        (let ()
                                          (declare (not safe))
                                          (std/srfi/19#tm:time-error
                                           'string->date
                                           'bad-date-template-string
                                           '"Non-numeric characters in integer read."))))))))))
            (let ()
              (declare (not safe))
              (_accum-int110233_ _port110229_ '0 '0))))))
    (define std/srfi/19#tm:make-integer-exact-reader
      (lambda (_n110224_)
        (lambda (_port110226_)
          (let ()
            (declare (not safe))
            (std/srfi/19#tm:integer-reader-exact _n110224_ _port110226_)))))
    (define std/srfi/19#tm:zone-reader
      (lambda (_port110206_)
        (let ((_offset110208_ '0) (_positive?110209_ '#f))
          (let ((_ch110211_ (read-char _port110206_)))
            (if (let () (declare (not safe)) (eof-object? _ch110211_))
                (let ((__tmp955787 (list '"Invalid time zone +/-" _ch110211_)))
                  (declare (not safe))
                  (std/srfi/19#tm:time-error
                   'string->date
                   'bad-date-template-string
                   __tmp955787))
                '#!void)
            (if (or (char=? _ch110211_ '#\Z) (char=? _ch110211_ '#\z))
                '0
                (begin
                  (if (char=? _ch110211_ '#\+)
                      (set! _positive?110209_ '#t)
                      (if (char=? _ch110211_ '#\-)
                          (set! _positive?110209_ '#f)
                          (let ((__tmp955788
                                 (list '"Invalid time zone +/-" _ch110211_)))
                            (declare (not safe))
                            (std/srfi/19#tm:time-error
                             'string->date
                             'bad-date-template-string
                             __tmp955788))))
                  (let ((_ch110216_ (read-char _port110206_)))
                    (if (let () (declare (not safe)) (eof-object? _ch110216_))
                        (let ((__tmp955789
                               (list '"Invalid time zone number" _ch110216_)))
                          (declare (not safe))
                          (std/srfi/19#tm:time-error
                           'string->date
                           'bad-date-template-string
                           __tmp955789))
                        '#!void)
                    (set! _offset110208_
                          (* (let ()
                               (declare (not safe))
                               (std/srfi/19#tm:char->int _ch110216_))
                             '10
                             '60
                             '60)))
                  (let ((_ch110218_ (read-char _port110206_)))
                    (if (let () (declare (not safe)) (eof-object? _ch110218_))
                        (let ((__tmp955790
                               (list '"Invalid time zone number" _ch110218_)))
                          (declare (not safe))
                          (std/srfi/19#tm:time-error
                           'string->date
                           'bad-date-template-string
                           __tmp955790))
                        '#!void)
                    (set! _offset110208_
                          (+ _offset110208_
                             (* (let ()
                                  (declare (not safe))
                                  (std/srfi/19#tm:char->int _ch110218_))
                                '60
                                '60))))
                  (let ((_ch110220_ (read-char _port110206_)))
                    (if (let () (declare (not safe)) (eof-object? _ch110220_))
                        (let ((__tmp955791
                               (list '"Invalid time zone number" _ch110220_)))
                          (declare (not safe))
                          (std/srfi/19#tm:time-error
                           'string->date
                           'bad-date-template-string
                           __tmp955791))
                        '#!void)
                    (set! _offset110208_
                          (+ _offset110208_
                             (* (let ()
                                  (declare (not safe))
                                  (std/srfi/19#tm:char->int _ch110220_))
                                '10
                                '60))))
                  (let ((_ch110222_ (read-char _port110206_)))
                    (if (let () (declare (not safe)) (eof-object? _ch110222_))
                        (let ((__tmp955792
                               (list '"Invalid time zone number" _ch110222_)))
                          (declare (not safe))
                          (std/srfi/19#tm:time-error
                           'string->date
                           'bad-date-template-string
                           __tmp955792))
                        '#!void)
                    (set! _offset110208_
                          (+ _offset110208_
                             (* (let ()
                                  (declare (not safe))
                                  (std/srfi/19#tm:char->int _ch110222_))
                                '60))))
                  (if _positive?110209_
                      _offset110208_
                      (- _offset110208_))))))))
    (define std/srfi/19#tm:locale-reader
      (lambda (_port110191_ _indexer110192_)
        (let ((_string-port110194_ (open-output-string)))
          (letrec ((_read-char-string110196_
                    (lambda ()
                      (let ((_ch110204_ (peek-char _port110191_)))
                        (if (char-alphabetic? _ch110204_)
                            (begin
                              (write-char
                               (read-char _port110191_)
                               _string-port110194_)
                              (let ()
                                (declare (not safe))
                                (_read-char-string110196_)))
                            (get-output-string _string-port110194_))))))
            (let* ((_str110198_
                    (let () (declare (not safe)) (_read-char-string110196_)))
                   (_index110200_ (_indexer110192_ _str110198_)))
              (if _index110200_
                  _index110200_
                  (let ((__tmp955793
                         (list '"Invalid string for " _indexer110192_)))
                    (declare (not safe))
                    (std/srfi/19#tm:time-error
                     'string->date
                     'bad-date-template-string
                     __tmp955793))))))))
    (define std/srfi/19#tm:make-locale-reader
      (lambda (_indexer110187_)
        (lambda (_port110189_)
          (let ()
            (declare (not safe))
            (std/srfi/19#tm:locale-reader _port110189_ _indexer110187_)))))
    (define std/srfi/19#tm:make-char-id-reader
      (lambda (_char110183_)
        (lambda (_port110185_)
          (if (char=? _char110183_ (read-char _port110185_))
              _char110183_
              (let ()
                (declare (not safe))
                (std/srfi/19#tm:time-error
                 'string->date
                 'bad-date-template-string
                 '"Invalid character match."))))))
    (define std/srfi/19#tm:read-directives
      (let ((_ireader4110117_
             (let ()
               (declare (not safe))
               (std/srfi/19#tm:make-integer-reader '4)))
            (_ireader2110118_
             (let ()
               (declare (not safe))
               (std/srfi/19#tm:make-integer-reader '2)))
            (_fireader9110119_
             (let ()
               (declare (not safe))
               (std/srfi/19#tm:make-fractional-integer-reader '9)))
            (_ireaderf110120_
             (let ()
               (declare (not safe))
               (std/srfi/19#tm:make-integer-reader '#f)))
            (_eireader2110121_
             (let ()
               (declare (not safe))
               (std/srfi/19#tm:make-integer-exact-reader '2)))
            (_eireader4110122_
             (let ()
               (declare (not safe))
               (std/srfi/19#tm:make-integer-exact-reader '4)))
            (_locale-reader-abbr-weekday110123_
             (let ()
               (declare (not safe))
               (std/srfi/19#tm:make-locale-reader
                std/srfi/19#tm:locale-abbr-weekday->index)))
            (_locale-reader-long-weekday110124_
             (let ()
               (declare (not safe))
               (std/srfi/19#tm:make-locale-reader
                std/srfi/19#tm:locale-long-weekday->index)))
            (_locale-reader-abbr-month110125_
             (let ()
               (declare (not safe))
               (std/srfi/19#tm:make-locale-reader
                std/srfi/19#tm:locale-abbr-month->index)))
            (_locale-reader-long-month110126_
             (let ()
               (declare (not safe))
               (std/srfi/19#tm:make-locale-reader
                std/srfi/19#tm:locale-long-month->index)))
            (_char-fail110127_ (lambda (_ch110112_) '#t))
            (_do-nothing110128_ (lambda (_val110114_ _object110115_) '#!void)))
        (list (list '#\~
                    _char-fail110127_
                    (let ()
                      (declare (not safe))
                      (std/srfi/19#tm:make-char-id-reader '#\~))
                    _do-nothing110128_)
              (list '#\a
                    char-alphabetic?
                    _locale-reader-abbr-weekday110123_
                    _do-nothing110128_)
              (list '#\A
                    char-alphabetic?
                    _locale-reader-long-weekday110124_
                    _do-nothing110128_)
              (list '#\b
                    char-alphabetic?
                    _locale-reader-abbr-month110125_
                    (lambda (_val110130_ _object110131_)
                      (##structure-set!
                       _object110131_
                       _val110130_
                       '6
                       std/srfi/19#date::t
                       '#f)))
              (list '#\B
                    char-alphabetic?
                    _locale-reader-long-month110126_
                    (lambda (_val110133_ _object110134_)
                      (##structure-set!
                       _object110134_
                       _val110133_
                       '6
                       std/srfi/19#date::t
                       '#f)))
              (list '#\d
                    char-numeric?
                    _ireader2110118_
                    (lambda (_val110136_ _object110137_)
                      (##structure-set!
                       _object110137_
                       _val110136_
                       '5
                       std/srfi/19#date::t
                       '#f)))
              (list '#\e
                    _char-fail110127_
                    _eireader2110121_
                    (lambda (_val110139_ _object110140_)
                      (##structure-set!
                       _object110140_
                       _val110139_
                       '5
                       std/srfi/19#date::t
                       '#f)))
              (list '#\h
                    char-alphabetic?
                    _locale-reader-abbr-month110125_
                    (lambda (_val110142_ _object110143_)
                      (##structure-set!
                       _object110143_
                       _val110142_
                       '6
                       std/srfi/19#date::t
                       '#f)))
              (list '#\H
                    char-numeric?
                    _ireader2110118_
                    (lambda (_val110145_ _object110146_)
                      (##structure-set!
                       _object110146_
                       _val110145_
                       '4
                       std/srfi/19#date::t
                       '#f)))
              (list '#\k
                    _char-fail110127_
                    _eireader2110121_
                    (lambda (_val110148_ _object110149_)
                      (##structure-set!
                       _object110149_
                       _val110148_
                       '4
                       std/srfi/19#date::t
                       '#f)))
              (list '#\m
                    char-numeric?
                    _ireader2110118_
                    (lambda (_val110151_ _object110152_)
                      (##structure-set!
                       _object110152_
                       _val110151_
                       '6
                       std/srfi/19#date::t
                       '#f)))
              (list '#\M
                    char-numeric?
                    _ireader2110118_
                    (lambda (_val110154_ _object110155_)
                      (##structure-set!
                       _object110155_
                       _val110154_
                       '3
                       std/srfi/19#date::t
                       '#f)))
              (list '#\N
                    char-numeric?
                    _fireader9110119_
                    (lambda (_val110157_ _object110158_)
                      (##structure-set!
                       _object110158_
                       _val110157_
                       '1
                       std/srfi/19#date::t
                       '#f)))
              (list '#\S
                    char-numeric?
                    _ireader2110118_
                    (lambda (_val110160_ _object110161_)
                      (##structure-set!
                       _object110161_
                       _val110160_
                       '2
                       std/srfi/19#date::t
                       '#f)))
              (list '#\y
                    _char-fail110127_
                    _eireader2110121_
                    (lambda (_val110163_ _object110164_)
                      (##structure-set!
                       _object110164_
                       (let ()
                         (declare (not safe))
                         (std/srfi/19#tm:natural-year _val110163_))
                       '7
                       std/srfi/19#date::t
                       '#f)))
              (list '#\Y
                    char-numeric?
                    _ireader4110117_
                    (lambda (_val110166_ _object110167_)
                      (##structure-set!
                       _object110167_
                       _val110166_
                       '7
                       std/srfi/19#date::t
                       '#f)))
              (list '#\z
                    (lambda (_c110169_)
                      (let ((_$e110171_ (char=? _c110169_ '#\Z)))
                        (if _$e110171_
                            _$e110171_
                            (let ((_$e110174_ (char=? _c110169_ '#\z)))
                              (if _$e110174_
                                  _$e110174_
                                  (let ((_$e110177_ (char=? _c110169_ '#\+)))
                                    (if _$e110177_
                                        _$e110177_
                                        (char=? _c110169_ '#\-))))))))
                    std/srfi/19#tm:zone-reader
                    (lambda (_val110180_ _object110181_)
                      (##structure-set!
                       _object110181_
                       _val110180_
                       '8
                       std/srfi/19#date::t
                       '#f))))))
    (define std/srfi/19#tm:string->date
      (lambda (_date110080_
               _index110081_
               _format-string110082_
               _str-len110083_
               _port110084_
               _template-string110085_)
        (letrec ((_skip-until110087_
                  (lambda (_port110107_ _skipper110108_)
                    (let ((_ch110110_ (peek-char _port110107_)))
                      (if (let ()
                            (declare (not safe))
                            (eof-object? _ch110110_))
                          (let ()
                            (declare (not safe))
                            (std/srfi/19#tm:time-error
                             'string->date
                             'bad-date-format-string
                             _template-string110085_))
                          (if (let ((__tmp955794 (_skipper110108_ _ch110110_)))
                                (declare (not safe))
                                (not __tmp955794))
                              (begin
                                (read-char _port110107_)
                                (let ()
                                  (declare (not safe))
                                  (_skip-until110087_
                                   _port110107_
                                   _skipper110108_)))
                              '#!void))))))
          (if (>= _index110081_ _str-len110083_)
              '#!void
              (let ((_current-char110089_
                     (string-ref _format-string110082_ _index110081_)))
                (if (let ((__tmp955798 (char=? _current-char110089_ '#\~)))
                      (declare (not safe))
                      (not __tmp955798))
                    (let ((_port-char110091_ (read-char _port110084_)))
                      (if (or (let ()
                                (declare (not safe))
                                (eof-object? _port-char110091_))
                              (let ((__tmp955796
                                     (char=? _current-char110089_
                                             _port-char110091_)))
                                (declare (not safe))
                                (not __tmp955796)))
                          (let ()
                            (declare (not safe))
                            (std/srfi/19#tm:time-error
                             'string->date
                             'bad-date-format-string
                             _template-string110085_))
                          '#!void)
                      (let ((__tmp955797 (+ _index110081_ '1)))
                        (declare (not safe))
                        (std/srfi/19#tm:string->date
                         _date110080_
                         __tmp955797
                         _format-string110082_
                         _str-len110083_
                         _port110084_
                         _template-string110085_)))
                    (if (> (+ _index110081_ '1) _str-len110083_)
                        (let ()
                          (declare (not safe))
                          (std/srfi/19#tm:time-error
                           'string->date
                           'bad-date-format-string
                           _template-string110085_))
                        (let* ((_format-char110096_
                                (string-ref
                                 _format-string110082_
                                 (+ _index110081_ '1)))
                               (_format-info110098_
                                (assoc _format-char110096_
                                       std/srfi/19#tm:read-directives)))
                          (if (let ()
                                (declare (not safe))
                                (not _format-info110098_))
                              (let ()
                                (declare (not safe))
                                (std/srfi/19#tm:time-error
                                 'string->date
                                 'bad-date-format-string
                                 _template-string110085_))
                              (let ((_skipper110101_
                                     (cadr _format-info110098_))
                                    (_reader110102_
                                     (caddr _format-info110098_))
                                    (_actor110103_
                                     (cadddr _format-info110098_)))
                                (let ()
                                  (declare (not safe))
                                  (_skip-until110087_
                                   _port110084_
                                   _skipper110101_))
                                (let ((_val110105_
                                       (_reader110102_ _port110084_)))
                                  (if (let ()
                                        (declare (not safe))
                                        (eof-object? _val110105_))
                                      (let ()
                                        (declare (not safe))
                                        (std/srfi/19#tm:time-error
                                         'string->date
                                         'bad-date-format-string
                                         _template-string110085_))
                                      (_actor110103_
                                       _val110105_
                                       _date110080_)))
                                (let ((__tmp955795 (+ _index110081_ '2)))
                                  (declare (not safe))
                                  (std/srfi/19#tm:string->date
                                   _date110080_
                                   __tmp955795
                                   _format-string110082_
                                   _str-len110083_
                                   _port110084_
                                   _template-string110085_))))))))))))
    (define std/srfi/19#string->date
      (lambda (_input-string110071_ _template-string110072_)
        (letrec ((_tm:date-ok?110074_
                  (lambda (_date110078_)
                    (if (##structure-ref
                         _date110078_
                         '1
                         std/srfi/19#date::t
                         '#f)
                        (if (##structure-ref
                             _date110078_
                             '2
                             std/srfi/19#date::t
                             '#f)
                            (if (##structure-ref
                                 _date110078_
                                 '3
                                 std/srfi/19#date::t
                                 '#f)
                                (if (##structure-ref
                                     _date110078_
                                     '4
                                     std/srfi/19#date::t
                                     '#f)
                                    (if (##structure-ref
                                         _date110078_
                                         '5
                                         std/srfi/19#date::t
                                         '#f)
                                        (if (##structure-ref
                                             _date110078_
                                             '6
                                             std/srfi/19#date::t
                                             '#f)
                                            (if (##structure-ref
                                                 _date110078_
                                                 '7
                                                 std/srfi/19#date::t
                                                 '#f)
                                                (##structure-ref
                                                 _date110078_
                                                 '8
                                                 std/srfi/19#date::t
                                                 '#f)
                                                '#f)
                                            '#f)
                                        '#f)
                                    '#f)
                                '#f)
                            '#f)
                        '#f))))
          (let ((_newdate110076_
                 (let ()
                   (declare (not safe))
                   (##structure
                    std/srfi/19#date::t
                    '0
                    '0
                    '0
                    '0
                    '#f
                    '#f
                    '#f
                    '0))))
            (let ((__tmp955800 (string-length _template-string110072_))
                  (__tmp955799 (open-input-string _input-string110071_)))
              (declare (not safe))
              (std/srfi/19#tm:string->date
               _newdate110076_
               '0
               _template-string110072_
               __tmp955800
               __tmp955799
               _template-string110072_))
            (if (let ()
                  (declare (not safe))
                  (_tm:date-ok?110074_ _newdate110076_))
                _newdate110076_
                (let ((__tmp955801
                       (list '"Incomplete date read. "
                             _newdate110076_
                             _template-string110072_)))
                  (declare (not safe))
                  (std/srfi/19#tm:time-error
                   'string->date
                   'bad-date-format-string
                   __tmp955801)))))))))
